namespace sGUI

declare function AddCloseButton (win as sGUIWindow ptr=0,PosX as integer=0,PosY as integer=0) as Gadget ptr
declare function WCB_Actions(gad as Gadget ptr,action as integer) as integer
declare sub WCB_Draw (gad as Gadget ptr)
declare sub WCB_Update (gad as _Gadget ptr)
/'
type WCB_Data
  oldWinSelection as integer
end type
'/
function AddCloseButton (win as sGUIWindow ptr=0,PosX as integer=0,PosY as integer=0) as Gadget ptr
  function=0  
  dim as Gadget ptr gad
  if win=0 then win=RootWindow
  gad=win->WinGadgetList->AppendNew (GadgetType)
  if gad then
    gad->parent=win
    gad->Selection=0
    gad->Activation=0
    gad->PosX=PosX
    gad->PosY=PosY
    gad->GadHeight=GetFontHeight + 2*sGUIMainGap
    gad->GadWidth=gad->GadHeight
    gad->DrawBuffer->img=imagecreate(gad->GadWidth,Gad->GadHeight,0,32)
    gad->DoDraw     =@WCB_Draw
    gad->DoAction   =@WCB_Actions 
    gad->DoUpdate   =@WCB_Update
    'gad->xtd.wcb.oldWinSelection=-1'garantiert ein Neuzeichnen nach Erzeugung, ist vielleicht nicht notwendig
    gad->DeviceFlags=DFLAG_LMB      
    function=gad
  end if
end function


function WCB_Actions(gad as Gadget ptr,action as integer) as integer
  function=0
  dim as integer doit=0
  dim as sGUIWindow ptr parentwin=cast(sGUIWindow ptr,gad->parent)
  select case action      
    case GADGET_LMBHIT  
      SetSelect (gad,1)      
    
    case GADGET_LMBHOLD   
      SetSelect (gad,1)      
    
    case GADGET_LMBHOLDOFF  
      SetSelect (gad,0)     
    
    case GADGET_LMBRELEASE  
      SetSelect (gad,0)
      doit=1
      function=1           
    
    case GADGET_LMBRELEASEOFF 
      SetSelect (gad,0)     
    
    case GADGET_MOUSEHOVER 
      gad->MouseHover=1
      
    case GADGET_MOUSENEXT   
      gad->MouseHover=0
      
  end select
  
  if doit then
    if parentwin<>RootWindow then
      if (parentwin->WinFlags and WFLAG_DELETEONCLOSE) then DeleteWindow(parentwin) else HideWindow(parentwin)
    else
      SCREENCLOSEBUTTON=1
    end if
  end if
end function


sub WCB_Draw (gad as Gadget ptr)
	dim as integer GadWidth,GadHeight,offset,WinSelection
  dim as FB.Image ptr Buffer
  dim as sGUIWindow ptr parentwin=cast(sGUIWindow ptr,gad->parent)
	GadWidth =gad->GadWidth-4
	GadHeight=gad->GadHeight-4   
  Buffer   =gad->DrawBuffer->img
  offset=2+(GadWidth-8)/2
  
  WinSelection=parentwin->Selection
  'WinFlag Override
  if (parentwin->WinFlags and WFLAG_APPEARSSELECTED) then WinSelection=1
  if (parentwin->WinFlags and WFLAG_APPEARSUNSELECTED) then WinSelection=0
'OFF 
  ClearBox Buffer,0,0,gad->GadWidth,gad->GadHeight,&HFF00FF
'ON   unselect/select
  if gad->Activation then
    if gad->MouseHover then
      StdFilledBoxRounded Buffer,2,2,GadWidth,GadHeight,Colors.WarnRed,Colors.WarnRed,gad->Selection,0
      Symbol_X Buffer,offset,offset,Colors.White
    else
      if WinSelection then
        StdFilledBoxRounded Buffer,2,2,GadWidth,GadHeight,Colors.WinFrame,Colors.WinFrame,gad->Selection,0
        Symbol_X Buffer,offset,offset,Colors.WinText        
      else
        StdFilledBoxRounded Buffer,2,2,GadWidth,GadHeight,Colors.WinFrameUnselected,Colors.WinFrameUnselected,gad->Selection,0      
        Symbol_X Buffer,offset,offset,Colors.WinTextUnselected      
      end if
    end if
'SLEEP
    if gad->Activation=2 then Raster Buffer,0,0,GadWidth,GadHeight
  end if    
end sub


sub WCB_Update(gad as Gadget ptr)
  if gad->xtd.wcb.oldWinSelection <> cast(sGUIWindow ptr,gad->parent)->Selection then
    gad->ReDraw=1
    gad->xtd.wcb.oldWinSelection = cast(sGUIWindow ptr,gad->parent)->Selection
  end if
end sub

end namespace
