#include once "Gadget_DataGrid_Display.bas"
#include once "Gadget_ScrollBar.bas"
#include once "Gadget_String.bas"
namespace sGUI

declare function AddDataGrid (win as sGUIWindow ptr,PosX as integer,PosY as integer,WinWidth as integer,WinHeight as integer) as any ptr
declare sub DGR_Actions(win as sGUIWindow ptr)
declare sub DGR_Update (win as sGUIWindow ptr)
'gui
declare sub DataGridUpdate(thing as any ptr, mode as integer=0)
declare sub SetScrollBars(ddisplay as Gadget ptr, vscroll as Gadget ptr=0, hscroll as Gadget ptr=0, vvalue as integer=0, hvalue as integer=0)
declare sub TraceColumn(thing as any ptr, ColumnIndx as integer)
declare sub TraceRow(thing as any ptr, RowIndx as integer) 
declare sub TraceCell(thing as any ptr, RowIndx as integer, ColumnIndx as integer)
'info
declare function GetSelectionMode(thing as any ptr) as integer
declare function GetSelectedRow(thing as any ptr) as integer
declare function GetSelectedColumn(thing as any ptr) as integer
declare function GetNumRows(thing as any ptr) as integer
declare function GetNumColumns(thing as any ptr) as integer
'config
declare sub SetViewMode(thing as any ptr)
declare sub SetCellEditMode(thing as any ptr)
declare sub SetColumnEditMode(thing as any ptr)
'edit grid
declare sub AddColumn(thing as any ptr, cname as string, cwidth as integer=80)
declare sub AddRow(thing as any ptr,numrows as integer=1)
declare sub DelColumn(thing as any ptr, ColumnIndx as integer)
declare sub DelRow(thing as any ptr, RowIndx as integer)

declare sub RowMove(thing as any ptr, RowIndx as integer, DestIndx as integer)
declare sub ColumnMove(thing as any ptr, ColumnIndx as integer, DestIndx as integer)

declare sub ClearGrid(thing as any ptr)
declare sub AutoWidth(thing as any ptr, minwidth as integer=0, maxwidth as integer=0)

'cell edit i/o
declare sub SetCell(thing as any ptr,RowIndx as integer,ColumnIndx as integer, text as string)
declare function GetCell(thing as any ptr,RowIndx as integer,ColumnIndx as integer) as string

'column edit i/o
declare sub SetColumn(thing as any ptr,ColumnIndx as integer, text as string)
declare function GetColumn(thing as any ptr,ColumnIndx as integer) as string

'file i/o
declare sub CSVLoad(thing as any ptr, filename as string, mode as integer=0)
declare sub CSVSave(thing as any ptr, filename as string, mode as integer=0)

/'
'Data Grid
type DGR_Data
	ColumnList 	          as sGUIList ptr
  RowList 	            as sGUIList ptr
	ddisplay     			    as _Gadget ptr
	vscroll 					    as _Gadget ptr
	hscroll 					    as _Gadget ptr
	edit    		          as _Gadget ptr  
  TimeStamp             as double   
end type
'/
function AddDataGrid(win as sGUIWindow ptr,PosX as integer,PosY as integer,WinWidth as integer,WinHeight as integer) as any ptr
  function=0
  dim as sGUIWindow ptr gwin  
	dim as ExtendedAction ptr xaction
  dim as integer editheight
  editheight=GetFontHeight(1) + 2*sGUIMainGap
  if win=0 then win=RootWindow 
  gwin=AddWindow(win,PosX,PosY,WinWidth,WinHeight,,WFLAG_GADGETMODE)  
  if gwin then
    gwin->Activation=1   
      gwin->xtd.dgr.edit      =AddStringGadget(gwin,0,0,gwin->WinWidth,,,1,0,0)
      gwin->xtd.dgr.ddisplay  =AddDataGridDisplay (gwin,0,editheight + 1,gwin->WinWidth - sGUIMainSize-1,gwin->WinHeight - sGUIMainSize - editheight- 1 - 1)
      gwin->xtd.dgr.hscroll   =AddScrollBar(gwin,0,gwin->WinHeight-sGUIMainSize,gwin->WinWidth-sGUIMainSize-1,1,1,1,1,0)'OHNE Page/FullRange
      gwin->xtd.dgr.vscroll   =AddScrollBar(gwin,gwin->WinWidth-sGUIMainSize,editheight + 1,gwin->WinHeight-sGUIMainSize - editheight - 1 -1,1,1,1,1,1,1)'MIT Page/FullRange	
      'aus dem ddisplay die Zeiger der Zeilen-/SpaltenInfoliste nach "oben" holen
      gwin->xtd.dgr.ColumnList = gwin->xtd.dgr.ddisplay->xtd.dtd.ColumnList 
      gwin->xtd.dgr.RowList = gwin->xtd.dgr.ddisplay->xtd.dtd.RowList
      gwin->DoAction   =@DGR_Actions
      gwin->DoUpdate   =@DGR_Update
    function=gwin
  end if  
end function


sub DGR_Actions(win as sGUIWindow ptr)
  dim as sGUIList ptr column
  dim as sGUIDGColumn ptr cinfo
  dim as sGUIDGCell ptr cell
  dim as sGUIList ptr row
  dim as integer tracerequest,modecheck
  
  dim as Gadget ptr ddisplay,vscroll,hscroll,edit
 	dim as integer GadPosX,GadPosY,junk
  ddisplay=win->xtd.dgr.ddisplay  
  vscroll=win->xtd.dgr.vscroll
  hscroll=win->xtd.dgr.hscroll
  edit=win->xtd.dgr.edit
  tracerequest=0  
  if GADGETMESSAGE then           
    select case GADGETMESSAGE            
      case edit
      'das StringGadget setzt bei einem RETURN den FOCUSGADGET/WINDOW zurck,
      'd.h. Tastatureingaben, die ja ein FOCUSGADGET/WINDOW vorraussetzen, wrden nicht mehr hier ankommen
      'darum dem Focus wieder zurckholen
      SetFocus(win)
  
      case ddisplay     
        win->xtd.dgr.TimeStamp=timer
        tracerequest=1        
        if ddisplay->xtd.dtd.EditMode>8 then
          select case ddisplay->xtd.dtd.EditMode
            case 16'cell
              if ddisplay->xtd.dtd.SelectionMode=1 then'...und auch nur eine Zelle selektiert ist              
                SetString(edit, ddisplay->xtd.dtd.SelectedCell->Text)
                SetSelect(edit->xtd.stg.edit)
                ScrollToAnEnd (edit)
              end if
            case 32'header
              if ddisplay->xtd.dtd.SelectionMode=4 then'...und auch nur ein Header selektiert ist
                SetString(edit, ddisplay->xtd.dtd.SelectedColumn->Text)               
                SetSelect(edit->xtd.stg.edit)
                ScrollToAnEnd (edit)
              end if
          end select
          SetFocus(edit->xtd.stg.edit)
        end if
        
        if WHEEL then GADGETMESSAGE=0
       
      case hscroll     
        ddisplay->xtd.dtd.VPTargetColumnIndx=GetScrollBar(hscroll)
        tracerequest=1
        ddisplay->ReDraw=1   
        
      case vscroll            
        ddisplay->xtd.dtd.VPTargetRowIndx=GetScrollBar(vscroll) 
        tracerequest=1
        ddisplay->ReDraw=1             
      
    end select       
  end if  
  
  if GADGETMESSAGE=ddisplay then GADGETMESSAGE=cast(any ptr,win)
 
  if KEY<>"" then
    modecheck=ddisplay->xtd.dtd.EditMode + ddisplay->xtd.dtd.SelectionMode
    
'falls ein bestimmter EditMode nebst passendender Selection besteht, bisherige Selection zurckschreiben
'damit ist das Editieren im StringGadget auch in der/dem Zelle/Header sichtbar
    if modecheck=17 then'Cell Edit + Cell Selection
      SetCell(win, ddisplay->xtd.dtd.SelectedRowIndx, ddisplay->xtd.dtd.SelectedColumnIndx, GetString(Edit))
    end if
    if modecheck=36 then'Column Edit + Column Selection
      SetColumn(win, ddisplay->xtd.dtd.SelectedColumnIndx, GetString(Edit))
    end if    

'Cursorsteuerung        
    '!!!!! Regelerklrungen siehe ganz unten 
    'Return ZeilenRotation
    if (modecheck<>12) andalso (modecheck<32) then
      if ASCCODE=13 then 
        ddisplay->xtd.dtd.VPTargetRowIndx +=1    
        if ddisplay->xtd.dtd.VPTargetRowIndx>ddisplay->xtd.dtd.RowList->NumNodes then ddisplay->xtd.dtd.VPTargetRowIndx=1
      end if
    end if
    
    'Tab SpaltenRotation
    if modecheck<>10 then
      if ASCCODE=9 then
        ddisplay->xtd.dtd.VPTargetColumnIndx +=1
        if ddisplay->xtd.dtd.VPTargetColumnIndx>ddisplay->xtd.dtd.ColumnList->NumNodes then ddisplay->xtd.dtd.VPTargetColumnIndx=1  
      end if
    end if
    if (ASCCODE=9) or (ASCCODE=13) then tracerequest=1
    
    
    'Arrows Spalten-/Zeilen "mit Anschlag" und ohne Rotation
    if EXTENDED=255 then        
      'Arrow Left/Right      
      if (modecheck<>10) and (modecheck<16) then
        select case ASCCODE
          case 75'links
            ddisplay->xtd.dtd.VPTargetColumnIndx -=1
            if ddisplay->xtd.dtd.VPTargetColumnIndx<1 then ddisplay->xtd.dtd.VPTargetColumnIndx=1'ddisplay->xtd.dtd.ColumnList->NumNodes           
          case 77'rechts
            ddisplay->xtd.dtd.VPTargetColumnIndx +=1
            if ddisplay->xtd.dtd.VPTargetColumnIndx>ddisplay->xtd.dtd.ColumnList->NumNodes then ddisplay->xtd.dtd.VPTargetColumnIndx=ddisplay->xtd.dtd.ColumnList->NumNodes'1
        end select        
      end if
      if (ASCCODE=75) or (ASCCODE=77) then tracerequest=1
      
      'Arrow Up/Down
      if (modecheck<>12) and (modecheck<32) then      
        select case ASCCODE
          case 72'hoch
            ddisplay->xtd.dtd.VPTargetRowIndx -=1
            if ddisplay->xtd.dtd.VPTargetRowIndx<1 then ddisplay->xtd.dtd.VPTargetRowIndx=1'ddisplay->xtd.dtd.RowList->NumNodes  
          case 80'runter
            ddisplay->xtd.dtd.VPTargetRowIndx +=1
            if ddisplay->xtd.dtd.VPTargetRowIndx>ddisplay->xtd.dtd.RowList->NumNodes then ddisplay->xtd.dtd.VPTargetRowIndx=ddisplay->xtd.dtd.RowList->NumNodes'1   
        end select          
        if (ASCCODE=72) or (ASCCODE=80) then tracerequest=1
      end if

    end if
    
'mgliche Selektion dem Cursor nachfhren   
'0=No Selection, 1=Cell, 2=Row, 4=Column
    select case ddisplay->xtd.dtd.SelectionMode
      case 1
        ddisplay->xtd.dtd.SelectedColumnIndx=ddisplay->xtd.dtd.VPTargetColumnIndx    
        ddisplay->xtd.dtd.SelectedRowIndx=ddisplay->xtd.dtd.VPTargetRowIndx
        row=ddisplay->xtd.dtd.RowList->GetAddr(ddisplay->xtd.dtd.SelectedRowIndx, ddisplay->xtd.dtd.VPTopRow)
        ddisplay->xtd.dtd.SelectedCell=row->GetAddr(ddisplay->xtd.dtd.SelectedColumnIndx)      
      case 2
        ddisplay->xtd.dtd.SelectedColumnIndx=0   
        ddisplay->xtd.dtd.SelectedRowIndx=ddisplay->xtd.dtd.VPTargetRowIndx
        row=ddisplay->xtd.dtd.RowList->GetAddr(ddisplay->xtd.dtd.SelectedRowIndx, ddisplay->xtd.dtd.VPTopRow)'Zwischenschritt
        ddisplay->xtd.dtd.SelectedCell=0'da keine Spalte, nicht ermittelbar      
      case 4
        ddisplay->xtd.dtd.SelectedColumnIndx=ddisplay->xtd.dtd.VPTargetColumnIndx    
        ddisplay->xtd.dtd.SelectedRowIndx=0
        ddisplay->xtd.dtd.SelectedCell=0'   
    end select
    
    ddisplay->ReDraw=1
  end if

  if tracerequest then
    'falls ein bestimmter EditMode nebst passendender Selelection besteht, neue Selektion ins StringGadget schreiben
    if modecheck=17 then'Cell Edit + Cell Selection
      SetString(edit, GetCell(win, ddisplay->xtd.dtd.SelectedRowIndx, ddisplay->xtd.dtd.SelectedColumnIndx),0)'0=keine CursorNeuPositionierung!
      SetFocus(edit->xtd.stg.edit)
      SetSelect(edit->xtd.stg.edit)    
      ddisplay->ReDraw=1
    end if
    if modecheck=36 then'Column Edit + Column Selection
      SetString(edit, GetColumn(win, ddisplay->xtd.dtd.SelectedColumnIndx),0)'0=keine CursorNeuPositionierung!
      SetFocus(edit->xtd.stg.edit)
      SetSelect(edit->xtd.stg.edit)
      ddisplay->ReDraw=1      
    end if
'falls ein Spalten/Zeilenwechsel in einem der EditModes stattfand, im StringGadget den Cursor
'nach hinten setzen, da wir ja nun einen neuen Zellen-/HeaderInhalt sehen
    if (modecheck=17) then'Cell Edit + Cell Selection
      if (ASCCODE=9) or (ASCCODE=13) then ScrollToAnEnd (edit)'Zellenwechsel bei Tab/Return
      if EXTENDED=255 then
        if (ASCCODE=72) or (ASCCODE=80) then ScrollToAnEnd (edit)'Zellenwechsel bei Up/Dwn
      end if
    end if
    if modecheck=36 then'Column Edit + Column Selection
       if (ASCCODE=9) then ScrollToAnEnd (edit)'Headerwechsel bei Tab 
    end if      
  
    TraceVPRow(ddisplay,ddisplay->xtd.dtd.VPTargetRowIndx)
    TraceVPColumn(ddisplay,ddisplay->xtd.dtd.VPTargetColumnIndx)
    SetScrollBars(ddisplay, vscroll, hscroll, ddisplay->xtd.dtd.VPTargetRowIndx, ddisplay->xtd.dtd.VPTargetColumnIndx) 
  end if

end sub


sub DGR_Update (win as sGUIWindow ptr)

end sub


'gui **************************************************************************
sub DataGridUpdate(thing as any ptr, mode as integer=0) 
  dim as sGUIWindow ptr win=cast(sGUIWindow ptr, thing) 
  dim as Gadget ptr ddisplay,vscroll,hscroll
  dim as integer vvalue,hvalue
  ddisplay=win->xtd.dgr.ddisplay  
  vscroll=win->xtd.dgr.vscroll
  hscroll=win->xtd.dgr.hscroll 
      
  select case mode
    case 0
      'ScrollPosition links,oben
      SetLayout (ddisplay)      
      vvalue=1     
      hvalue=1
    case 1     
      'ScrollPosition links,unten(neue Zeile)
      SetLayout (ddisplay)
      vvalue=win->xtd.dgr.RowList->NumNodes    
      hvalue=1
    case 2
      'ScrollPosition rechts,oben(neue Spalte)
      vvalue=1    
      hvalue=win->xtd.dgr.ColumnList->NumNodes     
    case 3
      'halte selektierte Zeile
      vvalue=ddisplay->xtd.dtd.SelectedRowIndx    
      hvalue=GetScrollBar(hscroll)
    case 4
      'halte selektierte Spalte
      vvalue=GetScrollBar(vscroll)       
      hvalue=ddisplay->xtd.dtd.SelectedColumnIndx
          
    case 10
      'alle Scrollpositionen halten, diese knnten in diesem Moment nicht mehr valide sein!
      SetLayout (ddisplay)
      vvalue=GetScrollBar(vscroll)        
      hvalue=GetScrollBar(hscroll)   
  end select
  'beide Trace-Routinen korrigieren gegebenenfalls dabei unseren "Scrollwunsch" aus vvalue/hvalue und
  'hinterlegen einen gltigen Scrollwert in ddisplay->xtd.dtd.... VPTargetRowIndx/VPTargetColumnIndx  
  TraceVPRow(ddisplay,vvalue)
  TraceVPColumn(ddisplay,hvalue)
  'auf diese Werte sollten dann auch die beiden ScrollBars nachgefhrt werden
  'syntax: sub SetScrollBars(ddisplay as Gadget ptr, vscroll as Gadget ptr=0, hscroll as Gadget ptr=0, vvalue as integer=0, hvalue as integer=0)
  SetScrollBars(ddisplay, vscroll, hscroll, ddisplay->xtd.dtd.VPTargetRowIndx, ddisplay->xtd.dtd.VPTargetColumnIndx)  
end sub


sub SetScrollBars(ddisplay as Gadget ptr, vscroll as Gadget ptr=0, hscroll as Gadget ptr=0, vvalue as integer=0, hvalue as integer=0)
  if vscroll then
    if (ddisplay->xtd.dtd.RowList->NumNodes<>0) and (vvalue<>0) then
      SetScrollBar (vscroll, 1, ddisplay->xtd.dtd.RowList->NumNodes, vvalue, ddisplay->xtd.dtd.VPNumRows-1) 
    else
      SetScrollBar (vscroll, 1, 1, 1, 1)
    end if 
  end if
  if hscroll then
    if (ddisplay->xtd.dtd.ColumnList->NumNodes<>0) and (hvalue<>0) then
      SetScrollBar (hscroll, 1, ddisplay->xtd.dtd.ColumnList->NumNodes, hvalue, 1)
    else
      SetScrollBar (hscroll, 1, 1, 1, 1)
    end if
  end if
end sub


sub TraceColumn(thing as any ptr, ColumnIndx as integer)
  dim as sGUIWindow ptr win=cast(sGUIWindow ptr, thing) 
  dim as Gadget ptr ddisplay,hscroll
  ddisplay=win->xtd.dgr.ddisplay  
  hscroll=win->xtd.dgr.hscroll 
  TraceVPColumn(ddisplay,ColumnIndx)
  SetScrollBars(ddisplay,,hscroll,,ddisplay->xtd.dtd.VPTargetColumnIndx)     
end sub


sub TraceRow(thing as any ptr, RowIndx as integer)
  dim as sGUIWindow ptr win=cast(sGUIWindow ptr, thing) 
  dim as Gadget ptr ddisplay,vscroll
  ddisplay=win->xtd.dgr.ddisplay  
  vscroll=win->xtd.dgr.vscroll
  TraceVPRow(ddisplay,RowIndx)
  SetScrollBars(ddisplay,vscroll,,ddisplay->xtd.dtd.VPTargetRowIndx)
end sub


sub TraceCell(thing as any ptr, RowIndx as integer, ColumnIndx as integer)
  dim as sGUIWindow ptr win=cast(sGUIWindow ptr, thing) 
  dim as Gadget ptr ddisplay,vscroll,hscroll
  dim as integer vvalue,hvalue
  ddisplay=win->xtd.dgr.ddisplay  
  vscroll=win->xtd.dgr.vscroll
  hscroll=win->xtd.dgr.hscroll 
  TraceVPRow(ddisplay,RowIndx)
  TraceVPColumn(ddisplay,ColumnIndx)
  SetScrollBars(ddisplay, vscroll, hscroll, ddisplay->xtd.dtd.VPTargetRowIndx, ddisplay->xtd.dtd.VPTargetColumnIndx) 
end sub


'info *************************************************************************
function GetSelectionMode(thing as any ptr) as integer
  function=cast(sGUIWindow ptr,thing)->xtd.dgr.ddisplay->xtd.dtd.SelectionMode
end function


function GetSelectedRow(thing as any ptr) as integer
  function=cast(sGUIWindow ptr,thing)->xtd.dgr.ddisplay->xtd.dtd.SelectedRowIndx
end function


function GetSelectedColumn(thing as any ptr) as integer
  function=cast(sGUIWindow ptr,thing)->xtd.dgr.ddisplay->xtd.dtd.SelectedColumnIndx
end function


function GetNumRows(thing as any ptr) as integer
  function=cast(sGUIWindow ptr,thing)->xtd.dgr.RowList->NumNodes
end function


function GetNumColumns(thing as any ptr) as integer
  function=cast(sGUIWindow ptr,thing)->xtd.dgr.ColumnList->NumNodes
end function


'config ***********************************************************************
sub SetViewMode(thing as any ptr)
  dim as sGUIWindow ptr win=cast(sGUIWindow ptr, thing) 
  dim as Gadget ptr ddisplay,vscroll,hscroll,edit
  ddisplay=win->xtd.dgr.ddisplay  
  vscroll=win->xtd.dgr.vscroll
  hscroll=win->xtd.dgr.hscroll
  edit=win->xtd.dgr.edit 
  ddisplay->xtd.dtd.EditMode=8
  ddisplay->ReDraw=1
end sub


sub SetCellEditMode(thing as any ptr)
  dim as sGUIWindow ptr win=cast(sGUIWindow ptr, thing) 
  dim as Gadget ptr ddisplay,vscroll,hscroll,edit
  ddisplay=win->xtd.dgr.ddisplay  
  vscroll=win->xtd.dgr.vscroll
  hscroll=win->xtd.dgr.hscroll
  edit=win->xtd.dgr.edit
  
  ddisplay->xtd.dtd.EditMode=16 
  if ddisplay->xtd.dtd.SelectedCell then
    ddisplay->xtd.dtd.SelectionMode=1
    SetString(edit, ddisplay->xtd.dtd.SelectedCell->Text)
    SetSelect(edit->xtd.stg.edit)
    ScrollToAnEnd (edit)
    SetFocus(edit->xtd.stg.edit)                 
  else
    ddisplay->xtd.dtd.SelectionMode=0
    ddisplay->xtd.dtd.SelectedRowIndx=0
    ddisplay->xtd.dtd.SelectedRow=0    
    ddisplay->xtd.dtd.SelectedColumnIndx=0
    ddisplay->xtd.dtd.SelectedColumn=0         
    ddisplay->xtd.dtd.SelectedCell=0     
  end if
  ddisplay->ReDraw=1
end sub


sub SetColumnEditMode(thing as any ptr)
  dim as sGUIWindow ptr win=cast(sGUIWindow ptr, thing) 
  dim as Gadget ptr ddisplay,vscroll,hscroll,edit
  ddisplay=win->xtd.dgr.ddisplay  
  vscroll=win->xtd.dgr.vscroll
  hscroll=win->xtd.dgr.hscroll
  edit=win->xtd.dgr.edit
  ddisplay->xtd.dtd.EditMode=32
  if ddisplay->xtd.dtd.SelectedColumn then
    ddisplay->xtd.dtd.SelectionMode=4
    ddisplay->xtd.dtd.SelectedRowIndx=0
    ddisplay->xtd.dtd.SelectedRow=0            
    ddisplay->xtd.dtd.SelectedCell=0
    SetString(edit, ddisplay->xtd.dtd.SelectedColumn->Text)               
    SetSelect(edit->xtd.stg.edit)
    ScrollToAnEnd (edit)
    SetFocus(edit->xtd.stg.edit) 
  else
    ddisplay->xtd.dtd.SelectionMode=0
    ddisplay->xtd.dtd.SelectedRowIndx=0
    ddisplay->xtd.dtd.SelectedRow=0    
    ddisplay->xtd.dtd.SelectedColumnIndx=0
    ddisplay->xtd.dtd.SelectedColumn=0         
    ddisplay->xtd.dtd.SelectedCell=0     
  end if
  ddisplay->ReDraw=1
end sub


'edit grid *********************************************************************
sub AddColumn(thing as any ptr, cname as string, cwidth as integer=80)
  dim as sGUIWindow ptr win=cast(sGUIWindow ptr, thing) 
  dim as Gadget ptr ddisplay,hscroll
  ddisplay=win->xtd.dgr.ddisplay  
  hscroll=win->xtd.dgr.hscroll
  'cname &= " " & str(win->xtd.dgr.ColumnList->NumNodes + 1)
  CreateColumn(ddisplay,cname,cwidth)
  SetLayout (ddisplay)  
  TraceVPColumn(ddisplay,win->xtd.dgr.ColumnList->NumNodes)  
  SetScrollBars(ddisplay,,hscroll,,win->xtd.dgr.ColumnList->NumNodes)
end sub


sub AddRow(thing as any ptr,numrows as integer=1)
  dim as sGUIWindow ptr win=cast(sGUIWindow ptr, thing) 
  dim as Gadget ptr ddisplay,vscroll
  ddisplay=win->xtd.dgr.ddisplay  
  vscroll=win->xtd.dgr.vscroll
  CreateRow(ddisplay,numrows)
  SetLayout (ddisplay)  
  TraceVPRow(ddisplay,win->xtd.dgr.RowList->NumNodes)
  SetScrollBars(ddisplay,vscroll,,win->xtd.dgr.RowList->NumNodes)
end sub


sub DelColumn(thing as any ptr, ColumnIndx as integer)
  dim as sGUIWindow ptr win=cast(sGUIWindow ptr, thing) 
  dim as sGUIDGCell ptr cell
  dim as sGUIList ptr row
  dim as sGUIDGColumn ptr cinfo
  dim as Gadget ptr ddisplay,hscroll,vscroll
  ddisplay=win->xtd.dgr.ddisplay  
  hscroll=win->xtd.dgr.hscroll
  vscroll=win->xtd.dgr.vscroll
  
  if (ColumnIndx>0) and (ColumnIndx<=win->xtd.dgr.ColumnList->NumNodes) then'wenn zu lschende Spalte existent ist
    
    'Spalteninfo in ColumnList Lschen
    cinfo=win->xtd.dgr.ColumnList->GetAddr(ColumnIndx)
    win->xtd.dgr.ColumnList->DeleteNode(cinfo)
    'Loop durch alle Zeilen um dort jeweils die der Spalte zugehrigen Zelle zu lschen
    row=win->xtd.dgr.RowList->GetFirst
    if row then
      do
        cell=row->GetAddr(ColumnIndx)
        row->DeleteNode(cell) 
        row=cast(sGUIList ptr,row->next_node)
      loop until row=0
    end if   
    'in jedem Fall nach Lschen eine bestehende Selektion aufheben
    ddisplay->xtd.dtd.SelectionMode   =0
    ddisplay->xtd.dtd.SelectedColumn  =0
    ddisplay->xtd.dtd.SelectedColumnIndx=0
    ddisplay->xtd.dtd.SelectedRow     =0
    ddisplay->xtd.dtd.SelectedRowIndx   =0
    ddisplay->xtd.dtd.SelectedCell    =0          
    'in jedem Fall nach Lschen bestehende ScrollCursor/VP aufheben
    ddisplay->xtd.dtd.VPTargetColumn=0
    ddisplay->xtd.dtd.VPTargetColumnIndx=0
    ddisplay->xtd.dtd.VPLeftColumn=0
    ddisplay->xtd.dtd.VPLeftColumnIndx=0
    ddisplay->xtd.dtd.VPRightColumn=0
    ddisplay->xtd.dtd.VPRightColumnIndx=0    
    
    DataGridUpdate(win, 10)'10=Scrollpositionen halten 
  end if 
end sub


sub DelRow(thing as any ptr, RowIndx as integer)
  dim as sGUIWindow ptr win=cast(sGUIWindow ptr, thing)   
  dim as sGUIList ptr row
  dim as Gadget ptr ddisplay,vscroll
  ddisplay=win->xtd.dgr.ddisplay  
  vscroll=win->xtd.dgr.vscroll
  
  if (RowIndx>0) and (RowIndx<=win->xtd.dgr.RowList->NumNodes) then'wenn zu lschende Zeile existent ist
    'Zeile lschen
    row=win->xtd.dgr.RowList->GetAddr(RowIndx , ddisplay->xtd.dtd.VPTopRow)   
    win->xtd.dgr.RowList->DeleteNode(row)   
    'in jedem Fall nach Lschen eine bestehende Selektion aufheben   
    ddisplay->xtd.dtd.SelectionMode   =0
    ddisplay->xtd.dtd.SelectedColumn  =0
    ddisplay->xtd.dtd.SelectedColumnIndx=0
    ddisplay->xtd.dtd.SelectedRow     =0
    ddisplay->xtd.dtd.SelectedRowIndx   =0
    ddisplay->xtd.dtd.SelectedCell    =0      
    'in jedem Fall nach Lschen bestehende ScrollCursor/VP aufheben
    ddisplay->xtd.dtd.VPTargetRow=0
    ddisplay->xtd.dtd.VPTargetRowIndx=0
    ddisplay->xtd.dtd.VPTopRow=0
    ddisplay->xtd.dtd.VPTopRowIndx=0
    
    DataGridUpdate(win, 10)'10=Scrollpositionen halten 
  end if
end sub


sub RowMove(thing as any ptr, RowIndx as integer, DestIndx as integer)
  dim as sGUIWindow ptr win=cast(sGUIWindow ptr, thing)
  dim as Gadget ptr ddisplay
  ddisplay=win->xtd.dgr.ddisplay  
  win->xtd.dgr.RowList->MoveTo(RowIndx,DestIndx)
  if ddisplay->xtd.dtd.SelectedRow then ddisplay->xtd.dtd.SelectedRowIndx=ddisplay->xtd.dtd.SelectedRow->Index 
  DataGridUpdate(win,3)  
end sub


sub ColumnMove(thing as any ptr, ColumnIndx as integer, DestIndx as integer)
  dim as sGUIWindow ptr win=cast(sGUIWindow ptr, thing)
  dim as sGUIList ptr row
  dim as Gadget ptr ddisplay
  ddisplay=win->xtd.dgr.ddisplay    
  win->xtd.dgr.ColumnList->MoveTo(ColumnIndx,DestIndx) 
  'Zelle
  row=win->xtd.dgr.RowList->GetFirst
  if row then
    do
      row->MoveTo(ColumnIndx,DestIndx)
      row=cast(sGUIList ptr,row->next_node)
    loop until row=0     
  end if    
  if ddisplay->xtd.dtd.SelectedColumn then ddisplay->xtd.dtd.SelectedColumnIndx=ddisplay->xtd.dtd.SelectedColumn->Index 
  DataGridUpdate(win,4)  
end sub


sub ColumnLeft(thing as any ptr, ColumnIndx as integer)
  dim as sGUIWindow ptr win=cast(sGUIWindow ptr, thing)
  dim as sGUIDGCell ptr cell,dest
  dim as sGUIList ptr row
  dim as sGUIDGColumn ptr cinfo,cinfodest
  dim as Gadget ptr ddisplay,vscroll,hscroll
  ddisplay=win->xtd.dgr.ddisplay  
  vscroll=win->xtd.dgr.vscroll
  hscroll=win->xtd.dgr.hscroll
  if ColumnIndx>1 then'schliesst keine Spaltenselektion(=0) und den Fall das Spalte schon 1. Position hat aus  
  'Column Info
    cinfo=win->xtd.dgr.ColumnList->GetAddr(ColumnIndx)
    cinfodest=cast(sGUIDGColumn ptr,cinfo->prev_node)'linker Nachbar/Vorgnger'win->xtd.dgr.ColumnList->GetAddr(ColumnIndx-1,cinfo)
    win->xtd.dgr.ColumnList->MoveBefore(cinfo,cinfodest)'cinfo nach links verschieben
    'die bergebene ColumnIndx kann eine selektierte Spalte sein, dann die ID der verschobenen Spalte an SelectColumnIndx bergeben
    if ColumnIndx=ddisplay->xtd.dtd.SelectedColumnIndx then ddisplay->xtd.dtd.SelectedColumnIndx=cinfo->Index       
  'Zelle
    row=win->xtd.dgr.RowList->GetFirst
    if row then
      do
        cell=row->GetAddr(ColumnIndx)
        dest=cast(sGUIDGCell ptr,cell->prev_node)'row->GetAddr(ColumnIndx-1,cell)
        row->MoveBefore(cell,dest)
        row=cast(sGUIList ptr,row->next_node)
      loop until row=0     
    end if  
  end if
  DataGridUpdate(win,4)   
end sub


sub ColumnRight(thing as any ptr, ColumnIndx as integer)
  dim as sGUIWindow ptr win=cast(sGUIWindow ptr, thing)
  dim as sGUIDGCell ptr cell,dest
  dim as sGUIList ptr row
  dim as sGUIDGColumn ptr cinfo,cinfodest
  dim as Gadget ptr ddisplay,vscroll,hscroll
  ddisplay=win->xtd.dgr.ddisplay  
  vscroll=win->xtd.dgr.vscroll
  hscroll=win->xtd.dgr.hscroll
  if (ColumnIndx>0) and (ColumnIndx<win->xtd.dgr.ColumnList->NumNodes) then'schliesst keine Spaltenselektion(=0) und den Fall das Spalte schon die letzte ist aus    
  'Column Info
    cinfo=win->xtd.dgr.ColumnList->GetAddr(ColumnIndx)
    cinfodest=cast(sGUIDGColumn ptr,cinfo->next_node)'rechter Nachbar/Nachfolger'cwin->xtd.dgr.ColumnList->GetAddr(ColumnIndx+1,cinfo)
    win->xtd.dgr.ColumnList->MoveBehind(cinfo,cinfodest)'cinfo nach rechts verschieben    
    'die bergebene ColumnIndx kann eine selektierte Spalte sein, dann die ID der verschobenen Spalte an SelectColumnIndx bergeben
    if ColumnIndx=ddisplay->xtd.dtd.SelectedColumnIndx then ddisplay->xtd.dtd.SelectedColumnIndx=cinfo->Index
  'Zelle
    row=win->xtd.dgr.RowList->GetFirst
    if row then
      do
        cell=row->GetAddr(ColumnIndx)
        dest=cast(sGUIDGCell ptr,cell->next_node)'row->GetAddr(ColumnIndx+1,cell)
        row->MoveBehind(cell,dest)
        row=cast(sGUIList ptr,row->next_node)
      loop until row=0
    end if
  end if
  DataGridUpdate(win,4)  
end sub


sub ClearGrid(thing as any ptr)
  dim as sGUIWindow ptr win=cast(sGUIWindow ptr, thing)    
  dim as Gadget ptr ddisplay,vscroll,hscroll
  ddisplay=win->xtd.dgr.ddisplay  
  vscroll=win->xtd.dgr.vscroll
  hscroll=win->xtd.dgr.hscroll
  
  win->xtd.dgr.RowList->DeleteAll
  win->xtd.dgr.ColumnList->DeleteAll
  
  ddisplay->xtd.dtd.SelectionMode=0
  ddisplay->xtd.dtd.SelectedRowIndx=0
  ddisplay->xtd.dtd.SelectedColumnIndx=0
  ddisplay->xtd.dtd.SelectedCell=0

  ddisplay->xtd.dtd.VPTargetRow    =0
  ddisplay->xtd.dtd.VPTargetRowIndx  =0
  ddisplay->xtd.dtd.VPTopRow       =0
  ddisplay->xtd.dtd.VPTopRowIndx     =0

  ddisplay->xtd.dtd.VPTargetColumn   =0
  ddisplay->xtd.dtd.VPTargetColumnIndx =0
  ddisplay->xtd.dtd.VPLeftColumn     =0
  ddisplay->xtd.dtd.VPLeftColumnIndx   =0
  ddisplay->xtd.dtd.VPRightColumn    =0
  ddisplay->xtd.dtd.VPRightColumnIndx  =0   
  DataGridUpdate(win)
end sub


sub AutoWidth(thing as any ptr, minwidth as integer=0, maxwidth as integer=0)
  dim as sGUIWindow ptr win=cast(sGUIWindow ptr, thing) 
  dim as sGUIDGCell ptr cell
  dim as sGUIList ptr row
  dim as sGUIDGColumn ptr cinfo
  dim as integer cellwidth
  dim as Gadget ptr ddisplay,vscroll,hscroll
  ddisplay=win->xtd.dgr.ddisplay  
  vscroll=win->xtd.dgr.vscroll
  hscroll=win->xtd.dgr.hscroll

  if (maxwidth=0) or (maxwidth>ddisplay->xtd.dtd.GrdWidth*.80) then maxwidth=ddisplay->xtd.dtd.GrdWidth*.80'Spalte sollte immer etwas kleiner als GrdWidth sein
  if minwidth>maxwidth then swap minwidth,maxwidth    
  
  if win->xtd.dgr.ColumnList->NumNodes then
    cinfo=win->xtd.dgr.ColumnList->GetFirst
    do
      cinfo->ColumnWidth=GetTextWidth(cinfo->Text,2) + 2*sGUIMainGap
      if minwidth then
        if cinfo->ColumnWidth<minwidth then cinfo->ColumnWidth=minwidth
      end if
      if cinfo->ColumnWidth>maxwidth then cinfo->ColumnWidth=maxwidth      
      cinfo=cast(sGUIDGColumn ptr,cinfo->next_node)
    loop until (cinfo=0) 
    
    if win->xtd.dgr.RowList->NumNodes then
    row=win->xtd.dgr.RowList->GetFirst
      do       
        cell=row->GetFirst
        cinfo=win->xtd.dgr.ColumnList->GetFirst
        do
          cellwidth=GetTextWidth(cell->Text,2) + 2*sGUIMainGap
          if cellwidth>cinfo->ColumnWidth then cinfo->ColumnWidth=iif(cellwidth>maxwidth,maxwidth,cellwidth)    
          cell=cast(sGUIDGCell ptr,cell->next_node)
          cinfo=cast(sGUIDGColumn ptr,cinfo->next_node)
        loop until (cell=0) 
        
        row=cast(sGUIList ptr,row->next_node)
      loop until row=0    
    end if
  end if
  DataGridUpdate(win)
end sub


'cell edit i/o *****************************************************************
sub SetCell(thing as any ptr,RowIndx as integer,ColumnIndx as integer, text as string)
  dim as sGUIWindow ptr win=cast(sGUIWindow ptr, thing)   
  dim as sGUIDGCell ptr cell 
  cell=GetCellAddr(win->xtd.dgr.ddisplay,RowIndx,ColumnIndx)
  if cell then cell->Text=text
end sub


function GetCell(thing as any ptr,RowIndx as integer,ColumnIndx as integer) as string
  dim as sGUIWindow ptr win=cast(sGUIWindow ptr, thing)   
  dim as sGUIDGCell ptr cell 
  cell=GetCellAddr(win->xtd.dgr.ddisplay,RowIndx,ColumnIndx)
  if cell then function=cell->Text else function=""
end function


'column edit i/o *****************************************************************
sub SetColumn(thing as any ptr, ColumnIndx as integer, text as string)
  dim as sGUIWindow ptr win=cast(sGUIWindow ptr, thing)   
  dim as _sGUIDGColumn ptr cinfo=win->xtd.dgr.ColumnList->GetAddr(ColumnIndx) 
  if cinfo then cinfo->Text=text
end sub


function GetColumn(thing as any ptr, ColumnIndx as integer) as string
  dim as sGUIWindow ptr win=cast(sGUIWindow ptr, thing)   
  dim as _sGUIDGColumn ptr cinfo=win->xtd.dgr.ColumnList->GetAddr(ColumnIndx)
  if cinfo then function=cinfo->Text else function=""
end function


'file i/o **********************************************************************
sub CSVLoad(thing as any ptr, filename as string, mode as integer=0)
  dim as sGUIWindow ptr win=cast(sGUIWindow ptr, thing)   
  dim as integer ff,comma,commaold,lenrow,lenpart,exitsignal,txtwidth,maxwidth
  dim as string rowtxt,celltxt,hdrtxt
  dim as sGUIDGCell ptr cell
  dim as sGUIList ptr row
  dim as sGUIDGColumn ptr cinfo
  dim as Gadget ptr ddisplay,vscroll,hscroll
  ddisplay=win->xtd.dgr.ddisplay  
  vscroll=win->xtd.dgr.vscroll
  hscroll=win->xtd.dgr.hscroll
  maxwidth=ddisplay->xtd.dtd.GrdWidth-sGUIMainSize
  ClearGrid(win)
  ff=freefile
  open filename for input as ff
    'Header einlesen in ColumnList, Spalte erzeugen
    line input #ff, rowtxt
    lenrow=len(rowtxt)
    comma=0
    do
      commaold=comma
      comma = instr(commaold + 1, rowtxt, ",")
      if comma<>0 then lenpart=comma - commaold -1 else lenpart=lenrow - commaold         
      hdrtxt=mid(rowtxt,commaold+1,lenpart)
      CreateColumn(ddisplay, hdrtxt,GetTextWidth(hdrtxt,2)+ 2*sGUIMainGap)     
    loop until comma=0

    select case mode
    
      case 0'neues Grid aus CSV, komplett geladen mit fester Spaltenbreite
        
        'Datenzeilen einlesen in RowList, Zeilen und Zellen erzeugen
        'es wird nicht berprft ob Zellenanzahl jeder Zeile gleich der Spaltenanzahl entspricht
        'wir gehen davon aus dass die CSV "gltig" ist
        'Line Input geht nicht, wegen Komma im Zelltext
        do
          row=win->xtd.dgr.RowList->AppendNew(sGUIListType)
          cinfo=win->xtd.dgr.ColumnList->GetFirst
          for i as integer=1 to win->xtd.dgr.ColumnList->NumNodes' hier direkt aus ColumnList geholt, da oben frisch gendert
            input #ff,celltxt
            cell=row->AppendNew(sGUIDGCellType)
            if cell then
              cell->Text=celltxt
              txtwidth=GetTextWidth(celltxt,2)+ 2*sGUIMainGap
              if txtwidth>cinfo->ColumnWidth then cinfo->ColumnWidth=txtwidth
              if cinfo->ColumnWidth>maxwidth then cinfo->ColumnWidth=maxwidth
            end if
            
            cinfo=cast(sGUIDGColumn ptr,cinfo->next_node)            
          next i
        loop until eof(ff)         

    end select
    
  close ff
  
  DataGridUpdate(win)'auf Zeile/Spalte 1 zurcksetzen
end sub


sub CSVSave(thing as any ptr, filename as string, mode as integer=0)
  dim as sGUIWindow ptr win=cast(sGUIWindow ptr, thing)   
  dim as integer ff
  dim as sGUIDGCell ptr cell
  dim as sGUIList ptr row
  dim as sGUIDGColumn ptr cinfo
  dim as Gadget ptr ddisplay
  ddisplay=win->xtd.dgr.ddisplay    
  
  ff=freefile
  open filename for output as ff  
      
    if win->xtd.dgr.ColumnList->NumNodes then'wenn es Spalten gibt, aktiv werden, Hauptbedingung!!!
    
      'Header schreiben
      cinfo=win->xtd.dgr.ColumnList->GetFirst
      do
        print #ff,cinfo->Text;
        cinfo=cast(sGUIDGColumn ptr,cinfo->next_node)
        if cinfo<>0 then print #ff,",";
      loop until cinfo=0
      print #ff,
      
      'Daten schreiben
      select case mode     
        case 0'aus den Daten ein "normale" CSV Datei erzeugen          
          if win->xtd.dgr.RowList->NumNodes then'wenn es Zeilen gibt          
            row=win->xtd.dgr.RowList->GetFirst
            do
              cell=row->GetFirst
              do
                if instr(cell->Text,",") then cell->Text =chr(34) & cell->Text & chr(34)'falls Komma im String, selbigen in Anfhrungszeichen setzen
                print #ff, cell->Text;                   
                cell=cast(sGUIDGCell ptr,cell->next_node)
                if cell<>0 then print #ff, ",";
              loop until cell=0
              row=cast(sGUIList ptr,row->next_node)
              if row<>0 then print #ff,         
            loop until row=0
          end if
        /'
        case 1'Config CSV, Daten enthalten Spaltenbreiten
          if win->xtd.dgr.ColumnList->NumNodes then'wenn es Spalten gibt      
            cinfo=win->xtd.dgr.ColumnList->GetFirst
            do
              print #ff,cinfo->ColumnWidth;
              cinfo=cast(sGUIDGColumn ptr,cinfo->next_node)
              if cinfo<>0 then print #ff,",";
            loop until cinfo=0
          end if        
        '/
      end select
    
    end if   
  close ff
end sub


end namespace


'******************************************************************************
'******************************************************************************
/'
Regelwerk fr die Modi und entsprechender Steuerungen via Tastatur

1. Der EditMode bestimmt den SelectionMode
  wenn 8=no Edit              dann folgendes mglich: 0=no Selection, 1=Cell Selection, 2=Row Selection, 4=Column Selection
  wenn 16=Cell Edit           dann folgendes mglich: 0=no Selection, 1=Cell Selection
  wenn 32=Column/Header Edit  dann folgendes mglich: 0=no Selection, 4=Column Selection
  
  daraus ergeben sich 8 verschiedene Modi-Kombinationen die jeweils eine andere Tastatursteuerung haben!
      Rtrn  Tab Up  Dwn Lft Rght 
8/0   1     1   1   1   1   1
8/1   1     1   1   1   1   1
8/2   1         1   1
8/4         1           1   1
16/0  1     1   1   1
16/1  1     1   1   1
32/0        1
32/4        1

Fr die Keys kann man nun relativ einfach Regeln ableiten, wann welche Tasten erlaubt/verboten sind:
Tab   erlaubt wenn (EM+SM)<>10

Rtrn  erlaubt wenn (EM+SM)<>12  und (EM+SM)<32
Up    erlaubt wenn (EM+SM)<>12  und (EM+SM)<32 
Dwn   erlaubt wenn (EM+SM)<>12  und (EM+SM)<32

Lft   erlaubt wenn (Em+SM)<>10  und (EM+SM)<16 
Rght  erlaubt wenn (Em+SM)<>10  und (EM+SM)<16 
'/
