namespace sGUI

declare function AddDataGridDisplay (win as sGUIWindow ptr,PosX as integer,PosY as integer,GadWidth as integer,GadHeight as integer) as Gadget ptr
declare function DTD_Actions(gad as Gadget ptr,action as integer) as integer
declare sub DTD_Draw (gad as Gadget ptr)

declare sub SetLayout (gad as Gadget ptr)

declare sub TraceVPRow (gad as Gadget ptr, target as integer=1)
declare sub TraceVPColumn (gad as Gadget ptr, target as integer=1)
declare sub SetVPLeftbased (gad as Gadget ptr, target as integer=1)
declare sub SetVPRightbased (gad as Gadget ptr, target as integer=1)
declare sub RefreshVPRowAddresses(gad as Gadget ptr)
declare sub RefreshVPColumnAddresses(gad as Gadget ptr)

declare sub CreateColumn(gad as Gadget ptr, cname as string, cwidth as integer=80)
declare sub CreateRow(gad as Gadget ptr,num as integer=1)
declare function GetSelColumn(gad as Gadget ptr, GadPosX as integer, GadPosY as integer) as integer
declare function GetSelRow(gad as Gadget ptr, GadPosX as integer, GadPosY as integer) as integer
declare function GetRowAddr(gad as Gadget ptr, rowid as integer) as _sGUIList ptr
declare function GetCellAddr(gad as Gadget ptr, rowid as integer, columnid as integer) as _sGUIDGCell ptr
/'
type DTD_Data
	ColumnList 	          as sGUIList ptr
  RowList 	            as sGUIList ptr

  CellHeight            as integer 'Festwert gesetzt durch AddDataGridDisplay 
  
  InfoPosX              as integer 'Festwert gesetzt durch AddDataGridDisplay
  InfoPosY              as integer 'Festwert gesetzt durch AddDataGridDisplay
  InfoHeight            as integer 'Festwert gesetzt durch AddDataGridDisplay
  GrdPosY               as integer 'Festwert gesetzt durch AddDataGridDisplay
  GrdHeight             as integer 'Festwert gesetzt durch AddDataGridDisplay  
  InfoWidth             as integer 'aktualisiert durch SetLayout  
  
  GrdPosX               as integer 'aktualisiert durch SetLayout   
  GrdWidth              as integer 'aktualisiert durch SetLayout
  
  'VP
  'virtueller Zeilen/Spalten ScrollCursor, ihm wird das Display, also VPTopRow/VPLeftColumn, nachgefhrt
  VPNumRows         as integer  
  VPTargetRow       as sGUIList ptr
  VPTargetRowIndx   as integer    
  VPTargetColumn    as _sGUIDGColumn ptr
  VPTargetColumnIndx  as integer  
  VPTopRow          as sGUIList ptr
  VPTopRowIndx      as integer               
  VPLeftColumn      as _sGUIDGColumn ptr
  VPLeftColumnIndx  as integer
  VPRightColumn     as _sGUIDGColumn ptr
  VPRightColumnIndx as integer   
  
  SelectionMode       as integer'0=No Selection, 1=Cell, 2=Row, 4=Column
  SelectedColumn      as _sGUIDGColumn ptr
  SelectedColumnIndx  as integer
  SelectedRow         as _sGUIList ptr
  SelectedRowIndx     as integer  
  SelectedCell        as _sGUIDGCell ptr
  
  EditMode            as integer

  EditPosXglobal      as integer
  EditPosYglobal      as integer  
  TimeStamp           as double   
end type
'/
function AddDataGridDisplay (win as sGUIWindow ptr,PosX as integer,PosY as integer,GadWidth as integer,GadHeight as integer) as Gadget ptr  
  function=0  
  dim as Gadget ptr gad
  dim as integer cellheight,fillwidth
  
  if win=0 then win=RootWindow
  gad=win->GadgetList->AppendNew (GadgetType)
  if gad then
    gad->parent=win
    gad->PosX=PosX
    gad->PosY=PosY
		gad->GadWidth=GadWidth
		gad->GadHeight=GadHeight     
    
    gad->xtd.dtd.ColumnList = EntryLists->AppendNew (sGUIListType)    
    gad->xtd.dtd.RowList = CellLists->AppendNew (sGUIListType)  
    gad->xtd.dtd.CellHeight=GetFontHeight(2) + 2*sGUIMainGap    
    gad->xtd.dtd.EditMode=8'no edit/ view mode
    
    SetLayout (gad)
    TraceVPRow (gad)
    TraceVPColumn (gad)
   
    gad->DrawBuffer->img=imagecreate(gad->GadWidth,Gad->GadHeight)
    gad->DoDraw      =@DTD_Draw
    gad->DoAction    =@DTD_Actions
    'gad->DoUpdate	   =@DTD_Update
    gad->DeviceFlags=DFLAG_LMB or DFLAG_WHEEL      
		function=gad
  end if
end function


function DTD_Actions(gad as Gadget ptr,action as integer) as integer
  function=0
 	dim as integer GadPosX,GadPosY,fail 
  dim as sGUIDGColumn ptr cinfo
  dim as sGUIDGCell ptr cell
  dim as sGUIList ptr row
  
  select case action
    case GADGET_LMBHIT 
      GetGlobalPosition(gad,GadPosX,GadPosY)  
      gad->xtd.dtd.SelectionMode=0
      'Zellenbereich
      if (MOUSEX>=(GadPosX + gad->xtd.dtd.GrdPosX)) and (MOUSEX<(GadPosX + gad->xtd.dtd.GrdPosX + gad->xtd.dtd.GrdWidth)) and _
         (MOUSEY>=(GadPosY + gad->xtd.dtd.GrdPosY)) and (MOUSEY<(GadPosY + gad->xtd.dtd.GrdPosY + gad->xtd.dtd.GrdHeight)) then
        gad->xtd.dtd.SelectionMode=1
      end if
      'Zeilennummerbereich
      if (MOUSEX>=GadPosX + gad->xtd.dtd.InfoPosX) and (MOUSEX<GadPosX + gad->xtd.dtd.InfoPosX + gad->xtd.dtd.InfoWidth) and _
         (MOUSEY>=GadPosY + gad->xtd.dtd.InfoPosY + gad->xtd.dtd.InfoHeight) and (MOUSEY<GadPosY + gad->xtd.dtd.InfoPosY + gad->GadHeight - 1) then
         gad->xtd.dtd.SelectionMode=2
      end if      
      'Spaltenbereich
      if (MOUSEX>=GadPosX + gad->xtd.dtd.GrdPosX) and (MOUSEX<GadPosX + gad->GadWidth - 1) and _
         (MOUSEY>=GadPosY + gad->xtd.dtd.InfoPosY) and (MOUSEY<GadPosY + gad->xtd.dtd.InfoPosY + gad->xtd.dtd.InfoHeight) then
         gad->xtd.dtd.SelectionMode=4
      end if

      if gad->xtd.dtd.SelectionMode then
        gad->xtd.dtd.SelectedRowIndx=0
        gad->xtd.dtd.SelectedColumnIndx=0
        gad->xtd.dtd.SelectedCell=0        
        fail=0
        select case gad->xtd.dtd.SelectionMode
          case 4
            fail+=GetSelColumn(gad, GadPosX, GadPosY)
            gad->xtd.dtd.EditPosYGlobal=GadPosY + gad->xtd.dtd.InfoPosY
          case 2
            fail+=GetSelRow(gad, GadPosX, GadPosY)
          case 1
            fail+=GetSelColumn(gad, GadPosX, GadPosY)
            fail+=GetSelRow(gad, GadPosX, GadPosY)
            if fail=0 then
              row=gad->xtd.dtd.RowList->GetAddr(gad->xtd.dtd.SelectedRowIndx, gad->xtd.dtd.VPTopRow)
              gad->xtd.dtd.SelectedCell=row->GetAddr(gad->xtd.dtd.SelectedColumnIndx)
            end if
        end select
      else
        fail +=1
      end if
      
      'nachtrglicher EditMode Selection Filter ;)
      'falls einer der beiden Editmodes aktiv ist, muss auch die passende Selektion vorhanden sein
      'anderenfalls machen wir hier einfach einen Fail draus und gut ists :)
      select case gad->xtd.dtd.EditMode
        case 16'Cell Edit
          if gad->xtd.dtd.SelectionMode<>1 then fail +=1
        case 32'Header Edit
          if gad->xtd.dtd.SelectionMode<>4 then fail +=1   
      end select      
      
      if fail then 
        gad->xtd.dtd.SelectionMode=0
        gad->xtd.dtd.SelectedRowIndx=0      
        gad->xtd.dtd.SelectedColumnIndx=0     
        gad->xtd.dtd.SelectedCell=0        
      else
        if gad->xtd.dtd.SelectedColumnIndx>0 then gad->xtd.dtd.VPTargetColumnIndx=gad->xtd.dtd.SelectedColumnIndx
        if gad->xtd.dtd.SelectedRowIndx>0 then gad->xtd.dtd.VPTargetRowIndx=gad->xtd.dtd.SelectedRowIndx   
      end if  
      gad->ReDraw=1       
      function=1
    
    case GADGET_LMBHOLDOFF,GADGET_LMBRELEASEOFF
    
    case GADGET_WHEELMOVE  
      GetGlobalPosition(gad,GadPosX,GadPosY)
      if (MOUSEX >= GadPosX + gad->xtd.dtd.InfoPosX) and (MOUSEX < GadPosX + gad->xtd.dtd.GrdPosX + gad->xtd.dtd.GrdWidth) and _
         (MOUSEY >= GadPosY + gad->xtd.dtd.GrdPosY) and (MOUSEY < GadPosY + gad->xtd.dtd.GrdPosY + gad->xtd.dtd.GrdHeight) then
        TraceVPRow (gad, gad->xtd.dtd.VPTargetRowIndx + WHEEL)
        gad->ReDraw=1       
        function=1         
      end if
      
      if (MOUSEX >= GadPosX + gad->xtd.dtd.GrdPosX) and (MOUSEX < GadPosX + gad->GadWidth - 1) and _
         (MOUSEY >= GadPosY + gad->xtd.dtd.InfoPosY) and (MOUSEY < GadPosY + gad->xtd.dtd.InfoPosY + gad->xtd.dtd.InfoHeight) then
        TraceVPColumn (gad, gad->xtd.dtd.VPTargetColumnIndx + WHEEL)
        gad->ReDraw=1       
        function=1   
      end if            
    
    case GADGET_MOUSEHOVER
      gad->MouseHover=1
    
    case GADGET_MOUSENEXT
      gad->MouseHover=0
  end select
end function


sub DTD_Draw (gad as Gadget ptr)
	dim as FB.Image ptr Buffer
  dim as sGUIDGColumn ptr cinfo
  dim as sGUIDGCell ptr cell
  dim as sGUIList ptr row
  dim as integer ColumnPos,RowPos
  dim as integer cellheight,counter,csel
  dim as ulong col,tcol
  
  cellheight=gad->xtd.dtd.CellHeight
	Buffer=gad->DrawBuffer->img
  
'OFF
  ClearBox Buffer,0,0,gad->GadWidth,gad->GadHeight,Colors.DGR_DataBackGround
'ON
  'Hauptbedingung fr den "Rest", es mssen Spalten da sein
  if gad->xtd.dtd.ColumnList->NumNodes then  
    
    'ClearBox    Buffer,gad->xtd.dtd.InfoPosX + ColumnPos,gad->xtd.dtd.InfoPosY,gad->xtd.dtd.InfoWidth,gad->xtd.dtd.InfoHeight,Colors.DGR_InfoBackground                  
    GrdFrame    Buffer,gad->xtd.dtd.InfoPosX + ColumnPos,gad->xtd.dtd.InfoPosY,gad->xtd.dtd.InfoWidth,gad->xtd.dtd.InfoHeight  
    
    'Column ******************************
    cinfo=gad->xtd.dtd.VPLeftColumn
    ColumnPos=0
    do
      col=iif(cinfo->Index=gad->xtd.dtd.SelectedColumnIndx,Colors.DGR_InfoBackGroundSelected,Colors.DGR_InfoBackGround)
      tcol=iif(cinfo->Index=gad->xtd.dtd.SelectedColumnIndx,Colors.DGR_TextSelected,Colors.DGR_Text)
      ClearBox    Buffer,gad->xtd.dtd.GrdPosX + ColumnPos,gad->xtd.dtd.InfoPosY,cinfo->ColumnWidth,cellheight,col             
      drawstring  Buffer,gad->xtd.dtd.GrdPosX + ColumnPos+sGUIMainGap,gad->xtd.dtd.InfoPosY+sGUIMainGap,cinfo->Text,tcol,2     
      GrdFrame    Buffer,gad->xtd.dtd.GrdPosX + ColumnPos,gad->xtd.dtd.InfoPosY,cinfo->ColumnWidth,cellheight        
      if cinfo=gad->xtd.dtd.VPTargetColumn then GrdFrame Buffer,gad->xtd.dtd.GrdPosX + ColumnPos +1,gad->xtd.dtd.InfoPosY +1,cinfo->ColumnWidth-2,cellheight-2             
      ColumnPos += cinfo->ColumnWidth
      cinfo=cast(sGUIDGColumn ptr,cinfo->next_node) 
    loop until (cinfo=0) or (ColumnPos>=gad->xtd.dtd.GrdWidth)

    'Counter ******************************
    if gad->xtd.dtd.RowList->NumNodes then
      RowPos=0
      counter=gad->xtd.dtd.VPTopRowIndx
      do
        col=iif(counter=gad->xtd.dtd.SelectedRowIndx,Colors.DGR_InfoBackGroundSelected,Colors.DGR_InfoBackGround)
        tcol=iif(counter=gad->xtd.dtd.SelectedRowIndx,Colors.DGR_TextSelected,Colors.DGR_Text)      
        ClearBox    Buffer,gad->xtd.dtd.InfoPosX,gad->xtd.dtd.GrdPosY + RowPos,gad->xtd.dtd.InfoWidth,cellheight,col
        drawstring  Buffer,gad->xtd.dtd.InfoPosX +sGUIMainGap,gad->xtd.dtd.GrdPosY + RowPos +sGUIMainGap,str(counter),tcol,2   
        GrdFrame    Buffer,gad->xtd.dtd.InfoPosX,gad->xtd.dtd.GrdPosY + RowPos,gad->xtd.dtd.InfoWidth,cellheight 
        if counter=gad->xtd.dtd.VPTargetRowIndx then GrdFrame Buffer,gad->xtd.dtd.InfoPosX +1,gad->xtd.dtd.GrdPosY + RowPos +1,gad->xtd.dtd.InfoWidth-2,cellheight-2
        RowPos +=gad->xtd.dtd.CellHeight
        counter +=1
      loop until (RowPos>=gad->xtd.dtd.GrdHeight) or (counter > gad->xtd.dtd.RowList->NumNodes)
   
    'Cells *********************************
      row=gad->xtd.dtd.VPTopRow
      RowPos=0
      do
        cell=row->GetAddr(gad->xtd.dtd.VPLeftColumnIndx)
        cinfo=gad->xtd.dtd.VPLeftColumn       
        ColumnPos=0        
        do
        
          select case gad->xtd.dtd.SelectionMode
            case 0
              col=Colors.DGR_DataBackGround
              'tcol=Colors.DGR_Text
            case 1
              col=iif(cell=gad->xtd.dtd.SelectedCell,Colors.DGR_DataBackGroundSelected,Colors.DGR_DataBackGround)
              'tcol=iif(cell=gad->xtd.dtd.SelectedCell,Colors.DGR_TextSelected,Colors.DGR_Text)              
            case 2
              col=iif(row->Index=gad->xtd.dtd.SelectedRowIndx,Colors.DGR_DataBackGroundSelected,Colors.DGR_DataBackGround)
              'tcol=iif(row->Index=gad->xtd.dtd.SelectedRowIndx,Colors.DGR_TextSelected,Colors.DGR_Text)            
            case 4
              col=iif(cinfo->Index=gad->xtd.dtd.SelectedColumnIndx,Colors.DGR_DataBackGroundSelected,Colors.DGR_DataBackGround) 
              'tcol=iif(cinfo->Index=gad->xtd.dtd.SelectedColumnIndx,Colors.DGR_TextSelected,Colors.DGR_Text)
          end select        
        
          ClearBox    Buffer,gad->xtd.dtd.GrdPosX + ColumnPos,gad->xtd.dtd.GrdPosY + RowPos,cinfo->ColumnWidth,cellheight,col
          drawstring  Buffer,gad->xtd.dtd.GrdPosX + ColumnPos+sGUIMainGap,gad->xtd.dtd.GrdPosY + RowPos+sGUIMainGap,cell->Text,Colors.DGR_Text,2              
          GrdFrame    Buffer,gad->xtd.dtd.GrdPosX + ColumnPos,gad->xtd.dtd.GrdPosY + RowPos,cinfo->ColumnWidth,cellheight         

          ColumnPos += cinfo->ColumnWidth
          cell=cast(sGUIDGCell ptr,cell->next_node)
          cinfo=cast(sGUIDGColumn ptr,cinfo->next_node)           
        loop until (cell=0) or (cinfo=0) or (ColumnPos>=gad->xtd.dtd.GrdWidth)
        
        RowPos +=gad->xtd.dtd.CellHeight
        row=cast(sGUIList ptr,row->next_node)
      loop until (row=0) or (RowPos>=gad->xtd.dtd.GrdHeight)'gibt es keine oder ist die nchste untere Zelle ausserhalb, Abbruch!!!    
    end if
    
    'Rechter Rand Reinigung
    if ColumnPos<gad->xtd.dtd.GrdWidth then'falls dargestellte Spalten kleiner als der "Datenviewport" sind und noch lange Textreste zu sehen sind
      ClearBox    Buffer,gad->xtd.dtd.GrdPosX + ColumnPos,1,gad->xtd.dtd.GrdWidth - ColumnPos,gad->GadHeight-1,Colors.DGR_DataBackGround    
    end if
  end if    
  
  StdFrame Buffer,0,0,gad->GadWidth,gad->GadHeight,Colors.DGR_DataBackGround,Colors.DGR_DataBackGround,0
'SLEEP
    if gad->Activation=2 then Raster Buffer,0,0,gad->GadWidth,gad->GadHeight
end sub


sub SetLayout (gad as Gadget ptr)
  '1px Border !
  'Info Nummerierung,Headerbereich
  gad->xtd.dtd.InfoPosX=1
  gad->xtd.dtd.InfoPosY=1    
  gad->xtd.dtd.InfoWidth=0
  if gad->xtd.dtd.ColumnList->NumNodes>0 then
    if gad->xtd.dtd.RowList->NumNodes then gad->xtd.dtd.InfoWidth=GetTextWidth( str( gad->xtd.dtd.RowList->NumNodes) & "0", 2) + 2*sGUIMainGap
  end if 
  gad->xtd.dtd.InfoHeight=gad->xtd.dtd.CellHeight
  
  'Gridbereich
  gad->xtd.dtd.GrdPosX=gad->xtd.dtd.InfoPosX + gad->xtd.dtd.InfoWidth
  gad->xtd.dtd.GrdPosY=gad->xtd.dtd.InfoPosY + gad->xtd.dtd.InfoHeight
  gad->xtd.dtd.GrdWidth=gad->GadWidth -  gad->xtd.dtd.InfoWidth - 2'-2 ->1 px Border
  gad->xtd.dtd.GrdHeight=gad->GadHeight - gad->xtd.dtd.InfoHeight - 2'-2 ->1 px Border
  
  'Anzahl der Zeilen im Gridbereich
  gad->xtd.dtd.VPNumRows=int(gad->xtd.dtd.GrdHeight/gad->xtd.dtd.CellHeight)
end sub


sub TraceVPRow (gad as Gadget ptr, target as integer=1)
  if gad->xtd.dtd.RowList->NumNodes then
    'Limiter
    gad->xtd.dtd.VPTargetRowIndx=target
    if gad->xtd.dtd.VPTargetRowIndx<1 then gad->xtd.dtd.VPTargetRowIndx=1
    if gad->xtd.dtd.VPTargetRowIndx>gad->xtd.dtd.RowList->NumNodes then gad->xtd.dtd.VPTargetRowIndx=gad->xtd.dtd.RowList->NumNodes    
    
    
    'ID TopRow
    'Verndern der TopRow des VP um Target im Display zu halten:
    'Fall 1:Target wandert nach oben raus
    if gad->xtd.dtd.VPTargetRowIndx < gad->xtd.dtd.VPTopRowIndx then
      gad->xtd.dtd.VPTopRowIndx = gad->xtd.dtd.VPTargetRowIndx
    end if   
    'Fall 2:Target wandert nach unten raus
    if gad->xtd.dtd.VPTargetRowIndx > (gad->xtd.dtd.VPTopRowIndx + (gad->xtd.dtd.VPNumRows -1)) then
      gad->xtd.dtd.VPTopRowIndx = gad->xtd.dtd.VPTargetRowIndx - (gad->xtd.dtd.VPNumRows -1)     
    end if
    '!!! Fall 2 kann bei weniger Zeilen im Grid als darstellbar fr TopRow Werte unter 1 liefern, wird mit folgendem korrigiert:
    if gad->xtd.dtd.VPTopRowIndx<1 then gad->xtd.dtd.VPTopRowIndx=1
    RefreshVPRowAddresses(gad)
    
  else
    gad->xtd.dtd.VPTargetRow    =0
    gad->xtd.dtd.VPTargetRowIndx  =0
    gad->xtd.dtd.VPTopRow       =0
    gad->xtd.dtd.VPTopRowIndx     =0
  end if

  gad->ReDraw=1    
end sub


sub TraceVPColumn (gad as Gadget ptr, target as integer=1)
  dim as integer dircase
  if gad->xtd.dtd.ColumnList->NumNodes then
    
    'Target Limiter
    gad->xtd.dtd.VPTargetColumnIndx=target
    if gad->xtd.dtd.VPTargetColumnIndx<1 then gad->xtd.dtd.VPTargetColumnIndx=1
    if gad->xtd.dtd.VPTargetColumnIndx>gad->xtd.dtd.ColumnList->NumNodes then gad->xtd.dtd.VPTargetColumnIndx=gad->xtd.dtd.ColumnList->NumNodes
    
    '                  wichtig ist hier kleiner gleich
    if gad->xtd.dtd.VPTargetColumnIndx <= gad->xtd.dtd.VPLeftColumnIndx then SetVPLeftbased (gad, gad->xtd.dtd.VPTargetColumnIndx)
    if gad->xtd.dtd.VPTargetColumnIndx > gad->xtd.dtd.VPRightColumnIndx then SetVPRightbased (gad, gad->xtd.dtd.VPTargetColumnIndx)     
    RefreshVPColumnAddresses(gad)  
  else
    gad->xtd.dtd.VPTargetColumn   =0
    gad->xtd.dtd.VPTargetColumnIndx =0
    gad->xtd.dtd.VPLeftColumn     =0
    gad->xtd.dtd.VPLeftColumnIndx   =0
    gad->xtd.dtd.VPRightColumn    =0
    gad->xtd.dtd.VPRightColumnIndx  =0    
  end if

  gad->ReDraw=1    
end sub


sub SetVPLeftbased (gad as Gadget ptr, target as integer=1)
  dim as sGUIDGColumn ptr cinfo
  dim as integer WidthCumulative,overwidth
  gad->xtd.dtd.VPLeftColumnIndx = target
  cinfo=gad->xtd.dtd.ColumnList->GetAddr(gad->xtd.dtd.VPLeftColumnIndx, gad->xtd.dtd.VPLeftColumn) 
  WidthCumulative=cinfo->ColumnWidth
  overwidth=0
  do          
    'Adresse und ID in RightColumn merken
    gad->xtd.dtd.VPRightColumnIndx=cinfo->Index  
    'zum Nachfolger
    cinfo=cast(sGUIDGColumn ptr,cinfo->next_node)
    if cinfo then WidthCumulative +=cinfo->ColumnWidth'wenn Nachfolger vorhanden, dessen Breite hinzu addieren
    if WidthCumulative > gad->xtd.dtd.GrdWidth then overwidth=1'wenn breiter als Gridbreite
  loop until (cinfo=0) or (overwidth=1)'falls Listenende/berbreite Abbruch  
end sub


sub SetVPRightbased (gad as Gadget ptr, target as integer=1) 
  dim as sGUIDGColumn ptr cinfo
  dim as integer WidthCumulative,overwidth
  gad->xtd.dtd.VPRightColumnIndx = target  
  cinfo=gad->xtd.dtd.ColumnList->GetAddr(gad->xtd.dtd.VPRightColumnIndx, gad->xtd.dtd.VPRightColumn)
  WidthCumulative=cinfo->ColumnWidth
  overwidth=0
  do          
    'Adresse und ID in LeftColumn merken
    gad->xtd.dtd.VPLeftColumnIndx=cinfo->Index 
    'zum Vorgnger
    cinfo=cast(sGUIDGColumn ptr,cinfo->prev_node)
    if cinfo then WidthCumulative +=cinfo->ColumnWidth'wenn Vorggnger vorhanden, dessen Breite hinzu addieren
    if WidthCumulative > gad->xtd.dtd.GrdWidth then overwidth=1'wenn breiter als Gridbreite
  loop until (cinfo=0) or (overwidth=1)'falls Listenende/berbreite Abbruch
end sub


sub RefreshVPRowAddresses(gad as Gadget ptr)
  gad->xtd.dtd.VPTopRow       =gad->xtd.dtd.RowList->GetAddr(gad->xtd.dtd.VPTopRowIndx, gad->xtd.dtd.VPTopRow)    
  gad->xtd.dtd.VPTargetRow    =gad->xtd.dtd.RowList->GetAddr(gad->xtd.dtd.VPTargetRowIndx, gad->xtd.dtd.VPTopRow)
end sub


sub RefreshVPColumnAddresses(gad as Gadget ptr)
  gad->xtd.dtd.VPLeftColumn     =gad->xtd.dtd.ColumnList->GetAddr(gad->xtd.dtd.VPLeftColumnIndx, gad->xtd.dtd.VPLeftColumn)
  gad->xtd.dtd.VPTargetColumn   =gad->xtd.dtd.ColumnList->GetAddr(gad->xtd.dtd.VPTargetColumnIndx, gad->xtd.dtd.VPLeftColumn)
  gad->xtd.dtd.VPRightColumn    =gad->xtd.dtd.ColumnList->GetAddr(gad->xtd.dtd.VPRightColumnIndx, gad->xtd.dtd.VPTargetColumn)
end sub


sub CreateColumn(gad as Gadget ptr, cname as string, cwidth as integer=80)
  dim as sGUIList ptr row
  dim as sGUIDGColumn ptr cinfo  
  cinfo=gad->xtd.dtd.ColumnList->AppendNew(sGUIDGColumnType)  
  cinfo->Text=cname
  cinfo->ColumnWidth=cwidth

  if gad->xtd.dtd.RowList->NumNodes then'wenn Zeilen existieren dann jeder Zeile eine Zelle(Spalte) hinzufgen 
    row=gad->xtd.dtd.RowList->GetFirst
    do
      row->AppendNew(sGUIDGCellType)
      row=cast(sGUIList ptr,row->next_node)
    loop until row=0
  end if
  gad->ReDraw=1
end sub


sub CreateRow(gad as Gadget ptr,num as integer=1)
  dim as sGUIList ptr row
  dim as sGUIDGColumn ptr cinfo 
  if gad->xtd.dtd.ColumnList->NumNodes>0 then'nur wenn Spalten(-definitionen) in ColumnList existieren, knnen auch Zeilen erzeugt werden
    for i as integer=1 to num
      row=gad->xtd.dtd.RowList->AppendNew(sGUIListType)
      if row then
        for k as integer=1 to gad->xtd.dtd.ColumnList->NumNodes'soviel Zellen hinzufgen, wie es Spalten gibt
          row->AppendNew(sGUIDGCellType)
        next k
      end if
    next i
  end if
  gad->ReDraw=1
end sub


function GetSelColumn(gad as Gadget ptr, GadPosX as integer, GadPosY as integer) as integer
  function=0
  dim as sGUIList ptr column
  dim as sGUIDGColumn ptr cinfo    
  dim as integer found,ColumnPosCumulative
  found=0
  
  if gad->xtd.dtd.ColumnList->NumNodes then
    cinfo=gad->xtd.dtd.VPLeftColumn
    ColumnPosCumulative=GadPosX + gad->xtd.dtd.GrdPosX         
    do
      if (MOUSEX>=ColumnPosCumulative) and (MOUSEX<(ColumnPosCumulative + cinfo->ColumnWidth)) then
        gad->xtd.dtd.SelectedColumnIndx=cinfo->Index
        gad->xtd.dtd.SelectedColumn=cinfo
        gad->xtd.dtd.EditPosXGlobal=ColumnPosCumulative
        found=1
      end if
      ColumnPosCumulative +=cinfo->ColumnWidth
      cinfo=cast(sGUIDGColumn ptr,cinfo->next_node)'Spaltenwechsel
    loop until (cinfo=0) or (found=1)          
  end if
  if found=0 then function=1  
end function


function GetSelRow(gad as Gadget ptr, GadPosX as integer, GadPosY as integer) as integer
  function=0
  gad->xtd.dtd.SelectedRowIndx=int((MOUSEY - (GadPosY + gad->xtd.dtd.InfoPosY))/gad->xtd.dtd.CellHeight) + gad->xtd.dtd.VPTopRowIndx - 1   
  gad->xtd.dtd.SelectedRow=GetRowAddr(gad,gad->xtd.dtd.SelectedRowIndx)
  if gad->xtd.dtd.SelectedRowIndx > gad->xtd.dtd.RowList->NumNodes then 
    function=1
  else
    gad->xtd.dtd.EditPosYGlobal =GadPosY + 1 + int((MOUSEY-GadPosY-1)/gad->xtd.dtd.CellHeight)*gad->xtd.dtd.CellHeight
  end if
end function


function GetRowAddr(gad as Gadget ptr, rowid as integer) as _sGUIList ptr
  if (rowid>0) and (rowid<=gad->xtd.dtd.RowList->NumNodes) then
    function=gad->xtd.dtd.RowList->GetAddr(rowid,gad->xtd.dtd.VPTopRow)
  else
    function=0
  end if
end function 


function GetCellAddr(gad as Gadget ptr, rowid as integer, columnid as integer) as _sGUIDGCell ptr
  dim as sGUIDGCell ptr cell
  dim as _sGUIList ptr row
  cell=0
  row=GetRowAddr(gad,rowid)
  if row then
    if (columnid>0) and (columnid<=gad->xtd.dtd.ColumnList->NumNodes) then
      cell=row->GetAddr(columnid)
    else
      cell=0
    end if
  end if
  function=cell
end function 
  
end namespace

