#include once "Gadget_ListBox.bas"
namespace sGUI

declare function AddDropDownListBox (win as sGUIWindow ptr,PosX as integer,PosY as integer,GadWidth as integer,GadHeight as integer,ListBoxWidth as integer=200,ListBoxHeight as integer=100, mode as integer=0) as Gadget ptr
declare function DDL_Actions(gad as Gadget ptr,action as integer) as integer
declare sub DDL_ExtendedAction (xaction as ExtendedAction ptr)
declare sub DDL_Draw (gad as Gadget ptr)
declare function GetDDListBox(gad as Gadget ptr) as integer
declare sub SetDDListBox(gad as Gadget ptr,i as integer,Selection as integer=1)
declare function RollSelection(gad as Gadget ptr,initindex as integer) as integer
/'
type DDL_Data
	WinExternal		as _sGUIWindow ptr
	ListBox				as _Gadget ptr
  mode          as integer
end type
'/
function AddDropDownListBox (win as sGUIWindow ptr,PosX as integer,PosY as integer,GadWidth as integer,GadHeight as integer,ListBoxWidth as integer=200,ListBoxHeight as integer=100, mode as integer=0) as Gadget ptr
	function=0  
	dim as Gadget ptr gad,Listbox
	dim as sGUIWindow ptr winext
	dim as ExtendedAction ptr xaction
	if win=0 then win=RootWindow
	gad=win->GadgetList->AppendNew (GadgetType)
	if gad then
		gad->parent=win
		gad->Selection=0
		gad->Activation=0
		gad->PosX=PosX
		gad->PosY=PosY
		gad->Text=""

		gad->GadWidth=GadWidth
		gad->GadHeight=GadHeight
    gad->DrawBuffer->img=imagecreate(gad->GadWidth,Gad->GadHeight)
		gad->DoDraw     =@DDL_Draw
		gad->DoAction   =@DDL_Actions
		winext= AddWindow(0,10,10,ListBoxWidth,ListBoxHeight,,WFLAG_HIDECLICKEDOUTSIDE or WFLAG_NOSELECT or WFLAG_ALWAYSONTOP )' or WFLAG_WARNIGNORE)
		if winext then			
      gad->xtd.ddl.WinExternal=winext
			Listbox=AddListBox(winext,0,0,ListBoxWidth,ListBoxHeight,0,0)
			if Listbox then
				gad->xtd.ddl.ListBox=Listbox
				GadgetOn(Listbox)
				xaction=ExtendedActionList->AppendNew (ExtendedActionType)
				if xaction then
					xaction->cause_gad				=Listbox				
					xaction->DoExtendedAction	=@DDL_ExtendedAction
					xaction->effect_gad			  =gad
				end if
        gad->xtd.EntryList =gad->xtd.ddl.ListBox->xtd.EntryList'Listenzeiger aus Listbox holen und in die DDListBox kopieren
			end if
		end if
    'da der Knob nun abgerundete Ecken hat und ich ihn desswegen transparent in den
    'Container kopieren muss, bekommt der Knob nun ein eigenes Image, das dann per Put(),TRANS in den Container kommt   
    gad->xtd.ddl.SymbolGFXLayer=ImageList->AppendNew(sGUIImageType)    
    gad->xtd.ddl.SymbolGFXLayer->img=imagecreate(sGUIMainSize, GetFontHeight)    
    
    gad->xtd.ddl.mode=mode
    gad->DeviceFlags=DFLAG_LMB  
		function=gad
	end if
end function


sub DDL_ExtendedAction (xaction as ExtendedAction ptr)
	dim as Gadget ptr src,dest
	dim as sGUIList ptr EList
	dim as sGUIEntry ptr entry
	dim as integer entrynum	
	src=xaction->cause_gad
	dest=xaction->effect_gad
	EList=dest->xtd.EntryList	
	entrynum=GetListBox(src)		
	
  HideWindow(cast(sGUIWindow ptr,src->parent))
	
  dest->Text=GetEntryAddr(EList,entrynum)->Text
	dest->ReDraw=1
	
  GADGETMESSAGE=dest
	WINDOWMESSAGE=cast(sGUIWindow ptr,dest->parent)
  cast(sGUIWindow ptr,dest->parent)->Selection=1
end sub


function DDL_Actions(gad as Gadget ptr,action as integer) as integer
  function=0  
	dim as sGUIWindow ptr winext
	dim as integer PosX,PosY,selectedEntry,dropdownaction,rollaction
  dim as sGUIList ptr EList
  dropdownaction=0
  rollaction=0
  winext=cast(sGUIWindow ptr,gad->xtd.ddl.WinExternal)
	select case action
    case GADGET_LMBHIT
      SetSelect (gad,1)
      GetGlobalPosition(gad,PosX,PosY)     
      select case gad->xtd.ddl.mode
        case 0
          dropdownaction=1        
        case 1
          if MOUSEX<PosX+gad->GadWidth-(sGUIMainSize+1) then dropdownaction=1
        case 2
          if MOUSEX>=PosX+gad->GadWidth-(sGUIMainSize+1) then dropdownaction=1              
      end select
      
    case GADGET_LMBHOLD    
      SetSelect (gad,1)
      
    case GADGET_LMBRELEASE     
      SetSelect (gad,0)
      GetGlobalPosition(gad,PosX,PosY)
      select case gad->xtd.ddl.mode
        case 1
          if MOUSEX>=PosX+gad->GadWidth-(sGUIMainSize+1) then rollaction=1          
        case 2
          if MOUSEX<PosX+gad->GadWidth-(sGUIMainSize+1) then rollaction=1
        case 3
          rollaction=1
      end select    
     
    case GADGET_LMBHOLDOFF,GADGET_LMBRELEASEOFF         
      SetSelect (gad,0)

    case GADGET_MOUSEHOVER  
      gad->MouseHover=1

    case GADGET_MOUSENEXT  
      gad->MouseHover=0       
  end select
  
  if dropdownaction then
    winext->PosX=PosX
    winext->PosY=PosY+gad->GadHeight+1
    if winext->PosX<0 then winext->PosX=0
    if winext->PosY<0 then winext->PosY=0
    if (winext->PosX + winext->WinWidth) > ScrnWidth then winext->PosX=ScrnWidth - winext->WinWidth
    if (winext->PosY + winext->WinHeight) > ScrnHeight then winext->PosY=ScrnHeight - winext->WinHeight
    winext->Selection=1				
    ShowWindow(winext)  
  end if
  
  if rollaction then
    EList=gad->xtd.EntryList
    selectedEntry=GetDDListBox(gad)'bisherige Selektion holen
    selectedEntry=RollSelection(gad,selectedEntry)'Weiterrollen mit ActivationCheck   
    SetDDListBox(gad,selectedEntry)'neue Selektion setzen
    if selectedEntry then function=1
  end if 
end function


sub DDL_Draw (gad as Gadget ptr)
	dim as integer GadWidth,GadHeight,TextPosX,TextPosY,ArrowBoxWidth
	dim as ulong col
  dim as FB.Image ptr Buffer,SymbolBuffer
	GadWidth =gad->GadWidth
	GadHeight=gad->GadHeight
	TextPosX =sGUIMainGap
	TextPosY =int((GadHeight-GetFontHeight)/2)
	Buffer   =gad->DrawBuffer->img
  SymbolBuffer      =gad->xtd.ddl.SymbolGFXLayer->img
	'OFF 
	ClearBox Buffer,0,0,GadWidth,GadHeight
	'ON   unselect/select
	if gad->Activation then
		if gad->MouseHover then
      col=iif(gad->Selection,Colors.HoverFXTextSelected,Colors.HoverFXText)
    else
			col=iif(gad->Selection,Colors.GadTextSelected,Colors.GadText)
    end if
    StdFilledBoxRounded Buffer,0,0,GadWidth,GadHeight,,,gad->Selection,gad->MouseHover
    drawstring (Buffer, TextPosX, TextPosY, gad->Text,col)
    
    '!!! SymbolBox hat nun eigenes Image das transparent ins Image der DDLBox kopiert wird
    FilledBoxDrop SymbolBuffer,,,gad->Selection,gad->MouseHover,gad->xtd.ddl.mode
    put Buffer,(GadWidth-sGUIMainSize-1,TextPosY),SymbolBuffer,trans
		
    'SLEEP
		if gad->Activation=2 then Raster Buffer,0,0,GadWidth,GadHeight
	end if
end sub


function GetDDListBox(gad as Gadget ptr) as integer
  function=GetListBox( cast(Gadget ptr,gad->xtd.ddl.ListBox) )
end function


sub SetDDListBox(gad as Gadget ptr,i as integer, Selection as integer=1)
  if i>0 then
    if SetListBox( cast(Gadget ptr,gad->xtd.ddl.ListBox), i , Selection) then gad->Text=GetEntryText(gad->xtd.EntryList, i)
  else
    gad->Text=""
  end if
end sub


function RollSelection(gad as Gadget ptr,initindex as integer) as integer
	dim as sGUIList ptr EList
	dim as sGUIEntry ptr entry
  dim as integer startindex,found,counter
  EList=gad->xtd.EntryList
  entry=EList->GetAddr(initindex)
  counter=0
  found=0
  do
    counter +=1
    entry=cast(sGUIEntry ptr,entry->next_node)
    if entry=0 then entry=EList->GetFirst
    
    if entry->Activation=1 then found=entry->index
  loop until found>0 or (counter>=EList->NumNodes)
  function=found
end function

end namespace
