#include once "Gadget_ListBox_Selector.bas"
#include once "Gadget_ScrollBar.bas"

namespace sGUI

declare function AddListBox (win as sGUIWindow ptr,PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,DisplayMode as integer=0,SelectionMode as integer=0) as any ptr
declare sub LBX_Actions(win as sGUIWindow ptr)
declare sub LBX_Update(win as sGUIWindow ptr)

declare function GetListBox(thing as any ptr, index as integer=0) as integer
declare function SetListBox(thing as any ptr,i as integer,Selection as integer=1) as integer
/'
'ListBox
type LBX_Data
	DisplayMode	      as integer
	SelectionMode     as integer	
	NumEntriesRef			as integer
  TimeStamp         as double
	selector				  as _Gadget ptr
	scrollbar					as _Gadget ptr	
end type
'/
function AddListBox(win as sGUIWindow ptr,PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,DisplayMode as integer=0,SelectionMode as integer=0) as any ptr
  function=0
  dim as sGUIWindow ptr gwin
  if win=0 then win=RootWindow
  gwin=AddWindow(win,PosX,PosY,BoxWidth,BoxHeight,,WFLAG_GADGETMODE)  
  if gwin then
    gwin->Activation=1
    gwin->xtd.lbx.DisplayMode   =DisplayMode
    gwin->xtd.lbx.SelectionMode =SelectionMode		  
    gwin->xtd.lbx.selector      =AddListBoxSelector(gwin,0,0,BoxWidth-(sGUIMainSize+1),BoxHeight,DisplayMode,SelectionMode)
    gwin->xtd.lbx.scrollbar     =AddScrollBar(gwin,BoxWidth-sGUIMainSize,0,BoxHeight,1,1,1,1,1)					
    gwin->xtd.EntryList         =gwin->xtd.lbx.selector->xtd.EntryList'Listenzeiger aus Selector holen und in die ListBox kopieren
    gwin->DoAction              =@LBX_Actions
    gwin->DoUpdate              =@LBX_Update   
    function=gwin
  end if
end function


sub LBX_Actions(win as sGUIWindow ptr)
  if GADGETMESSAGE then       
    select case GADGETMESSAGE
      case win->xtd.lbx.selector
        GADGETMESSAGE=cast(any ptr,win)
        WINDOWMESSAGE=win
      
      case win->xtd.lbx.scrollbar
        VScrollLBS(win->xtd.lbx.selector,GetScrollBar(win->xtd.lbx.scrollbar))
    end select
  end if
end sub


sub LBX_Update(win as sGUIWindow ptr)
  dim as sGUIList ptr EList
	dim as sGUIEntry ptr entry
  dim as integer TotalNumRows	
	EList=win->xtd.EntryList
  TotalNumRows=EList->NumNodes
	'falls Eintragsliste verndert wurde
  if win->xtd.lbx.TimeStamp <> win->xtd.EntryList->GetTimeStamp then
		win->xtd.lbx.NumEntriesRef=TotalNumRows
    if (win->xtd.lbx.selector->xtd.lbs.SelectedRow>TotalNumRows) or (win->xtd.lbx.selector->xtd.lbs.SelectedRow<1) then win->xtd.lbx.selector->xtd.lbs.SelectedRow=0   
		SetScrollBar(win->xtd.lbx.scrollbar,1,TotalNumRows,1,win->xtd.lbx.selector->xtd.lbs.NumRows)
    VScrollLBS(win->xtd.lbx.selector,1)
    win->xtd.lbx.TimeStamp = win->xtd.EntryList->GetTimeStamp
    win->xtd.lbx.selector->ReDraw=1
  end if
  'Fall kann nur auftreten wenn per Wheel im Selector gescrollt wurde
  'Scrollbar an Selector anpassen
  if win->xtd.lbx.selector->xtd.lbs.TopRow  <> GetScrollBar(win->xtd.lbx.scrollbar) then
    SetScrollBar(win->xtd.lbx.scrollbar, win->xtd.lbx.selector->xtd.lbs.TopRow)
  end if  
end sub


function GetListBox(thing as any ptr,index as integer=0) as integer
  dim as sGUIWindow ptr win=cast(sGUIWindow ptr, thing)
  dim as sGUIList ptr EList
	dim as sGUIEntry ptr entry
  dim as integer result
  
	EList=win->xtd.EntryList
  if index=0 then 
    entry=EList->GetFirst  
  else                                'haben wir einen Index als Startpunkt fr fortgesetzte Suche bergeben
    entry=GetEntryAddr(EList,index)   'dessen Adresse holen
    if entry=Elist->GetLast then      'sollte dieser der letzte der Liste sein
      entry=0                         'braucht nicht weitergesucht werden
    else                              'ist er nicht der letzte Eintrag in der Liste
      'entry=GetEntryAddr(EList,index+1)'seinen Nachfolger als Suchbeginn definieren
      entry=cast(sGUIEntry ptr,entry->next_node)'oder Nachfolger via DLL
    end if
  end if
  
  index=0
  
  if entry then
    do
      if entry->Selection then index=entry->index 
      entry=cast(sGUIEntry ptr,entry->next_node)
    loop until (entry=0) or (index<>0)
  end if
  
  function=index
end function


function SetListBox(thing as any ptr,i as integer,Selection as integer=1) as integer   
  dim as sGUIWindow ptr win=cast(sGUIWindow ptr, thing)  
  dim as sGUIList ptr EList
	dim as sGUIEntry ptr entry	
	EList=win->xtd.EntryList
  
  win->xtd.lbx.selector->ReDraw=1   
  entry=GetEntryAddr(EList,i) 
  if entry then
     function=1
     select case win->xtd.lbx.SelectionMode
        case 0 'single select
          if Selection then
            UnselectEntryList(EList)
            entry->Selection=Selection
            win->xtd.lbx.selector->xtd.lbs.SelectedRow=entry->Index
            SetScrollBar(win->xtd.lbx.scrollbar,win->xtd.lbx.selector->xtd.lbs.SelectedRow)
            VScrollLBS(win->xtd.lbx.selector,GetScrollBar(win->xtd.lbx.scrollbar))
          end if
  
        case 1'single deselectable
          if (entry->Selection)=1 then
            entry->Selection=Selection          
          else
            if Selection=1 then
              UnselectEntryList(EList)
              entry->Selection=1
              SetScrollBar(win->xtd.lbx.scrollbar,win->xtd.lbx.selector->xtd.lbs.SelectedRow)
              VScrollLBS(win->xtd.lbx.selector,GetScrollBar(win->xtd.lbx.scrollbar))
            end if
          end if      				            
       
        case 2'multi deselectable 
          entry->Selection=Selection              
          
      end select   
  else
    function=0
  end if
end function

end namespace
