namespace sGUI

declare function AddMenuGadget (entry as sGUIEntry ptr, win as sGUIWindow ptr=0) as Gadget ptr
declare function AddMenuItem (entry as sGUIEntry ptr) as Gadget ptr
declare function AddMenuCheckMark (entry as sGUIEntry ptr) as Gadget ptr
declare function AddMenuRadioButton (entry as sGUIEntry ptr) as Gadget ptr
declare function AddMenuOpen (entry as sGUIEntry ptr) as Gadget ptr
declare function AddWinMenuOpen (entry as sGUIEntry ptr) as Gadget ptr
declare function AddMenuSeparator (entry as sGUIEntry ptr) as Gadget ptr

declare function MIT_Actions(gad as Gadget ptr,action as integer) as integer
declare function MCM_Actions(gad as Gadget ptr,action as integer) as integer
declare function MRB_Actions(gad as Gadget ptr,action as integer) as integer
declare function MOP_Actions(gad as Gadget ptr,action as integer) as integer
declare function MWOP_Actions(gad as Gadget ptr,action as integer) as integer
declare function MSP_Actions(gad as Gadget ptr,action as integer) as integer

declare sub MIT_Draw (gad as Gadget ptr)
declare sub MCM_Draw (gad as Gadget ptr)
declare sub MRB_Draw (gad as Gadget ptr)
declare sub MOP_Draw (gad as Gadget ptr)
declare sub MWOP_Draw (gad as Gadget ptr)
declare sub MSP_Draw (gad as Gadget ptr)

declare sub MGT_Update(gad as Gadget ptr) 

declare sub CreatePopUpMenu(menulist as sGUIList ptr)
declare sub CreateWindowMenu(menulist as sGUIList ptr, win as sGUIWindow ptr)

declare function GetNumGroups (menulist as sGUIList ptr) as integer
declare sub ModifyGroupZero (menulist as sGUIList ptr, win as sGUIWindow ptr)
declare sub AdjustGroupMembers (menulist as sGUIList ptr, group as integer, byref SWWidth as integer, byref SWHeight as integer)
declare function CreateGroupWindow (menulist as sGUIList ptr,group as integer, SWWidth as integer, SWHeight as integer ) as sGUIWindow ptr
declare sub CreateGroupGadgets (menulist as sGUIList ptr,group as integer) 
declare function CreateMenuGadget (entry as sGUIEntry ptr) as Gadget ptr

declare sub OpenPopUpMenu(menulist as sGUIList ptr, PosX as integer, PosY as integer)
declare sub HideAllMenuWindows
declare sub LocateMenuWindow (win as sGUIWindow ptr, PosX as integer, PosY as integer, mode as integer=0)
declare sub OpenStripWindowPath (entry as sGUIEntry ptr, PosX as integer, PosY as integer)

declare function FoundInList (list as sGUIList ptr, thing as any ptr) as integer
'siehe MCP.bas und nach end namespace am Ende dieser .bas
'dort erfolgt die "Zuweisung" dieser Sub ausserhalb des Namespaces als "ausfhrbarer Code"
declare sub MenuHandler(win as sGUIWindow ptr)

/'
type MNG_Data
	MenuEntry
  TimeStamp  
end type
'/

'**********************************************************
function AddMenuGadget (entry as sGUIEntry ptr, win as sGUIWindow ptr=0) as Gadget ptr
	function=0  
	dim as Gadget ptr gad
  dim as node ptr LL_node
  dim as sGUIList ptr list
  win=entry->StripWindow
	
  if win then
    list=win->WinGadgetList    
  else
    list=win->GadgetList  
  end if
  gad=list->AppendNew (GadgetType)
  
  if gad then
    'Anhngen dieses Gadgets an eine "universelle" PointerListe speziell fr Meneintrge, dient der noch ungenutzen leichteren(?) Verarbeitung
    LL_node=MenuGadgetList->AppendNew (NodeType) 
    LL_node->anypointer=gad		
    
    gad->parent=win
    gad->Selection  =entry->Selection 
		gad->Activation =entry->Activation
		if gad->Activation<>1 then gad->Activation=2
    gad->PosX       =entry->PosX
		gad->PosY       =entry->PosY
		gad->GadWidth   =entry->EntryWidth
		gad->GadHeight  =entry->EntryHeight
		gad->Text       =entry->Text       
  
    gad->xtd.mng.MenuEntry  =entry
    entry->MenuGadget       =gad
    
    gad->DrawBuffer->img    =imagecreate(gad->GadWidth,Gad->GadHeight)
    
    'Timer gleichsetzen
    gad->xtd.mng.TimeStamp=timer
    gad->xtd.mng.MenuEntry->TimeStamp =  gad->xtd.mng.TimeStamp
    
    gad->DoUpdate           =@MGT_Update'eine Update-Routine fr alle MenGadgets
    gad->DeviceFlags=DFLAG_LMB	
    function=gad
	end if
end function


sub MGT_Update(gad as Gadget ptr) 
  if gad->xtd.mng.TimeStamp <> gad->xtd.mng.MenuEntry->TimeStamp then'falls Daten im Gadget oder MenListenEintrag unerschiedlich alt sind 
  
    if gad->xtd.mng.TimeStamp > gad->xtd.mng.MenuEntry->TimeStamp then
      'Daten im Gadget sind aktueller, d.h EXPORT
      'Gadget --> Entry
      gad->xtd.mng.MenuEntry->TimeStamp = gad->xtd.mng.TimeStamp'Zeiten angleichen      
      gad->xtd.mng.MenuEntry->Selection = gad->Selection
      gad->xtd.mng.MenuEntry->Activation=iif(gad->Activation=1,1,0)

         
    else
      'Daten im Eintrag sind aktueller, d.h IMPORT  
      'Entry --> Gadget
      gad->xtd.mng.TimeStamp  = gad->xtd.mng.MenuEntry->TimeStamp'Zeiten angleichen   
      gad->Selection          = gad->xtd.mng.MenuEntry->Selection
      gad->Activation         = iif(gad->xtd.mng.MenuEntry->Activation=1,1,2)    
      gad->ReDraw=1    
    end if   
  end if
end sub


'**********************************************************


function AddMenuItem (entry as sGUIEntry ptr) as Gadget ptr
	function=0  
	dim as Gadget ptr gad
  gad=AddMenuGadget (entry)
  if gad then
    gad->DoDraw             =@MIT_Draw
    gad->DoAction           =@MIT_Actions
    function=gad
  end if
end function


function MIT_Actions(gad as Gadget ptr,action as integer) as integer
  'dim as sGUIEntry entry
  'entry=gad->xtd.mng.MenuEntry
  function=0
  select case action
    case GADGET_LMBHIT
      SetSelect (gad,0)  
      MENUBASE=gad->xtd.mng.MenuEntry->Owner
      MENUID=gad->xtd.mng.MenuEntry->Index   
      function=1
    case GADGET_MOUSEHOVER   'Mouse berm Control
      gad->MouseHover=1
    
    case GADGET_MOUSENEXT   'Mouse vom Control wegbewegt
      gad->MouseHover=0       
  end select
end function


sub MIT_Draw (gad as Gadget ptr)
  dim as integer GadPosX,GadPosY,GadWidth,GadHeight,TextPosX,TextPosY
  dim as FB.Image ptr Buffer
  
  GadPosX     =gad->PosX
  GadPosY     =gad->PosY
  GadWidth    =gad->GadWidth
	GadHeight   =gad->GadHeight
  TextPosX    =gad->xtd.mng.MenuEntry->TextPosX
	TextPosY    =gad->xtd.mng.MenuEntry->TextPosY
  Buffer      =gad->DrawBuffer->img	
    
	'OFF 
	ClearBox Buffer,0,0,GadWidth,GadHeight
'ON   unselect/select
  if gad->Activation then
		if gad->MouseHover then
      ClearBox Buffer,0,0,GadWidth,GadHeight,Colors.MNG_HoverFX
      drawstring (Buffer, TextPosX, TextPosY, gad->Text,Colors.MNG_HoverFXText,2)
    else
      ClearBox Buffer,0,0,GadWidth,GadHeight,Colors.MNG_BackGround    
			drawstring (Buffer, TextPosX, TextPosY, gad->Text, Colors.MNG_Text,2)
    end if
		'SLEEP
		if gad->Activation=2 then 
      ClearBox Buffer,0,0,GadWidth,GadHeight,Colors.MNG_BackGround
      drawstring (Buffer, TextPosX, TextPosY, gad->Text, Colors.MNG_TextInactive,2)
    end if
	end if
end sub


'**********************************************************


function AddMenuSeparator (entry as sGUIEntry ptr) as Gadget ptr
	function=0  
	dim as Gadget ptr gad
  gad=AddMenuGadget (entry)
  if gad then
		gad->DoDraw             =@MSP_Draw
		gad->DoAction           =@MSP_Actions
    function=gad
  end if  
end function


sub MSP_Draw (gad as Gadget ptr)
  dim as integer GadWidth,GadHeight,BarPosX,BarPosY,BarWidth,BarHeight
  dim as FB.Image ptr Buffer
  
  GadWidth    =gad->GadWidth
	GadHeight   =gad->GadHeight
  BarWidth    =GadWidth/3' - 4*sGUIMainSize
  BarHeight   =1
  BarPosX     =(GadWidth-BarWidth)/2
  BarPosY     =(GadHeight-BarHeight)/2
  Buffer   =gad->DrawBuffer->img	
    
	ClearBox Buffer,0,0,GadWidth,GadHeight,Colors.MNG_BackGround
  
  ClearBox Buffer,BarPosX,BarPosY,BarWidth,BarHeight,Colors.MNG_TextInactive
  
end sub

function MSP_Actions(gad as Gadget ptr,action as integer) as integer
  function=0
end function


'**********************************************************


function AddMenuCheckMark (entry as sGUIEntry ptr) as Gadget ptr
	function=0  
	dim as Gadget ptr gad
  gad=AddMenuGadget (entry)
  if gad then
    gad->DoDraw             =@MCM_Draw
    gad->DoAction           =@MCM_Actions
    function=gad
  end if
end function


function MCM_Actions(gad as Gadget ptr,action as integer) as integer
  'dim as sGUIEntry entry
  'entry=gad->xtd.mng.MenuEntry
  function=0
  select case action
    case GADGET_LMBHIT
      SetSelect(gad,iif(GetSelect(gad),0,1))
      gad->xtd.mng.TimeStamp=timer
      MENUBASE=gad->xtd.mng.MenuEntry->Owner
      MENUID=gad->xtd.mng.MenuEntry->Index       
      function=1      
    
    case GADGET_MOUSEHOVER   'Mouse berm Control
      gad->MouseHover=1
    
    case GADGET_MOUSENEXT   'Mouse vom Control wegbewegt
      gad->MouseHover=0       
  end select
end function


sub MCM_Draw (gad as Gadget ptr)
  dim as integer GadPosX,GadPosY,GadWidth,GadHeight,TextPosX,TextPosY,SymbolSize,SymbolPosX,SymbolPosY
  dim as FB.Image ptr Buffer
  
  GadPosX     =gad->PosX
  GadPosY     =gad->PosY
  GadWidth    =gad->GadWidth
	GadHeight   =gad->GadHeight
  TextPosX    =gad->xtd.mng.MenuEntry->TextPosX
	TextPosY    =gad->xtd.mng.MenuEntry->TextPosY
  SymbolSize  =gad->xtd.mng.MenuEntry->SymbolSize
  SymbolPosX  =gad->xtd.mng.MenuEntry->SymbolLPosX
  SymbolPosY  =gad->xtd.mng.MenuEntry->SymbolLPosY
  Buffer      =gad->DrawBuffer->img	
    
	'OFF 
	ClearBox Buffer,0,0,GadWidth,GadHeight
'ON   unselect/select
  if gad->Activation then
		if gad->MouseHover then
      ClearBox Buffer,0,0,GadWidth,GadHeight,Colors.MNG_HoverFX
      drawstring (Buffer, TextPosX, TextPosY, gad->Text,Colors.MNG_HoverFXText,2)
      if gad->Selection then Symbol_CheckMark (Buffer,SymbolPosX,SymbolPosY,SymbolSize,Colors.MNG_HoverFXText)
    else
      ClearBox Buffer,0,0,GadWidth,GadHeight,Colors.MNG_BackGround    
			drawstring (Buffer, TextPosX, TextPosY, gad->Text, Colors.MNG_Text,2)
      if gad->Selection then Symbol_CheckMark (Buffer,SymbolPosX,SymbolPosY,SymbolSize,Colors.MNG_Text)      
    end if
		'SLEEP
		if gad->Activation=2 then 
      ClearBox Buffer,0,0,GadWidth,GadHeight,Colors.MNG_BackGround
      drawstring (Buffer, TextPosX, TextPosY, gad->Text, Colors.MNG_TextInactive,2)
      if gad->Selection then Symbol_CheckMark (Buffer,SymbolPosX,SymbolPosY,SymbolSize,Colors.MNG_TextInactive)      
    end if
	end if
end sub


'**********************************************************


function AddMenuRadioButton (entry as sGUIEntry ptr) as Gadget ptr
	function=0  
	dim as Gadget ptr gad,groupfirstgad
  dim as node ptr n
  dim as sGUIEntry ptr groupfirstentry
  dim as sGUIList ptr mbase
  mbase=entry->Owner  
  gad=AddMenuGadget (entry)
  if gad then
    gad->DoDraw             =@MRB_Draw
    gad->DoAction           =@MRB_Actions
    if entry->QualifierB=0 then' Entry-QualifierB = ID des RB-Header
      gad->xtd.mng.RBList = sGUI.PointersLists->AppendNew (sGUIListType)'eine einfache (Zeiger)Liste fr die Gruppe erzeugen
    else
      groupfirstentry=mbase->GetAddr(entry->QualifierB)'aus Menubase den Eintrag des "Headers" der RB-Gruppe holen
      groupfirstgad=groupfirstentry->MenuGadget'aus dem Eintrag dann das dazugehrige Gadget holen
      gad->xtd.mng.RBList = groupfirstgad->xtd.mng.RBList'die dort hinterlegte Adresse der Pointerliste in dieses Gadget bertragen um leichter Zugriff zu haben
    end if

    n=gad->xtd.mng.RBList->AppendNew (nodeType)'in der Liste einen node als "Informationstrger" erzeugen
    n->anypointer=cast(any ptr,gad)'den Zeiger dieses Controls in den node schreiben       
    function=gad
  end if
end function


function MRB_Actions(gad as Gadget ptr,action as integer) as integer
  'dim as sGUIEntry entry
  'entry=gad->xtd.mng.MenuEntry
  dim as Gadget ptr g
  dim as node ptr n
  dim as sGUIList ptr lst
 function=0
  select case action
    case GADGET_LMBHIT
      lst=gad->xtd.mng.RBList'Adresse der "GruppenPointerListe"
      n=lst->GetFirst
      do
        g=cast(Gadget ptr,n->anypointer)
        if g=gad then
          SetSelect(g,1)        
        else
          SetSelect(g,0)
        end if
        g->xtd.mng.TimeStamp=timer
        n=n->next_node
      loop until n=0      
      
      MENUBASE=gad->xtd.mng.MenuEntry->Owner
      MENUID=gad->xtd.mng.MenuEntry->Index                   
      function=1      
    
    case GADGET_MOUSEHOVER   'Mouse berm Control
      gad->MouseHover=1
    
    case GADGET_MOUSENEXT   'Mouse vom Control wegbewegt
      gad->MouseHover=0       
  end select
end function


sub MRB_Draw (gad as Gadget ptr)
  dim as integer GadPosX,GadPosY,GadWidth,GadHeight,TextPosX,TextPosY,SymbolSize,SymbolPosY,SymbolPosX
  dim as FB.Image ptr Buffer
  
  GadPosX     =gad->PosX
  GadPosY     =gad->PosY
  GadWidth    =gad->GadWidth
	GadHeight   =gad->GadHeight
  TextPosX    =gad->xtd.mng.MenuEntry->TextPosX
	TextPosY    =gad->xtd.mng.MenuEntry->TextPosY
  SymbolSize  =GetFontHeight(2)/4'sGUIMainGap
  SymbolPosY   =GadHeight/2
  SymbolPosX   =TextPosX/2
  Buffer      =gad->DrawBuffer->img	
    
	'OFF 
	ClearBox Buffer,0,0,GadWidth,GadHeight
'ON   unselect/select
  if gad->Activation then
		if gad->MouseHover then
      ClearBox Buffer,0,0,GadWidth,GadHeight,Colors.MNG_HoverFX
      drawstring (Buffer, TextPosX, TextPosY, gad->Text,Colors.MNG_HoverFXText,2)
      if gad->Selection then DrawMenuRBDot (Buffer,SymbolPosX,SymbolPosY,SymbolSize,Colors.MNG_HoverFXText)      
    else
      ClearBox Buffer,0,0,GadWidth,GadHeight,Colors.MNG_BackGround    
			drawstring (Buffer, TextPosX, TextPosY, gad->Text, Colors.MNG_Text,2)
      if gad->Selection then DrawMenuRBDot (Buffer,SymbolPosX,SymbolPosY,SymbolSize,Colors.MNG_Text)      
    end if
		'SLEEP
		if gad->Activation=2 then 
      ClearBox Buffer,0,0,GadWidth,GadHeight,Colors.MNG_BackGround
      drawstring (Buffer, TextPosX, TextPosY, gad->Text, Colors.MNG_TextInactive,2)
      if gad->Selection then DrawMenuRBDot (Buffer,SymbolPosX,SymbolPosY,SymbolSize,Colors.MNG_TextInactive)         
    end if
	end if
end sub



'**********************************************************


function AddMenuOpen (entry as sGUIEntry ptr) as Gadget ptr
	function=0  
	dim as Gadget ptr gad
  gad=AddMenuGadget (entry)
  if gad then
    gad->DoDraw             =@MOP_Draw
    gad->DoAction           =@MOP_Actions
    function=gad
  end if
end function


function MOP_Actions(gad as Gadget ptr,action as integer) as integer
  'dim as sGUIEntry entry
  'entry=gad->xtd.mng.MenuEntry
  function=0
  select case action
    case GADGET_LMBHIT
      SetSelect (gad,0)  
      MENUBASE=gad->xtd.mng.MenuEntry->Owner
      MENUID=gad->xtd.mng.MenuEntry->Index      
      function=1

    case GADGET_MOUSEHOVER   'Mouse berm Control
      gad->MouseHover=1
    
    case GADGET_MOUSENEXT   'Mouse vom Control wegbewegt
      gad->MouseHover=0       
  end select
end function


sub MOP_Draw (gad as Gadget ptr)
  dim as integer GadPosX,GadPosY,GadWidth,GadHeight,TextPosX,TextPosY,SymbolSize,SymbolPosX,SymbolPosY
  dim as FB.Image ptr Buffer
  
  GadPosX     =gad->PosX
  GadPosY     =gad->PosY
  GadWidth    =gad->GadWidth
	GadHeight   =gad->GadHeight
  TextPosX    =gad->xtd.mng.MenuEntry->TextPosX
	TextPosY    =gad->xtd.mng.MenuEntry->TextPosY
  SymbolSize  =gad->xtd.mng.MenuEntry->SymbolSize
  SymbolPosX  =gad->xtd.mng.MenuEntry->SymbolRPosX
  SymbolPosY  =gad->xtd.mng.MenuEntry->SymbolRPosY
  Buffer   =gad->DrawBuffer->img	
    
	'OFF 
	ClearBox Buffer,0,0,GadWidth,GadHeight
  'ON   unselect/select
  if gad->Activation then
		if gad->MouseHover then
      ClearBox Buffer,0,0,GadWidth,GadHeight,Colors.MNG_HoverFX
      drawstring (Buffer, TextPosX, TextPosY, gad->Text,Colors.MNG_HoverFXText,2)
      Symbol_Arrow (Buffer,SymbolPosX,SymbolPosY,SymbolSize,1,Colors.MNG_HoverFXText)
    else
      ClearBox Buffer,0,0,GadWidth,GadHeight,Colors.MNG_BackGround    
			drawstring (Buffer, TextPosX, TextPosY, gad->Text, Colors.MNG_Text,2)
      Symbol_Arrow (Buffer,SymbolPosX,SymbolPosY,SymbolSize,1,Colors.MNG_Text)      
    end if
		'SLEEP
		if gad->Activation=2 then 
      ClearBox Buffer,0,0,GadWidth,GadHeight,Colors.MNG_BackGround
      drawstring (Buffer, TextPosX, TextPosY, gad->Text, Colors.MNG_TextInactive,2)
      Symbol_Arrow (Buffer,SymbolPosX,SymbolPosY,SymbolSize,1,Colors.MNG_TextInactive)      
    end if
	end if
end sub


'**********************************************************


function AddWinMenuOpen (entry as sGUIEntry ptr) as Gadget ptr
	function=0  
	dim as Gadget ptr gad
  gad=AddMenuGadget (entry)
  if gad then
    gad->DoDraw             =@MWOP_Draw
    gad->DoAction           =@MWOP_Actions
    function=gad
  end if
end function


function MWOP_Actions(gad as Gadget ptr,action as integer) as integer
  dim as integer gadx,gady
  function=0
  select case action
    case GADGET_LMBHIT
      SetSelect (gad,0)  
      MENUBASE=gad->xtd.mng.MenuEntry->Owner
      MENUID=gad->xtd.mng.MenuEntry->Index      
      function=1
      
    case GADGET_MOUSEHOVER   'Mouse berm Control
      gad->MouseHover=1
    
    case GADGET_MOUSENEXT   'Mouse vom Control wegbewegt
      gad->MouseHover=0       
  end select
end function


sub MWOP_Draw (gad as Gadget ptr)
  dim as integer GadPosX,GadPosY,GadWidth,GadHeight,TextPosX,TextPosY,SymbolSize,SymbolPosX,SymbolPosY
  dim as FB.Image ptr Buffer
  
  GadPosX     =gad->PosX
  GadPosY     =gad->PosY
  GadWidth    =gad->GadWidth
	GadHeight   =gad->GadHeight
  TextPosX    =gad->xtd.mng.MenuEntry->TextPosX
	TextPosY    =gad->xtd.mng.MenuEntry->TextPosY
  Buffer   =gad->DrawBuffer->img	
    
	'OFF 
	ClearBox Buffer,0,0,GadWidth,GadHeight
  'ON   unselect/select
  if gad->Activation then
		if gad->MouseHover then
      ClearBox Buffer,0,0,GadWidth,GadHeight,Colors.MNG_HoverFX
      drawstring (Buffer, TextPosX, TextPosY, gad->Text,Colors.MNG_HoverFXText,2)
    else
      ClearBox Buffer,0,0,GadWidth,GadHeight,Colors.MNG_BackGround    
			drawstring (Buffer, TextPosX, TextPosY, gad->Text, Colors.MNG_Text,2)  
    end if
		'SLEEP
		if gad->Activation=2 then 
      ClearBox Buffer,0,0,GadWidth,GadHeight,Colors.MNG_BackGround
      drawstring (Buffer, TextPosX, TextPosY, gad->Text, Colors.MNG_TextInactive,2)     
    end if
	end if
end sub


'******************************************************************************
'******************************************************************************
'******************************************************************************


sub CreatePopUpMenu(menulist as sGUIList ptr)
  dim as sGUIEntry ptr entry
  dim as integer numgroups,winwidth,winheight
  if MenuValidator(menulist,1) then
  
    MenuSetLevel(menulist)
    MenuSetGroup(menulist)
    
    '!!! immer der erste Eintrag einer MenuBase enthlt im ->Qualifier die "Art der Nutzung" der Base als Men    
    entry=menulist->GetFirst     
    entry->Qualifier=1'0=Window PullDown, 1=PopUp
    
    numgroups=GetNumGroups (menulist)
    for group as integer=0 to numgroups-1
      AdjustGroupMembers (menulist, group, winwidth, winheight)
      CreateGroupWindow (menulist, group, winwidth, winheight)
      CreateGroupGadgets (menulist, group) 
    next group
  else
    print "MenuBase not valid"
    sleep:end
  end if  
end sub


sub CreateWindowMenu(menulist as sGUIList ptr, win as sGUIWindow ptr)
  dim as sGUIEntry ptr entry
  dim as node ptr LL_node
  dim as integer numgroups,winwidth,winheight
  if MenuValidator(menulist,1) then
  
    MenuSetLevel(menulist)
    MenuSetGroup(menulist)
    
    'Anhngen dieses Fensters an eine "universelle" PointerListe speziell fr MenFenster, dient der noch ungenutzen leichteren(?) Verarbeitung
    LL_node=MenuWindowList->AppendNew (NodeType) 
    LL_node->anypointer=win
    
    '!!! immer der erste Eintrag einer MenuBase enthlt im ->Qualifier die "Art der Nutzung" der Base als Men    
    entry=menulist->GetFirst     
    entry->Qualifier=0'0=Window PullDown, 1=PopUp
    
    ModifyGroupZero (menulist,win)
    AdjustGroupMembers (menulist, 0, winwidth, winheight)
    CreateGroupGadgets (menulist, 0)

    numgroups=GetNumGroups (menulist)
    for group as integer=1 to numgroups-1
      AdjustGroupMembers (menulist, group, winwidth, winheight)
      CreateGroupWindow (menulist, group, winwidth, winheight)
      CreateGroupGadgets (menulist, group) 
    next group

  else
    print "MenuBase not valid"
    sleep:end
  end if    
end sub


'******************************************************************************
'******************************************************************************
'******************************************************************************


function GetNumGroups (menulist as sGUIList ptr) as integer
  dim as sGUIEntry ptr entry
  dim as integer group
  entry=menulist->GetFirst
  group=0
  do
    if entry->MemberOfGroup > group then group = entry->MemberOfGroup  
    entry=cast(sGUIEntry ptr,entry->next_node)'nchsten Eintrag holen       
  loop until entry=0
  function=(group+1)
end function


sub ModifyGroupZero (menulist as sGUIList ptr, win as sGUIWindow ptr)
  dim as sGUIEntry ptr entry,firstmember
  entry=menulist->GetFirst
  do
    if entry->MemberOfGroup = 0 then 
      if entry->EntryType=ETYPE_OPENMENUSTRIP then 
        entry->EntryType=ETYPE_OPENWINMENUSTRIP
        entry->StripWindow=win
      end if
    end if
    entry=cast(sGUIEntry ptr,entry->next_node)'nchsten Eintrag holen       
  loop until entry=0
end sub


'passt, die Breite der Eintrge einer Gruppe an
'positioniert Symbole und Text in den Eintrgen
'liefert Hhe u. Breite des erforderlichen und noch zu erzeugenden Fensters dieser Gruppe
sub AdjustGroupMembers (menulist as sGUIList ptr, group as integer, byref SWWidth as integer, byref SWHeight as integer)
  dim as sGUIEntry ptr entry
  dim as integer foundcheck,foundopen,foundwinopen,dragwidth,dragheight,addwidth,symbolsize
  
  'nach CheckMark/OpenMenu/OpenWinMenu/Breitester Eintrag suchen
  entry=menulist->GetFirst
  foundcheck=0
  foundopen=0
  foundwinopen=0
  dragwidth=0
  symbolsize=0
  do
    if entry->MemberOfGroup = group then
      if entry->EntryType=ETYPE_CHECKMARK then foundcheck=1
      if entry->EntryType=ETYPE_RADIOBUTTON then foundcheck=1      
      if entry->EntryType=ETYPE_OPENMENUSTRIP then foundopen=1
      if entry->EntryType=ETYPE_OPENWINMENUSTRIP then foundwinopen=1     
      if (entry->SymbolSize<>0) and (symbolsize=0) then symbolsize=entry->SymbolSize'die erste gefundene Symbolgre festhalten
      
      'breitesten Eintrag finden auf Basis des Eintragstextes + Rand      
      entry->EntryWidth=GetTextWidth(entry->Text,2) + 2*sGUIMainGap
      if entry->EntryWidth > dragwidth then dragwidth=entry->EntryWidth
    end if
    entry=cast(sGUIEntry ptr,entry->next_node)'nchsten Eintrag holen       
  loop until entry=0
  
  if foundwinopen then'"Spezialfall" fr Window-Mens und auch nur bei group=0 mglich, waagerechtes Layout
    
    entry=menulist->GetFirst
    SWWidth=0
    SWHeight=GetFontHeight(2) + 2*sGUIMainGap
    do
      if entry->MemberOfGroup = group then
      
        'Positionierung im Fenster
        'whrend Testphase gilt: die Positionierung der Gadgets bezieht sich hier auf ein eigenes Fenster (noch als waagerechtes PopUp)
        'wenn die Gadgets spter in ein "UserWindow" wandern, mssen PosX/PosY relativ
        'zum ContentOffset des Fensters gesehen und gendert werden
        entry->PosX=SWWidth
        SWWidth +=entry->EntryWidth'Gesamtbreite Fenster um diesen Eintrag erhhen
        entry->PosY=-entry->EntryHeight
        
        'Positionierung Text
        entry->TextPosX=sGUIMainGap
        entry->TextPosY=sGUIMainGap       
    
      end if
      entry=cast(sGUIEntry ptr,entry->next_node)'nchsten Eintrag holen       
    loop until entry=0 
    
  else'"Normalfall", bei allen Gruppen mglich, senkrechtes Layout
        
    entry=menulist->GetFirst
    SWHeight=0
    'gemeinsame Breite aller Eintrge
    SWWidth=dragwidth
    if foundcheck then SWWidth += symbolsize + sGUIMainGap
    if foundopen then SWWidth += symbolsize + sGUIMainGap
    dragheight=0
    do
      if entry->MemberOfGroup = group then
      
        'gemeine Breite des Eintrages
        entry->EntryWidth=SWWidth      
              
        'Positionierung im Fenster
        entry->PosX=0
        entry->PosY=SWHeight
        SWHeight +=entry->EntryHeight'Gesamthhe Fenster um diesen Eintrag erhhen
              
        'Positionierung vorderes Symbol und Text
        if foundcheck then'mit Symbol vorn
          entry->SymbolLPosX=sGUIMainGap
          entry->SymbolLPosY=(entry->EntryHeight - symbolsize)/2        
          entry->TextPosX=symbolsize + 2*sGUIMainGap
          entry->TextPosY=sGUIMainGap     
        else'ohne Symbol vorn
          entry->TextPosX=sGUIMainGap
          entry->TextPosY=sGUIMainGap       
        end if
        
        'Positionierung hinteres Symbol
        if foundopen then
          entry->SymbolRPosX=entry->EntryWidth - (symbolsize + sGUIMainGap)
          entry->SymbolRPosY=(entry->EntryHeight - symbolsize)/2             
        end if
      
      end if
      
      entry=cast(sGUIEntry ptr,entry->next_node)'nchsten Eintrag holen       
    loop until entry=0    
  end if
end sub


function CreateGroupWindow (menulist as sGUIList ptr,group as integer, SWWidth as integer, SWHeight as integer ) as sGUIWindow ptr 
  dim as sGUIEntry ptr entry,firstmember
  dim as sGUIWindow ptr win
  dim as node ptr LL_node
  
  win=AddWindow(0,10,10,SWWidth,SWHeight,,WFLAG_ALWAYSONTOP or WFLAG_NOSELECT)
  if win then
    'Anhngen dieses Fensters an eine "universelle" PointerListe speziell fr MenFenster, dient der noch ungenutzen leichteren(?) Verarbeitung
    LL_node=MenuWindowList->AppendNew (NodeType) 
    LL_node->anypointer=win  
    entry=menulist->GetFirst
    firstmember=0
    do
      if entry->MemberOfGroup = group then      
        if firstmember=0 then firstmember=entry'den "Anfang" brauchen wir gleich, also merken
        entry->StripWindow=win'jedem Gruppenmitglied dieses Fenster zuweisen, erleichtert die Gadgeterzeugung     
      end if
      entry=cast(sGUIEntry ptr,entry->next_node)'nchsten Eintrag holen       
    loop until entry=0
    
    'der Vorgnger des ersten Gruppenmitgliedes einer Gruppe ist IMMER (sein) Open(Win)MenuStrip... , syntaxbedingt!!!
    'in diesem Open wird nun dieses Window hier als ChildStripWindow hinterlegt, quasi ein Shortcut
    'darber weiss spter das Gadget eines (Sub-)Mens, welches Strip-Fenster zu ffnen ist
    'Ausnahme ist Gruppe 0, je nach Betrachtung ist Gruppe 0 die oberste Ebene, Grundlage des ganzen Mensystems. Da gibt es kein "Parent-Ding"
    if group<>0 then
      cast(sGUIEntry ptr,firstmember->prev_node)->ChildStripWindow=win
    end if   
  end if
  function=win
end function


sub CreateGroupGadgets (menulist as sGUIList ptr,group as integer)
  dim as sGUIEntry ptr entry,firstmember
  entry=menulist->GetFirst
  do
    if entry->MemberOfGroup = group then CreateMenuGadget(entry)     
    entry=cast(sGUIEntry ptr,entry->next_node)'nchsten Eintrag holen       
  loop until entry=0
end sub


function CreateMenuGadget (entry as sGUIEntry ptr) as Gadget ptr
  dim as Gadget ptr gad
  select case entry->EntryType
    case ETYPE_ITEM
      gad=AddMenuItem (entry)
    
    case ETYPE_SEPARATOR
      gad=AddMenuSeparator (entry)      
    
    case ETYPE_CHECKMARK
      gad=AddMenuCheckMark (entry)
    
    case ETYPE_RADIOBUTTON
      gad=AddMenuRadioButton (entry)      
      
    case ETYPE_OPENMENUSTRIP
     gad=AddMenuOpen (entry)

    case ETYPE_OPENWINMENUSTRIP
     gad=AddWinMenuOpen (entry)       
      
  end select
  'if gad then GadgetOn(gad)
  function=gad
end function

'******************************************************************************
'******************************************************************************
'******************************************************************************


sub OpenPopUpMenu(menulist as sGUIList ptr, PosX as integer, PosY as integer)
  dim as sGUIEntry ptr entry,e
  dim as sGUIWindow ptr basewin
  entry=menulist->GetFirst
  
  if entry then
    basewin=entry->StripWindow
    
    'alle StripWindows schliessen
    HideAllMenuWindows
    
    '"BaseWindow" positionieren
    LocateMenuWindow (basewin, PosX, PosY)
    
    '"BaseWindow" ffnen
    ShowWindow(basewin)
    MENUBASE=menulist
    MENUOPEN=1
  end if  
end sub


sub HideAllMenuWindows
  dim as node ptr LL_node
  dim as uinteger winflags
  LL_node=MenuWindowList->GetFirst
  if LL_node then
    do
      winflags=cast (sGUIWindow ptr,LL_node->anypointer)->WinFlags
      'nur UserWindows haben das WFLAG_MENUBAR. Das nutzen wir als Erkennungsmerkmal
      'ein Fenster MIT diesem Flag darf NICHT geschlossen werden
      if (winflags and WFLAG_MENUBAR)=0 then HideWindow(cast (sGUIWindow ptr,LL_node->anypointer))
      LL_node=LL_node->next_node
    loop until (LL_node=0)
  end if
  MENUOPEN=0
end sub


sub LocateMenuWindow (win as sGUIWindow ptr, PosX as integer, PosY as integer, mode as integer=0)
  dim as integer originX,originY
  originY=PosY
  
  if (PosX + win->WinWidth) > ScrnWidth then PosX = ScrnWidth - win->WinWidth
  if PosX < 0 then PosX = 0
  if (PosY + win->WinHeight) > ScrnHeight then 
    PosY = ScrnHeight - win->WinHeight
    if mode then PosY=originY - win->WinHeight -(GetFontHeight(2) + 2*sGUIMainGap)
  end if
  
  if PosY < 0 then PosY = 0 
  win->PosX=PosX
  win->PosY=PosY
end sub


sub OpenStripWindowPath (entry as sGUIEntry ptr, PosX as integer, PosY as integer)
  dim as integer lvl,q
  dim as sGUIList ptr mbase
  dim as sGUIEntry ptr first
  dim as sGUIWindow ptr topwindow
  mbase=entry->Owner
  first=mbase->GetFirst
  q=first->Qualifier
  if entry then
    HideAllMenuWindows
    if entry->EntryType=ETYPE_OPENWINMENUSTRIP then
      LocateMenuWindow (entry->ChildStripWindow, PosX, PosY,1)
    else
      LocateMenuWindow (entry->ChildStripWindow, PosX, PosY)
    end if
    if q then ShowWindow(first->StripWindow) 
    do
      if (entry->EntryType=ETYPE_OPENMENUSTRIP) or (entry->EntryType=ETYPE_OPENWINMENUSTRIP) then 
        ShowWindow(entry->ChildStripWindow)    
        lvl=entry->Level
      end if
      entry=cast(sGUIEntry ptr,entry->prev_node)'vorhergehenden Eintrag holen       
    loop until (entry=0) or (lvl=0)
  end if
  MENUOPEN=1
end sub


function FoundInList (list as sGUIList ptr, thing as any ptr) as integer
  dim as integer found
  dim as node ptr n
  found=0
  n=list->GetFirst
  if n then
    do
      if n->anypointer=thing then found=1
      n=n->next_node
    loop until (n=0) or (found=1) 
  end if
  function=found
end function


sub MenuHandler(win as sGUIWindow ptr)
  dim as sGUIEntry ptr entry
  dim as integer gadx,gady,closemenu
  
  closemenu=0
  if FoundInList (MenuWindowList,win)=0 then closemenu +=1
  if FoundInList (MenuGadgetList,GADGETMESSAGE)=0 then closemenu +=1
  'if LMB<>HIT then closemenu +=1
  
  if closemenu=0 then
    entry=GADGETMESSAGE->xtd.mng.MenuEntry
                 
    select case entry->EntryType
      case ETYPE_OPENMENUSTRIP
        GetGlobalPosition(GADGETMESSAGE,gadx,gady)
        OpenStripWindowPath (entry, gadx + GADGETMESSAGE->GadWidth, gady)
        MENUBASE=0
        MENUID=0
       
       case ETYPE_OPENWINMENUSTRIP
        GetGlobalPosition(GADGETMESSAGE,gadx,gady)
        OpenStripWindowPath (entry, gadx , gady + (GADGETMESSAGE->GadHeight))
        MENUBASE=0
        MENUID=0         
          
      case ETYPE_ITEM,ETYPE_CHECKMARK,ETYPE_RADIOBUTTON
        HideAllMenuWindows
    end select

    WINDOWMESSAGE=0
    GADGETMESSAGE=0
  else 
    if MENUOPEN then HideAllMenuWindows
  end if
end sub

end namespace
'******************************************************************************
'... und nun der ausfhrbare Code, diese Datei ist ja schliesslich keine *.bi ;P
sGUI.MenuHandlerCall=@sGUI.MenuHandler()
'******************************************************************************
