namespace sGUI

declare function AddCheckMarkGadget (win as sGUIWindow ptr,PosX as integer,PosY as integer,Text as string="",Textleft as integer=0) as Gadget ptr
declare function AddRadioButton (win as sGUIWindow ptr,PosX as integer,PosY as integer,Text as string="",Head as Gadget ptr,Textleft as integer=0) as Gadget ptr
declare function AddRadioToggle (win as sGUIWindow ptr,PosX as integer,PosY as integer,GadWidth as integer,GadHeight as integer,Text as string,Head as Gadget ptr) as Gadget ptr
declare function RBC_Actions(gad as Gadget ptr,action as integer) as integer
declare sub RBC_Draw (gad as Gadget ptr)
declare sub RBC_Update (gad as Gadget ptr)
declare sub RBC_RethinkInternal(gad as Gadget ptr)

/'
type RBC_Data
	KindOf				    as integer
	OffsetXDraw	      as integer
	OffsetYDraw       as integer
	OffsetXText		    as integer
	OffsetYText		    as integer
	TextLeftRight     as integer
  Radius            as integer
  DrawSize          as integer
	RBList				    as sGUIList ptr
  RTWindow          as _sGUIWindow ptr		
end type
'/
function AddCheckmarkGadget (win as sGUIWindow ptr,PosX as integer,PosY as integer,Text as string="",Textleft as integer=0) as Gadget ptr
  function=0  
  dim as Gadget ptr gad
  if win=0 then win=RootWindow
  gad=win->GadgetList->AppendNew (GadgetType)
  if gad then
    gad->parent=win
    gad->Activation=0   
		gad->PosX=PosX
		gad->PosY=PosY   
    gad->xtd.rbc.KindOf=0
    gad->Text=Text
    gad->xtd.rbc.TextLeftRight=Textleft
    gad->xtd.rbc.DrawSize=sGUIMainSize
    
    RBC_RethinkInternal(gad)    
    gad->DrawBuffer->img=imagecreate(gad->GadWidth,Gad->GadHeight,0,32)'by Haubitze

    gad->DoDraw     =@RBC_Draw
    gad->DoAction   =@RBC_Actions
    gad->DeviceFlags=DFLAG_LMB  
		function=gad
  end if
end function


function AddRadioButton (win as sGUIWindow ptr,PosX as integer,PosY as integer,Text as string="",Head as Gadget ptr,Textleft as integer=0) as Gadget ptr
  function=0
  dim as Gadget ptr gad,groupfirst
  dim as node ptr n
  dim as integer d 
  if win=0 then win=RootWindow  
  gad=win->GadgetList->AppendNew (GadgetType)
  if gad then
    gad->parent=win
    gad->Activation=0   
		gad->PosX=PosX
		gad->PosY=PosY   
    gad->xtd.rbc.KindOf=1
    gad->Text=Text
    gad->xtd.rbc.TextLeftRight=Textleft
    'gad->xtd.rbc.Radius=int( iif(sGUIMainSize mod 2,sGUIMainSize,sGUIMainSize-1) /2)
    gad->xtd.rbc.Radius=int(sGUIMainSize/2)
    gad->xtd.rbc.DrawSize=sGUIMainSize
    
    RBC_RethinkInternal(gad)
    gad->DrawBuffer->img=imagecreate(gad->GadWidth,Gad->GadHeight,0,32) 

    if Head=0 then
      gad->xtd.rbc.RBList = sGUI.PointersLists->AppendNew (sGUIListType)'eine einfache (Zeiger)Liste fr die Gruppe erzeugen
    else
      gad->xtd.rbc.RBList = Head->xtd.rbc.RBList'in einem Nichtheader Liste aus Header bernehmen
    end if

    n=gad->xtd.rbc.RBList->AppendNew (nodeType)'in der Liste einen node als "Informationstrger" erzeugen
    n->anypointer=cast(any ptr,gad)'den Zeiger dieses Controls in den node schreiben
    
    gad->DoDraw     =@RBC_Draw
    gad->DoAction   =@RBC_Actions
    

    if RadioButtonMask=0 then
      RadioButtonMask=ImageList->AppendNew(sGUIImageType)'leer, noch ohne Image!
      if RadioButtonMask then
        RadioButtonMask->img=imagecreate(gad->xtd.rbc.DrawSize,gad->xtd.rbc.DrawSize,Colors.Background,32)
        DrawRBMask(RadioButtonMask->img, gad->xtd.rbc.DrawSize,gad->xtd.rbc.Radius)
      end if
		end if
    gad->DeviceFlags=DFLAG_LMB   
    function=gad
  end if
end function


function AddRadioToggle (win as sGUIWindow ptr,PosX as integer,PosY as integer,GadWidth as integer,GadHeight as integer,Text as string,Head as Gadget ptr) as Gadget ptr
	function=0  
  dim as Gadget ptr gad,groupfirst
  dim as node ptr n
	if win=0 then win=RootWindow
	gad=win->GadgetList->AppendNew (GadgetType)
	if gad then
    
    gad->xtd.rbc.KindOf=2'Flag RadioToggle
    if Head=0 then
      gad->xtd.rbc.RBList = sGUI.PointersLists->AppendNew (sGUIListType)'eine einfache (Zeiger)Liste fr die Gruppe erzeugen
    else
      gad->xtd.rbc.RBList = Head->xtd.rbc.RBList'in einem Nichtheader Liste aus Header bernehmen
    end if

    n=gad->xtd.rbc.RBList->AppendNew (nodeType)'in der Liste einen node als "Informationstrger" erzeugen
    n->anypointer=cast(any ptr,gad)'den Zeiger dieses Controls in den node schreiben  
  
		gad->parent=win
		gad->Selection=0
		gad->Activation=0
		gad->PosX=PosX
		gad->PosY=PosY
		gad->GadWidth=GadWidth
		gad->GadHeight=GadHeight
		gad->Text=Text   
    gad->DrawBuffer->img=imagecreate(gad->GadWidth,Gad->GadHeight,0,32)

    gad->DoDraw     =@RBC_Draw
    gad->DoAction   =@RBC_Actions
    gad->DeviceFlags=DFLAG_LMB   
		function=gad
	end if
end function



function RBC_Actions(gad as Gadget ptr,action as integer) as integer
  dim as Gadget ptr g
  dim as node ptr n
  dim as sGUIList ptr lst=gad->xtd.rbc.RBList'Adresse der "GruppenPointerListe"
  function=0
  select case action
    case GADGET_LMBRELEASE    'Control regulr losgelassen
        
      if gad->xtd.rbc.KindOf then
        
        n=lst->GetFirst
        do
          g=cast(Gadget ptr,n->anypointer)
          if g=gad then
            SetSelect(g,1)
            if g->xtd.rbc.RTWindow then ShowWindow(g->xtd.rbc.RTWindow)           
          else
            SetSelect(g,0)
            if g->xtd.rbc.RTWindow then HideWindow(g->xtd.rbc.RTWindow)
          end if
          n=n->next_node
        loop until n=0
        function=1
        
        
      else

        if GetSelect(gad) then SetSelect(gad,0) else SetSelect(gad,1)
        function=1
      
      end if

    case GADGET_MOUSEHOVER   'Mouse berm Control
      gad->MouseHover=1
    
    case GADGET_MOUSENEXT   'Mouse vom Control wegbewegt
      gad->MouseHover=0
  end select
end function


sub RBC_Draw (gad as Gadget ptr)
	dim as integer GadX,GadY,RadioCheckPosX,RadioCheckPosY,TextPosX,TextPosY,GadWidth,GadHeight,DrawSize,Radius
  dim as FB.Image ptr Buffer
  dim as ulong col  
  GadWidth		   =gad->GadWidth
	GadHeight		   =gad->GadHeight
  Buffer         =gad->DrawBuffer->img  

  select case gad->xtd.rbc.KindOf
    case 0,1
      RadioCheckPosX  =gad->xtd.rbc.OffsetXDraw
      RadioCheckPosY  =gad->xtd.rbc.OffsetYDraw
      TextPosX        =gad->xtd.rbc.OffsetXText
      TextPosY        =gad->xtd.rbc.OffsetYText
      DrawSize        =gad->xtd.rbc.DrawSize
      Radius          =gad->xtd.rbc.Radius   
      'OFF
      ClearBox Buffer,0,0,GadWidth,GadHeight,Colors.Background
      'ON
      if gad->Activation then
        
        if gad->xtd.rbc.KindOf=1 then'RadioButton
          FilledBoxRadio Buffer,RadioCheckPosX,RadioCheckPosY,DrawSize,Radius,Colors.GadBody,Colors.GadBody,gad->Selection,gad->MouseHover					
        else'CheckMark
          FilledBoxCheckMark Buffer,RadioCheckPosX,RadioCheckPosY,DrawSize,Colors.GadBody,Colors.GadBody,gad->Selection,gad->MouseHover	 
        end if

        if gad->Text<>"" then drawstring (Buffer,TextPosX,TextPosY,gad->Text,Colors.Pen)
        'SLEEP
        if gad->Activation=2 then Raster Buffer,0,0,GadWidth,GadHeight
      end if    
   
    case 2
      TextPosX =int((GadWidth-GetTextWidth(gad->Text))/2)
      TextPosY =int((GadHeight-GetFontHeight)/2)    
      'OFF 
      ClearBox Buffer,0,0,GadWidth,GadHeight,Colors.Background
      'ON   unselect/select
      if gad->Activation then
        StdFilledBoxRounded Buffer,0,0,GadWidth,GadHeight,,,gad->Selection,gad->MouseHover,3
        
      if gad->MouseHover then
        drawstring (Buffer, TextPosX, TextPosY, gad->Text,iif(gad->Selection,Colors.HoverFXTextSelected,Colors.HoverFXText))
      else
        drawstring (Buffer, TextPosX, TextPosY, gad->Text,iif(gad->Selection,Colors.GadTextSelected,Colors.GadText))
      end if   
        'SLEEP
        if gad->Activation=2 then Raster Buffer,0,0,GadWidth,GadHeight
      end if        
  end select 
end sub


sub RBC_Update (gad as Gadget ptr)
  RBC_RethinkInternal(gad)
end sub


sub RBC_RethinkInternal(gad as Gadget ptr)
  if gad->Text="" then   'ohne Text    
    'Breite u. Hhe Gadget
    gad->GadWidth=gad->xtd.rbc.DrawSize
    gad->GadHeight=gad->xtd.rbc.DrawSize
    gad->xtd.rbc.OffsetXDraw=0
    gad->xtd.rbc.OffsetYDraw=0
  else                   'mit Text  
    'Breite u. Hhe Gadget
    gad->GadWidth=gad->xtd.rbc.DrawSize + sGUIMainGap*2 + GetTextWidth(gad->Text)    
    gad->GadHeight=iif (GetFontHeight > gad->xtd.rbc.DrawSize, GetFontHeight, gad->xtd.rbc.DrawSize)    
    'Y Offset CheckBox/RadioButton
    gad->xtd.rbc.OffsetYDraw=(gad->GadHeight - gad->xtd.rbc.DrawSize)/2
    'Y Offset Text
    gad->xtd.rbc.OffsetYText=(gad->GadHeight-GetFontHeight)/2     
    'Text links oder rechts?
    if gad->xtd.rbc.TextLeftRight then' Text links      
      'X Offset CheckBox
      gad->xtd.rbc.OffsetXDraw=gad->GadWidth - gad->xtd.rbc.DrawSize      
      'X Offset Text
      gad->xtd.rbc.OffsetXText=0
    else 'Text rechts
      'X Offset CheckBox
      gad->xtd.rbc.OffsetXDraw=0      
      'X Offset Text
      gad->xtd.rbc.OffsetXText=gad->xtd.rbc.DrawSize + sGUIMainGap*2
    end if
  end if
end sub

end namespace
