#include once "Gadget_Arrows.bas"
#include once "Gadget_ScrollBar_Container.bas"

namespace sGUI

declare function AddScrollBar(win as sGUIWindow ptr,PosX as integer,PosY as integer,SBLength as integer,Minimum as integer,Maximum as integer,ScrollValue as integer,PageSize as integer,Orientation as integer,FullRange as integer=0) as any ptr
declare sub SCR_Actions(win as sGUIWindow ptr)

declare function GetScrollBar (thing as any ptr) as integer
declare sub SetScrollBar overload(thing as any ptr,ScrollValue as integer)
declare sub SetScrollBar (thing as any ptr,Minimum as integer,Maximum as integer)
declare sub SetScrollBar (thing as any ptr,Minimum as integer,Maximum as integer,ScrollValue as integer,PageSize as integer=0)

/'
type SCR_Data
	ScrollValue 			as integer
	ScrollValueOld 		as integer
	knobcontainer			as _Gadget ptr
	Arrowincr					as _Gadget ptr
	Arrowdecr					as _Gadget ptr
end type
'/
function AddScrollBar(win as sGUIWindow ptr,PosX as integer,PosY as integer,SBLength as integer,Minimum as integer,Maximum as integer,ScrollValue as integer,PageSize as integer,Orientation as integer,FullRange as integer=0) as any ptr
  function=0  
  dim as sGUIWindow ptr gwin
  dim as integer WinWidth,WinHeight
  if win=0 then win=RootWindow
  WinWidth=SBLength
  WinHeight=sGUIMainSize
  if Orientation then swap WinWidth,WinHeight'Breite und Hhe tauschen wenn vertikal

  gwin=AddWindow(win,PosX,PosY,WinWidth,WinHeight,,WFLAG_GADGETMODE)  
  if gwin then
    gwin->Activation=1
    
    if Orientation then       'wenn vertikal
      if SBLength < (3*sGUIMainSize + 2) then
        gwin->xtd.scr.knobcontainer	=AddScrollBarContainer(gwin,0,0,WinHeight,Minimum,Maximum,ScrollValue,PageSize,1)
      else
        gwin->xtd.scr.knobcontainer	=AddScrollBarContainer(gwin,0,0,WinHeight-(2*sGUIMainSize+2),Minimum,Maximum,ScrollValue,PageSize,1,FullRange)
        gwin->xtd.scr.Arrowdecr			=AddArrow(gwin, 0, WinHeight-(2*sGUIMainSize+1), 2)
        gwin->xtd.scr.Arrowincr			=AddArrow(gwin, 0, WinHeight-sGUIMainSize, 3)
      end if
    else                      'wenn horizontal
      if SBLength < (3*sGUIMainSize + 2) then
        gwin->xtd.scr.knobcontainer	=AddScrollBarContainer(gwin,0,0,WinWidth,Minimum,Maximum,ScrollValue,PageSize,0)
      else
        gwin->xtd.scr.knobcontainer	=AddScrollBarContainer(gwin,0,0,WinWidth-(2*sGUIMainSize+2),Minimum,Maximum,ScrollValue,PageSize,0)
        gwin->xtd.scr.Arrowdecr			=AddArrow(gwin, WinWidth-(2*sGUIMainSize+1), 0, 0)
        gwin->xtd.scr.Arrowincr			=AddArrow(gwin, WinWidth-sGUIMainSize, 0, 1)
      end if
    end if
    
    gwin->DoAction     =@SCR_Actions   
    function=gwin
  end if
end function


sub SCR_Actions (win as sGUIWindow ptr)
  win->xtd.scr.ScrollValueOld=win->xtd.scr.ScrollValue'alten Scrollwert merken 
  
  if GADGETMESSAGE then' wenn im Window irgend eines der Controls ein Action meldet, dann...              
    select case GADGETMESSAGE
      
      case win->xtd.scr.knobcontainer
        win->xtd.scr.ScrollValue=GetSBCVal(win->xtd.scr.knobcontainer)
      
      case win->xtd.scr.Arrowdecr
        win->xtd.scr.ScrollValue -=1
        SetSBCVal(win->xtd.scr.knobcontainer,win->xtd.scr.ScrollValue)
        win->xtd.scr.ScrollValue=GetSBCVal(win->xtd.scr.knobcontainer)
      
      case win->xtd.scr.Arrowincr
        win->xtd.scr.ScrollValue +=1
        SetSBCVal(win->xtd.scr.knobcontainer,win->xtd.scr.ScrollValue)
        win->xtd.scr.ScrollValue=GetSBCVal(win->xtd.scr.knobcontainer)
     end select
  end if
  
  if win->xtd.scr.ScrollValueOld<>win->xtd.scr.ScrollValue then 
    win->xtd.scr.knobcontainer->ReDraw=1
    GADGETMESSAGE=cast(any ptr,win)''Camouflage': Window gibt sich, zumindest fr den Mainloop, als Gadget aus
    WINDOWMESSAGE=win
  else
    GADGETMESSAGE=0
    WINDOWMESSAGE=0 
  end if

end sub


function GetScrollBar (thing as any ptr) as integer
  dim as sGUIWindow ptr win=cast(sGUIWindow ptr, thing)
  function=GetSBCVal(win->xtd.scr.knobcontainer)
end function


sub SetScrollBar (thing as any ptr,ScrollValue as integer)
  dim as sGUIWindow ptr win=cast(sGUIWindow ptr, thing)
  SetSBCVal (win->xtd.scr.knobcontainer,ScrollValue)
  win->xtd.scr.ScrollValue=GetScrollBar (win)
end sub


sub SetScrollBar (thing as any ptr,Minimum as integer,Maximum as integer)
  dim as sGUIWindow ptr win=cast(sGUIWindow ptr, thing) 
  SetSBCLimits(win->xtd.scr.knobcontainer,Minimum,Maximum)
end sub


sub SetScrollBar (thing as any ptr,Minimum as integer,Maximum as integer,ScrollValue as integer,PageSize as integer=0)  
  dim as sGUIWindow ptr win=cast(sGUIWindow ptr, thing)
  SetSBCLimits(win->xtd.scr.knobcontainer,Minimum,Maximum,PageSize)
  SetSBCVal (win->xtd.scr.knobcontainer,ScrollValue)
  win->xtd.scr.ScrollValue=GetScrollBar (win)
end sub

end namespace
