namespace sGUI

declare function AddScrollBarContainer(win as sGUIWindow ptr,PosX as integer,PosY as integer,l as integer,Minimum as integer,Maximum as integer,ScrollValue as integer,PageSize as integer,Orientation as integer,FullRange as integer=0) as Gadget ptr
declare function SBC_Actions(gad as Gadget ptr,action as integer) as integer
declare sub SBC_Draw (gad as Gadget ptr)
declare sub SBC_RethinkInternal(gad as Gadget ptr, Minimum as integer, Maximum as integer, ScrollValue as integer, PageSize as integer)

declare sub SlideSBC(gad as Gadget ptr,knobpos as integer)
declare sub SetSBCVal (gad as Gadget ptr,ScrollValue as integer)
declare function GetSBCVal (gad as Gadget ptr) as integer
declare sub SetSBCLimits(gad as Gadget ptr,Minimum as integer,Maximum as integer,PageSize as integer=0)

/'
type SBC_Data
	ScrollValue 			as integer
	ScrollValueOld 		as integer
	ScrollValueMax		as integer
	ScrollValueMin		as integer
	PageSize					as integer
  SlideSize         as integer
	KnobSize					as integer
	SwitchHV					as integer
	SwitchSlideMode		as integer
	KnobMouseOffset		as integer
	KnobPosition			as integer	
end type
'/
function AddScrollBarContainer(win as sGUIWindow ptr,PosX as integer,PosY as integer,l as integer,Minimum as integer,Maximum as integer,ScrollValue as integer,PageSize as integer,Orientation as integer,FullRange as integer=0) as Gadget ptr
  function=0  
  dim as Gadget ptr gad
  if win=0 then win=RootWindow
  gad=win->GadgetList->AppendNew (GadgetType)
  if gad then
    gad->parent=win
    gad->Selection=0
    gad->Activation=0
    gad->posx=PosX
    gad->posy=PosY
    
    gad->xtd.sbc.SwitchHV=Orientation
    if gad->xtd.sbc.SwitchHV then
     'vertikal
      gad->GadWidth=sGUIMainSize
      gad->GadHeight=l
    else
      'horizontal
      gad->GadWidth=l
      gad->GadHeight=sGUIMainSize
    end if
    gad->xtd.sbc.SlideSize=l
    gad->xtd.sbc.FullRange=FullRange    
    SBC_RethinkInternal(gad,Minimum,Maximum,ScrollValue,PageSize)   
    gad->DrawBuffer->img=imagecreate(gad->GadWidth,Gad->GadHeight)
    'da der Knob nun abgerundete Ecken hat und ich ihn desswegen transparent in den
    'Container kopieren muss, bekommt der Knob nun ein eigenes Image, das dann per PUT(),TRANS in den Container kommt   
    gad->xtd.sbc.KnobGFXLayer=ImageList->AppendNew(sGUIImageType)    
    gad->xtd.sbc.KnobGFXLayer->img=imagecreate(gad->GadWidth,Gad->GadHeight)
    
    gad->DoDraw     =@SBC_Draw
    gad->DoAction   =@SBC_Actions
    gad->DeviceFlags=DFLAG_LMB or DFLAG_WHEEL
    function=gad
  end if
end function


function SBC_Actions(gad as Gadget ptr,action as integer) as integer
  function=0
  'relative Mausposition zum Control berechnen, mit Fallunterscheidung h/v
	dim as integer GadX,GadY,GadMousePos
  GetGlobalPosition(gad,GadX,GadY)
  if gad->xtd.sbc.SwitchHV then
    GadMousePos=MOUSEY - GadY
  else
    GadMousePos=MOUSEX - GadX
  end if

  select case action
    case GADGET_LMBHIT        'Control grad frisch gedrckt

      if ( GadMousePos >= gad->xtd.sbc.KnobPosition ) and ( GadMousePos < gad->xtd.sbc.KnobPosition + gad->xtd.sbc.KnobSize ) then 'Fall Knobtreffer

          gad->xtd.sbc.KnobMouseOffset=GadMousePos  - gad->xtd.sbc.KnobPosition 'Speichern des MouseOffsets berm Knob
          gad->xtd.sbc.SwitchSlideMode=1 'SliderModus fr Hold aktivieren
          SetSelect (gad,1)

      else                                                                        'Fall im Container aber neben Knob

        if GadMousePos < gad->xtd.sbc.KnobPosition then                     'falls Maus im Container vor Knob dann...
          SetSBCVal(gad , GetSBCVal(gad) - gad->xtd.sbc.PageSize ) 'Page zurck
        elseif GadMousePos >= gad->xtd.sbc.KnobPosition +  gad->xtd.sbc.KnobSize then'falls Maus im Container hinter Knob dann...
          SetSBCVal(gad , GetSBCVal(gad) + gad->xtd.sbc.PageSize ) 'Page vor
        end if
        gad->xtd.sbc.SwitchSlideMode=0                                  'da kein Knobtreffer wird fr HOLD der SLIDINGMODUS nicht aktiviert

      end if
      function=1

    case GADGET_LMBHOLD,GADGET_LMBHOLDOFF       'Control wird gehalten, Maus ber/neben dem Control
      if gad->xtd.sbc.SwitchSlideMode=1 then
        gad->xtd.sbc.ScrollValueOld=GetSBCVal(gad)
        
        SlideSBC(gad,GadMousePos - gad->xtd.sbc.KnobMouseOffset)'bergabe einer Sliderposition in Abhngigkeit von Maus

        if gad->xtd.sbc.ScrollValueOld<>GetSBCVal(gad) then
          SetSelect (gad,1)
          function=1
        end if
      end if

    case GADGET_LMBRELEASE,GADGET_LMBRELEASEOFF    'Control losgelassen
      gad->xtd.sbc.SwitchSlideMode=0
      SetSelect(gad,0)
    
    case GADGET_WHEELMOVE
      SetSBCVal(gad,gad->xtd.sbc.ScrollValue + WHEEL * gad->xtd.sbc.PageSize)'Limiter via SBC_RethinkInternal
      function=1
      
    case GADGET_MOUSEHOVER   'Mouse berm Control
      gad->MouseHover=1

    case GADGET_MOUSENEXT   'Mouse vom Control wegbewegt
      gad->MouseHover=0
  end select
end function


sub SBC_Draw (gad as Gadget ptr)
	dim as integer KnobPos,KnobSize,GadWidth,GadHeight
  dim as FB.Image ptr Buffer,KnobBuffer  
  GadWidth		    =gad->GadWidth
	GadHeight		    =gad->GadHeight
  KnobPos         =gad->xtd.sbc.KnobPosition
  KnobSize        =gad->xtd.sbc.KnobSize
  KnobBuffer      =gad->xtd.sbc.KnobGFXLayer->img
  Buffer          =gad->DrawBuffer->img  
'OFF
  ClearBox Buffer,0,0,GadWidth,GadHeight,&HFF00FF
  
'ON  
  if gad->Activation then
		FilledBoxContainer Buffer,0,0,GadWidth,GadHeight,,Colors.SCR_Container,1,0		
    
    '!!! Knob hat nun eigenes Image das transparent ins Image des Containers kopiert wird
    ClearBox KnobBuffer,0,0,GadWidth,GadHeight,&HFF00FF
    if gad->xtd.sbc.SwitchHV then'vertikal     
      FilledBoxKnob KnobBuffer,1,KnobPos+1,GadWidth-2,KnobSize-2,,,gad->Selection,gad->MouseHover      
    else'horizontal
      FilledBoxKnob KnobBuffer,KnobPos+1,1,KnobSize-2,GadHeight-2,,,gad->Selection,gad->MouseHover
    end if
    put Buffer,(0,0),KnobBuffer,trans
    
'SLEEP
    if gad->Activation=2 then Raster Buffer,0,0,GadWidth,GadHeight
  end if
end sub


sub SlideSBC(gad as Gadget ptr,knobpos as integer)
  dim as integer clength, cres, vmaxp, vrange
  dim as single cratio

  'Containerlnge ermitteln, Werte entsprechend vertikal/horizontal aus Control holen
  'if gad->xtd.sbc.SwitchHV then clength=gad->GadHeight else clength=gad->GadWidth
  'Containerlnge ermitteln, Neu!!!
  clength=gad->xtd.sbc.SlideSize
  
  'Auflsung Slider, Gesamtzahl der Sliderpositionen
  cres=clength - gad->xtd.sbc.KnobSize
  
  'Knob Position Limiter
  if knobpos<0 then knobpos=0
  if knobpos>clength - gad->xtd.sbc.KnobSize then knobpos=clength - gad->xtd.sbc.KnobSize 
  'Prozentwert der aktuellen Knobposition
  cratio=knobpos / (clength - gad->xtd.sbc.KnobSize)

  if knobpos<>gad->xtd.sbc.KnobPosition then 'wenn eine Knobbewegung erfolgt, dann
    ''grter anzuscrollender Maximalwert
    'vmaxp=gad->xtd.sbc.ScrollValueMax - gad->xtd.sbc.PageSize + 1    
    'Ersatz:
    'nur wenn PageSize definiert und auch der FullRangeSchalter aus ist, dann den maximalen Rckgabewert verringern
    if (gad->xtd.sbc.PageSize>1) andalso (gad->xtd.sbc.FullRange=0) then
      vmaxp =gad->xtd.sbc.ScrollValueMax - (gad->xtd.sbc.PageSize - 1)
    else 
      vmaxp= gad->xtd.sbc.ScrollValueMax
    end if
       
    'Gesamtzahl aller Scrollwerte
    vrange=vmaxp - gad->xtd.sbc.ScrollValueMin

    gad->xtd.sbc.ScrollValue= gad->xtd.sbc.ScrollValueMin + vrange * cratio'minimalwert +  gesamtzahl * Prozent Knob

    gad->xtd.sbc.KnobPosition=knobpos
    gad->ReDraw=1
  end if
  
end sub


sub SetSBCVal (gad as Gadget ptr,ScrollValue as integer)
  'es wird nur der Scrollwert gesetzt, alle anderen Parameter werden aus Gadget geholt
  SBC_RethinkInternal(gad, gad->xtd.sbc.ScrollValueMin, gad->xtd.sbc.ScrollValueMax, ScrollValue, gad->xtd.sbc.PageSize)
  gad->ReDraw=1
end sub


function GetSBCVal (gad as Gadget ptr) as integer
	function=gad->xtd.sbc.ScrollValue
end function


sub SetSBCLimits(gad as Gadget ptr,Minimum as integer,Maximum as integer,PageSize as integer=0)
  if PageSize=0 then PageSize=gad->xtd.sbc.PageSize
  SBC_RethinkInternal(gad, Minimum, Maximum, Minimum, PageSize)
  gad->ReDraw=1
end sub


sub SBC_RethinkInternal(gad as Gadget ptr, Minimum as integer, Maximum as integer, ScrollValue as integer, PageSize as integer)
  /'
  SBC_RethinkInternal fat erstmal alle Parameter als "auenstehend" auf, und mssen - obwohl mglicherweise Bestandteil
  des Controls - auch erstmal als Parameter bergeben werden. berraschenderweise weit weniger Rechnerei
  als gedacht. Erst zum Schlu werden die neu berechneten Werte ins Zielcontrol bertragen
  '/

  dim as single pageratio,vratio
  dim as integer clength,knobsize,vmaxp,knobposmax,knobpos

  '**********Scrollwert Berechnung/berprfung
  'falls notwendig, tauschen
  if Minimum>Maximum then swap Minimum,Maximum

  'Verhltnis Pagegre / Gesamtzahl der Elemente
  pageratio=PageSize / (Maximum-Minimum+1)
  if pageratio>1 then pageratio=1'der Fall tritt auf wenn weniger Elemente da sind als Pagegre, dann kein Scrollen mglich
 
  'nur wenn PageSize definiert und auch der FullRangeSchalter aus ist, dann den maximalen Rckgabewert verringern
  if (PageSize>1) andalso (gad->xtd.sbc.FullRange=0) then 
    vmaxp =Maximum - (PageSize - 1)
  else 
    vmaxp= Maximum
  end if
 
  'Scrollwert Begrenzung berechnen falls ScrollValue ber beide Ziele hinaus will
  if pageratio=1 then                               'sollte Anzahl Elemente <= Pagegre sein (kein Scrollen mglich), dann..
    ScrollValue=Minimum                             'mu der Scrollwert immer auf Anfang stehen, dem Minimalwert
  else                                              'sollten mehr Elemente da sein, also Anzahl Elemente>Pagegre, dann...
    if ScrollValue<Minimum then ScrollValue=Minimum 'ScrollValue darf nicht kleiner als Minimalwert sein
    if ScrollValue>vmaxp then ScrollValue=vmaxp     'ScrollValue darf nicht grer als der mgliche anscrollbarer Maximalwert(abhngig von Pagegre) sein
  end if

  'den Scrollwert in einen Prozentwert (bzw Wert zwischen 0 bis 1) umrechnen Minimum=0%, vmaxp=100%
  vratio= (ScrollValue-Minimum) / (vmaxp-Minimum)

  '**********Darstellung
  'Containerlnge ermitteln, Werte entsprechend vertikal/horizontal aus Control holen
  'if gad->xtd.sbc.SwitchHV then clength=gad->GadHeight else clength=gad->GadWidth
  'Neu!!! Schiebebereichsgre aus Control holen
  clength=gad->xtd.sbc.SlideSize
  
  
  'hiermit ist die Gre des Knobs proportional zum Verhltnis von Pagesize/Anzahl Elemente
  'jedoch niemals grer als der Container(da pageratio<=1 siehe oben) bzw. nie kleiner als... 16,17, sGUIMainSize (+1) ???
  knobsize=int(clength * pageratio)
  'if knobsize<16 then knobsize=16
  'if knobsize<17 then knobsize=17
  'if knobsize<(sGUIMainSize+1) then knobsize=sGUIMainSize+1
  if knobsize<(sGUIMainSize) then knobsize=sGUIMainSize
  
  'Position(Abstand) von oben/links des Knobs entsprechend ScrollValue(genauer vratio) berechnen
  if pageratio=1 then             'wenn Knob den Container ausfllt dann
    knobposmax=0                  'kein Scrollen mglich
    knobpos=0                     'und Position ist immer 0  
    
  else                            'ist Knob kleiner als Container
    knobposmax=clength-knobsize   'grte Scrollposition des Knobs berechnen
    knobpos=int(knobposmax*vratio)'und auf dessen Basis eigentliche Position berechnen
  end if

  'Zurckschreiben ins Control
  gad->xtd.sbc.ScrollValueMin=Minimum 'Minimalwert den value als Rckgabewert annehmen kann
  gad->xtd.sbc.ScrollValueMax=Maximum 'Maximalwert den value als Rckgabewert annehmen kann
  gad->xtd.sbc.KnobPosition=knobpos   'Position des Knobs in px
  gad->xtd.sbc.KnobSize=knobsize      'KnobSize
  gad->xtd.sbc.PageSize=PageSize      'PageSize
  gad->xtd.sbc.ScrollValue=ScrollValue'Regelwert
end sub

end namespace