#include once "Gadget_Edit_Display.bas"

namespace sGUI

declare function AddStringGadget(win as sGUIWindow ptr,PosX as integer,PosY as integer,GadWidth as integer,MaxChars as integer=0 ,CharLimitation as integer=0,ShowEnd as integer=0,Focus as integer=0, Mode as integer=0) as any ptr
declare sub STG_Actions(win as sGUIWindow ptr)
declare sub STG_GadgetReact(win as sGUIWindow ptr)
declare sub STG_EditHandle(win as sGUIWindow ptr, _KEY as string, _ASCCODE as integer, _EXTENDED as integer) 
declare sub STG_CursorOnlyHandle(win as sGUIWindow ptr, _KEY as string, _ASCCODE as integer, _EXTENDED as integer)
declare sub STG_Update (win as sGUIWindow ptr)

declare sub SetString (thing as any ptr,Text as string, showend as integer=1)
declare function GetString (thing as any ptr) as string
declare sub ScrollToAnEnd  (thing as any ptr)

declare sub SetAllowedChars (thing as any ptr, allowed as string)
declare function UserDefinedKeysCheck(win as sGUIWindow ptr, a as integer) as integer

/'
type STG_Data
  TContainer					as sGUIText ptr
	EditMode					  as integer'0=Edit,1=View,2=View DataGrid
	CharsPerWidth       as integer
	RowsPerHeight				as integer 
  MaxChars            as integer
  CharLimitation      as integer
  ShowEnd             as integer
  Focus               as integer
  TimeStamp           as double  
	edit         			  as _Gadget ptr  
end type
'/
function AddStringGadget(win as sGUIWindow ptr,PosX as integer,PosY as integer,GadWidth as integer,MaxChars as integer=0 ,CharLimitation as integer=0,ShowEnd as integer=0,Focus as integer=0, Mode as integer=0) as any ptr
  function=0  
  dim as sGUIWindow ptr gwin
  dim as integer WinWidth,WinHeight
  if win=0 then win=RootWindow
  WinWidth=GadWidth
  WinHeight=GetFontHeight(1) + 2*sGUIMainGap
    
  gwin=AddWindow(win,PosX,PosY,WinWidth,WinHeight,,WFLAG_GADGETMODE)  
  if gwin then
    gwin->Activation=1   
    gwin->xtd.stg.Mode          =Mode  
    gwin->xtd.stg.MaxChars      =MaxChars
    gwin->xtd.stg.CharLimitation=CharLimitation
    gwin->xtd.stg.ShowEnd       =ShowEnd
    gwin->xtd.stg.Focus         =Focus     
    gwin->xtd.stg.edit          =AddEditDisplay (gwin,0,0,WinWidth,WinHeight,gwin->xtd.stg.Mode)		
    gwin->xtd.TContainer        =gwin->xtd.stg.edit->xtd.TContainer   
    gwin->xtd.stg.CharsPerWidth =int((GadWidth - 2*sGUIMainGap)/GetFixedWidth)
    gwin->xtd.stg.RowsPerHeight =1
    gwin->DoAction              =@STG_Actions
    gwin->DoUpdate              =@STG_Update
    ScrollToAnEnd(gwin) 
    function=gwin
  end if
end function


sub STG_Actions (win as sGUIWindow ptr)
  dim as Gadget ptr edit
  dim as sGUIText ptr TContainer
  edit=win->xtd.stg.edit
  TContainer=win->xtd.TContainer
  
  if GADGETMESSAGE then
    select case GADGETMESSAGE
      case edit
        TraceCursorPosition(edit)
    end select
    win->xtd.stg.edit->ReDraw=1
    GADGETMESSAGE=0
  end if

  if KEY<>"" then     
    if FOCUSGADGET=edit then
      
      'if (win->xtd.stg.Mode=0) or (win->xtd.stg.Mode=2) then STG_EditHandle(win, KEY,ASCCODE,EXTENDED)
      'if (win->xtd.stg.Mode=1) or (win->xtd.stg.Mode=3) then STG_CursorOnlyHandle(win, KEY,ASCCODE,EXTENDED)        
      select case win->xtd.stg.Mode
        case 0
          STG_EditHandle(win, KEY,ASCCODE,EXTENDED)      
        case 1,2
          STG_CursorOnlyHandle(win, KEY,ASCCODE,EXTENDED)  
      end select
         
      if ASCCODE=13 then      
        if win->xtd.stg.Focus=0 then
          ScrollToAnEnd(win)
          SetFocus(0)
        end if
        GADGETMESSAGE=cast(any ptr,win)
      end if
      
    end if
  end if      
end sub


'ermglicht es, diese Editierfunktion "gezielt von weiter draussen aufzurufen
sub STG_EditHandle(win as sGUIWindow ptr, _KEY as string, _ASCCODE as integer, _EXTENDED as integer)
  dim as Gadget ptr edit
  dim as sGUIText ptr TContainer
  edit=win->xtd.stg.edit
  TContainer=win->xtd.TContainer    
  dim as integer enable
  
  'Pfeiltasten/Cursorbewegung in beiden Modi erlaubt
  if  _EXTENDED then
    'Cursorbewegung mit Pfeiltasten
    if _ASCCODE=75 then TContainer->CursorLeft
    if _ASCCODE=77 then TContainer->CursorRight
    'added by MilkFreeze, modified by Muttonhead :D
    if _ASCCODE=71 then TContainer->CursorKeyPos1
    if _ASCCODE=79 then TContainer->CursorKeyEnd
    TraceCursorPosition(edit)
  end if
    
  if  _EXTENDED then
    'DEL Windows
    #ifdef __fb_win32__
      if _ASCCODE=83 then
        TContainer->KeyDelete
        TraceCursorPosition(edit)
      end if
    #endif
  else

    'BACKSPACE
    if _ASCCODE=8 then
      TContainer->KeyBackspace
      TraceCursorPosition(edit)
    end if

    'DEL Linux
    #ifdef __fb_linux__
      if _ASCCODE=127 then
        TContainer->KeyDelete
        TraceCursorPosition(edit)
      end if
    #endif

    'Zeicheneingabe
    enable=0

    'Beschrnkungen bei der Zeicheneingabe
    select case win->xtd.stg.CharLimitation
      case 0'String
       'Linux chr(127) (Delete) ausschlieen
        #ifdef __fb_linux__
          if _ASCCODE>=32 and _ASCCODE<>127 then enable=1
        #endif

        'Windows
        #ifdef __fb_win32__
          if _ASCCODE>=32 then enable=1
        #endif

      case 1'Ganze Zahlen
        if _ASCCODE>47 and _ASCCODE<58 then enable=1

      case 2'Fliekomma
        if _ASCCODE>47 and _ASCCODE<58 then enable=1
        if (_ASCCODE=46) and (TContainer->GetNumRows>0) then 
          if instr(TContainer->GetRowContent(1),".")=0 then enable=1 'wenn . gedrckt und noch kein . im String ist
        end if

      case 3'binr
        if _ASCCODE>47 and _ASCCODE<50 then enable=1

      case 4'hexadezimal
        if _ASCCODE>47 and _ASCCODE<58 then enable=1
        if _ASCCODE>64 and _ASCCODE<71 then enable=1
        if _ASCCODE>96 and _ASCCODE<103 then enable=1

      case 5'IPAdressen  ;)
        if _ASCCODE>47 and _ASCCODE<58 then enable=1
        if _ASCCODE>64 and _ASCCODE<71 then enable=1
        if _ASCCODE>96 and _ASCCODE<103 then enable=1
        if _ASCCODE=46 then enable=1
        
      case 6
        enable=UserDefinedKeysCheck(win,ASCCODE)        
        
    end select
    
    'if TContainer->GetNumRows then
      'Lngenbegrenzung
      if (win->xtd.stg.MaxChars>0) and (len(TContainer->GetRowContent(1))>=win->xtd.stg.MaxChars) then enable=0
      
      'generelles Minus Override, es fehlt etwas an Eleganz :/
      if (_ASCCODE=45) and (TContainer->GetCursorPosition=1) and (instr(TContainer->GetRowContent(1),"-")=0) then enable=1 'wenn - gedrckt und noch kein - im String ist
    'end if
    
    if enable then
      TContainer->KeyAddChar(_KEY)
      TraceCursorPosition(edit)
    end if
  end if 
end sub


'ermglicht es, diese Cursorfunktion "gezielt von "aussen" aufzurufen
sub STG_CursorOnlyHandle(win as sGUIWindow ptr, _KEY as string, _ASCCODE as integer, _EXTENDED as integer)
  dim as Gadget ptr edit
  dim as sGUIText ptr TContainer
  edit=win->xtd.stg.edit
  TContainer=win->xtd.TContainer    
  if  _EXTENDED then
    'Cursorbewegung mit Pfeiltasten
    if _ASCCODE=75 then TContainer->CursorLeft
    if _ASCCODE=77 then TContainer->CursorRight
    'added by MilkFreeze, modified by Muttonhead :D
    if _ASCCODE=71 then TContainer->CursorKeyPos1
    if _ASCCODE=79 then TContainer->CursorKeyEnd
    TraceCursorPosition(edit)
  end if
end sub


sub STG_Update(win as sGUIWindow ptr)
  if win->xtd.stg.TimeStamp <> win->xtd.TContainer->GetTimeStamp then
    win->xtd.stg.TimeStamp = win->xtd.TContainer->GetTimeStamp
    win->xtd.stg.edit->ReDraw=1   
  end if
end sub


sub SetString (thing as any ptr,Text as string, showend as integer=1)
  dim as sGUIWindow ptr win=cast(sGUIWindow ptr, thing)  
  'es knnten sogar schon 2 existieren durch SetAllowedChars()
  if win->xtd.TContainer->GetNumRows=0 then win->xtd.TContainer->AppendRow
  win->xtd.TContainer->SetRowContent(1,Text)
  if showend then
    ScrollToAnEnd(win)
  else
    if win->xtd.TContainer->GetCursorPosition > len(Text) then ScrollToAnEnd(win)
  end if
end sub


function GetString (thing as any ptr) as string
  dim as sGUIWindow ptr win=cast(sGUIWindow ptr, thing)   
  function=win->xtd.TContainer->GetRowContent(1)
end function


sub ScrollToAnEnd (thing as any ptr)
  dim as sGUIWindow ptr win=cast(sGUIWindow ptr, thing)  
  if win->xtd.stg.ShowEnd=1 then
    HScrollEditDisplay(win->xtd.stg.edit,1)'erst Scrollfenster (virtuell) ganz nach links schieben
    win->xtd.TContainer->CursorKeyEnd
    'dadurch ist immer das Ende des Textes im StringGadget zu sehen
    'Da nun das "Cursorverfolgen" von links(Textanfang) erfolgt
  else
    win->xtd.TContainer->CursorKeyPos1
  end if
  TraceCursorPosition(win->xtd.stg.edit)
end sub


sub SetAllowedChars (thing as any ptr,allowed as string)
  dim as sGUIWindow ptr win=cast(sGUIWindow ptr, thing)  
  if win->xtd.TContainer->GetNumRows<2 then 
    do
      win->xtd.TContainer->AppendRow    
    loop until win->xtd.TContainer->GetNumRows=2
  end if
  win->xtd.TContainer->SetRowContent(2,allowed)
end sub


function UserDefinedKeysCheck(win as sGUIWindow ptr, a as integer) as integer
  dim as integer offset,found,numchars
  dim as byte ptr AllowedChars
  dim as TextRow ptr row
  row=win->xtd.TContainer->GetRowAddress(2)'Adresse Zeile 2 enthlt den Zeichenlimiterstring, siehe SetAllowedChars()  
  numchars=len(row->Text)'Anzahl der Zeichen
  found=0
  if numchars then
    offset=0
    AllowedChars=strptr(row->Text)'Zeiger auf String, siehe TextRow UDT in sGUIText.bi     
    'Checkloop
    do 
      if AllowedChars[offset]=a then found=1
      offset +=1
    loop until (found=1) or (offset>=numchars)
  end if
  function=found
end function

end namespace
