#include once "Gadget_Edit_Display.bas"
#include once "Gadget_ScrollBar.bas"

namespace sGUI

declare function AddTextField(win as sGUIWindow ptr,PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,Mode as integer=0) as any ptr
declare sub EDB_Actions (win as sGUIWindow ptr)
declare sub EDB_Update(win as sGUIWindow ptr)

/'
type EDB_Data
	Mode					      as integer
	CharsPerWidth       as integer'PageSize horiz. Scrollbar
	RowsPerHeight				as integer'PageSize vert. Scrollbar   
  NumRows             as integer'Abgleich, bei Vernderungen im Text mu Update erfolgen
  LongestRow          as integer'"
  CursorRow           as integer'"
  CursorPos           as integer'"
  TimeStamp           as double
	edit         			  as _Gadget ptr
	vscroll 					  as _Gadget ptr
	hscroll 					  as _Gadget ptr  
end type
'/
function AddTextField(win as sGUIWindow ptr,PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,Mode as integer=0) as any ptr
  function=0  
  dim as sGUIWindow ptr gwin
  if win=0 then win=RootWindow    
  gwin=AddWindow(win,PosX,PosY,BoxWidth,BoxHeight,,WFLAG_GADGETMODE)  
  if gwin then  
    gwin->parent=win
    gwin->Activation=1
    gwin->PosX=PosX
    gwin->PosY=PosY
    gwin->xtd.edb.Mode=Mode  
    gwin->xtd.edb.edit   		=AddEditDisplay (gwin,0,0,BoxWidth-(sGUIMainSize+1),BoxHeight-(sGUIMainSize+1),Mode)'sGUIMainSize+1 bedeutet 1 Pixel Lcke zu den Scrollbar
    gwin->xtd.edb.vscroll		=AddScrollBar(gwin,BoxWidth-sGUIMainSize,0,BoxHeight-(sGUIMainSize+1),1,1,1,1,1)'sGUIMainSize+1 bedeutet 1 Pixel krzere Scrollbar
    gwin->xtd.edb.hscroll		=AddScrollBar(gwin,0,BoxHeight-sGUIMainSize,BoxWidth-(sGUIMainSize+1),1,1,1,1,0)			    
    gwin->xtd.edb.CharsPerWidth=gwin->xtd.edb.edit->xtd.edd.CharsPerWidth
    gwin->xtd.edb.RowsPerHeight=gwin->xtd.edb.edit->xtd.edd.RowsPerHeight
		gwin->xtd.TContainer	=gwin->xtd.edb.edit->xtd.TContainer  
    gwin->DoAction   =@EDB_Actions
    function=gwin
  end if  
  
 end function


sub EDB_Actions (win as sGUIWindow ptr)
  dim as integer WheelSensorX,WheelSensorY
  dim as Gadget ptr edit,vscroll,hscroll
  dim as sGUIText ptr TContainer 
  edit=win->xtd.edb.edit
  vscroll=win->xtd.edb.vscroll
  hscroll=win->xtd.edb.hscroll
  TContainer=win->xtd.TContainer
  
  dim as integer enable
  win->xtd.edb.scrollbarmodify=0
  
  if GADGETMESSAGE then
    select case GADGETMESSAGE
      case edit
        win->xtd.edb.scrollbarmodify=2
      case vscroll
        VScrollEditDisplay(edit,GetScrollBar(vscroll))
      case hscroll
        HScrollEditDisplay(edit,GetScrollBar(hscroll))
    end select
  end if  
  
  if KEY<>"" then
    'Pfeiltasten/Cursorbewegung in beiden Modi erlaubt
    if  EXTENDED then
      'Cursorbewegung mit Pfeiltasten
      if ASCCODE=75 then TContainer->CursorLeft
      if ASCCODE=77 then TContainer->CursorRight
      if ASCCODE=72 then TContainer->CursorUp
      if ASCCODE=80 then TContainer->CursorDown
      'added by MilkFreeze, modified by Muttonhead :D
      if ASCCODE=71 then TContainer->CursorKeyPos1
      if ASCCODE=79 then TContainer->CursorKeyEnd
      win->xtd.edb.scrollbarmodify=1      
    end if

    'Editieren nur in Mode 0 erlaubt
    if win->xtd.edb.Mode=0 then
      if  EXTENDED then
        'DEL Windows
        #ifdef __fb_win32__
          if ASCCODE=83 then
            TContainer->KeyDelete
            win->xtd.edb.scrollbarmodify=2
          end if
        #endif
      else
        'BACKSPACE
        if ASCCODE=8 then
          TContainer->KeyBackspace
          win->xtd.edb.scrollbarmodify=2
        end if
        'DEL Linux
        #ifdef __fb_linux__
          if ASCCODE=127 then
            TContainer->KeyDelete
            win->xtd.edb.scrollbarmodify=2    
          end if
        #endif
        'Return
        if ASCCODE=13 then
          TContainer->KeyReturn
          win->xtd.edb.scrollbarmodify=2
        end if
        
        'Zeicheneingabe
        enable=0

        'Linux chr(127)->Delete ausschlieen
        #ifdef __fb_linux__
          if ASCCODE>=32 and ASCCODE<>127 then enable=1
        #endif

        'Windows
        #ifdef __fb_win32__
          if ASCCODE>=32 then enable=1
        #endif

        if enable then
          TContainer->KeyAddChar(KEY)
          win->xtd.edb.scrollbarmodify=2
        end if
      end if                
    end if
  end if
  
  if WHEEL then
    GetGlobalPosition(win->xtd.edb.edit,WheelSensorX,WheelSensorY)
    if (MOUSEX>=WheelSensorX) and (MOUSEX<WheelSensorX + win->xtd.edb.edit->GadWidth) and _
       (MOUSEY>=WheelSensorY) and (MOUSEY<WheelSensorY + win->xtd.edb.edit->GadHeight) then
        SetScrollBar(vscroll,GetScrollBar( vscroll ) + WHEEL*3 )
        VScrollEditDisplay(edit,GetScrollBar(vscroll))
    end if  
  end if
  
  select case win->xtd.edb.scrollbarmodify
    case 1
      SetScrollBar(vscroll,TraceCursorRow(edit))
      SetScrollBar(hscroll,TraceCursorPosition(edit))        
    case 2
      SetScrollBar(vscroll,1,TContainer->GetNumRows+1,TraceCursorRow(edit))
      SetScrollBar(hscroll,TraceCursorPosition(edit))        
  end select
end sub


sub EDB_Update(win as sGUIWindow ptr)
  dim as Gadget ptr edit,vscroll,hscroll
  dim as sGUIText ptr TContainer
  edit=win->xtd.edb.edit
  vscroll=win->xtd.edb.vscroll
  hscroll=win->xtd.edb.hscroll
  TContainer=win->xtd.TContainer

  if win->xtd.edb.TimeStamp <> win->xtd.TContainer->GetTimeStamp then
    win->xtd.edb.NumRows = win->xtd.TContainer->GetNumRows
    win->xtd.edb.LongestRow = win->xtd.TContainer->GetLongestRow
    win->xtd.edb.CursorRow = win->xtd.TContainer->GetCursorRow
    win->xtd.edb.CursorPos = win->xtd.TContainer->GetCursorPosition
    
    SetScrollBar(vscroll,1,win->xtd.edb.NumRows,TraceCursorRow(edit),win->xtd.edb.RowsPerHeight)
    SetScrollBar(hscroll,1,win->xtd.edb.LongestRow+1,TraceCursorPosition(edit),win->xtd.edb.CharsPerWidth)      
    
    VScrollEditDisplay(edit,GetScrollBar(vscroll))
    HScrollEditDisplay(edit,GetScrollBar(hscroll))  
    win->xtd.edb.TimeStamp = win->xtd.TContainer->GetTimeStamp
    win->xtd.edb.edit->ReDraw=1   
  end if
end sub

end namespace
