 type ColorInfo
  RGBValue      as ulong
  Hue           as single
  Saturation    as single
  Value         as single
end type



sub SetRGB (byref ci as ColorInfo, col as ulong)
  dim as integer red,green,blue,min,max,range
 
  red=(col and &HFF0000) shr 16
  green=(col and &H00FF00) shr 8
  blue=(col and &H0000FF)  
  
  min=red
  if green<min then min=green
  if blue<min then min=blue  
  max=red
  if green>max then max=green
  if blue>max then max=blue  
     
  range=max-min
  
  /'
  'dim as integer redx,greenx,bluex
  'dim as single expandratio  
  '100% Saturation
  '100% Value
  if range then
    expandratio=(255/range)
    redx=(red-min) * expandratio
    greenx=(green-min) * expandratio
    bluex=(blue-min) * expandratio   
  else
    redx=255
    greenx=0
    bluex=0   
  end if
  ci.HueColor=(redx shl 16) or (greenx shl 8) or bluex  
  '/
  
  ci.RGBValue=col
  
  if range then
    select case max
      case red
        ci.Hue=0 + 60 * (green-blue)/range
        if ci.hue<0 then ci.hue +=360
      case green
        ci.Hue=120 + 60 * (blue-red)/range
      case blue
        ci.Hue=240 + 60 * (red-green)/range        
    end select   
  else    
    ci.Hue=0    
  end if  
  
  if max>0 then ci.Saturation=range/max*100 else ci.Saturation=0
  ci.Value=max/255*100   
end sub



sub SetHSV (byref ci as ColorInfo, hue as single, saturation as single, value as single)
  dim as integer huecase,red,green,blue,min,max,range  
  ci.Hue=hue
  ci.Saturation=saturation
  ci.Value=Value
  
  if ci.Hue<0 then ci.Hue=0
  if ci.Hue>=360 then ci.Hue=0
  if ci.Saturation<0 then ci.Saturation=0
  if ci.Saturation>100 then ci.Saturation=100  
  if ci.Value<0 then ci.Value=0
  if ci.Value>100 then ci.Value=100    
  max=255 * ci.Value/100
  range=max*ci.Saturation/100
  
  if range then
    min=max-range
    huecase=int(ci.Hue/60)
    select case huecase
      case 0
        red=max
        green=min + range*(ci.Hue/60)
        blue=min
      case 1
        red=max - range*((ci.Hue-60)/60) 
        green=max
        blue=min
      case 2
        red=min    
        green=max
        blue=min + range*((ci.Hue-120)/60)  
      case 3
        red=min     
        green=max - range*((ci.Hue-180)/60)
        blue=max  
      case 4
        red=min + range*((ci.Hue-240)/60)
        green=min
        blue=max  
      case 5
        red=max    
        green=min
        blue=max - range*((ci.Hue-300)/60)
    end select
  else
    red=max
    green=max
    blue=max
  end if
  ci.RGBValue= (red shl 16) or (green shl 8) or blue
end sub


sub MixColorCI (byref ColorC as ColorInfo, ColorA as ColorInfo, ColorB as ColorInfo, Weight as single)
  dim as single h,s,v
  h=ColorA.Hue + (ColorB.Hue - ColorA.Hue)*Weight
  s=ColorA.Saturation + (ColorB.Saturation - ColorA.Saturation)*Weight
  v=ColorA.Value + (ColorB.Value - ColorA.Value)*Weight
  SetHSV(ColorC,h,s,v)
end sub
