type _sGUIList as sGUIList

'Haupttype; intern in sGUIList verwendet
type node extends object
  prev_node     as node ptr'double linked List
  next_node     as node ptr'double linked List
  ntype         as integer
  Index         as integer
  Owner         as _sGUIList ptr
  'Data:
  'fr den einfachsten Fall einer Liste kann man in einem node einen Zeiger hinterlegen
  anypointer as any ptr
end type


type sGUIList extends node
  public:
  NumNodes     as integer'Anzahl der nodes
  private:
  first_node  as node ptr
  last_node   as node ptr
 
  TimeStamp   as double
  
  public:
  declare constructor
  declare destructor

  declare function AppendNew (nt as integer)  as any ptr 'erzeugt einen node und hngt es  a n  die Liste an, als letztes Element
  declare function PrependNew (nt as integer)  as any ptr 'erzeugt einen node und setzt es  v o r  die Liste, als erstes Element
  
  declare function GetFirst as any ptr              'liefert erstes Element als Zeiger
  declare function GetLast as any ptr               'liefert letztes Element als Zeiger
  'declare function GetAddr(Indx as integer )as any ptr 'liefert den Zeiger des Elementes mit dem Index Indx
  declare function GetAddr(Indx as integer, EntryNode as node ptr=0 )as any ptr 'liefert den Zeiger des Elementes mit dem Index Indx
  'declare function GetIndex(e as any ptr)as integer 'liefert den Index des Elementes mit der Adresse e
  declare function GetTimeStamp as double  
  declare function CheckNode(n as node ptr) as integer       'berprft node ob er in Liste existiert
  
  declare sub MoveTo(srcIndx as integer, dstIndx as integer)  'verschiebt ein Element auf Basis von Indizes 
  declare sub MoveToFirst(e as any ptr)              'verschiebt ein Element an die erste Position in der Liste
  declare sub MoveToLast(e as any ptr)               'verschiebt ein Element an die letzte Position der Liste
  declare sub MoveBehind(e as any ptr, de as any ptr)'verschiebt ein Element hinter das Element de
  declare sub MoveBefore(e as any ptr, de as any ptr)'verschiebt ein Element vor das Element de  
  declare sub PrintsGUIList

  declare sub DeleteNode(e as any ptr)       'lscht Element e sowohl aus der Liste (also Freistellen) als auch das Element(Objekt) selbst
  declare sub DeleteAll                      'lscht alle Elemente(Objekte), leere Liste

  private:
  declare sub UnLink(n as node ptr)           'stellt einen node frei und modifiziert entsprechend die Liste, ohne es zu lschen!!!
  declare sub LinkAsFirst(n as node ptr)      'fgt ein freigestelltes node an den sGUIListenanfang (als first_node) ein
  declare sub LinkAsLast(n as node ptr)       'hngt ein freigestelltes node ans sGUIListenende (als last_node) an
  declare sub LinkBehindDest(n as node ptr, dest as node ptr)'setzt ein freigestelltes node hinter dest in die Liste
  declare sub LinkBeforeDest(n as node ptr, dest as node ptr)'setzt ein freigestelltes node vor dest in die Liste

  declare sub MakeIndices
end type


constructor sGUIList
  TimeStamp=timer
end constructor


destructor sGUIList
  DeleteAll
end destructor


function sGUIList.AppendNew (nt as integer) as any ptr
  dim as any ptr e
  e=NewNode(nt)
  if e then
    LinkAsLast cast(node ptr,e)
    'MakeIndices
    'Weiterzhlen geht schneller und sollte unproblematisch sein
    NumNodes +=1
    cast(node ptr,e)->Index=NumNodes 
    cast(node ptr,e)->Owner=@this   
    function=e
  end if
  TimeStamp=timer
end function


function sGUIList.PrependNew (nt as integer) as any ptr
  dim as any ptr e
  e=NewNode(nt)
  if e then
    LinkAsFirst cast(node ptr,e)
    MakeIndices
    cast(node ptr,e)->Owner=@this
    function=e
  end if
  TimeStamp=timer
end function


function sGUIList.GetFirst as any ptr
  function=first_node
end function


function sGUIList.GetLast as any ptr
  function=last_node
end function

/'
function sGUIList.GetAddr(Indx as integer )as any ptr
  function=0
  dim as node ptr n,found
  found=0
  n=first_node
  if n then
    do
      if n->Index = Indx  then found=n
      n=n->next_node
    loop until (n=0) or (found<>0)
    function=found
  end if 
end function
'/


function sGUIList.GetAddr(Indx as integer, EntryNode as node ptr=0 )as any ptr
  function=0
  dim as node ptr n,found
  dim as integer en_Index,diff,mode
  
  if Indx<(NumNodes-Indx) then mode=1 else mode=2

  if EntryNode then
    en_Index=EntryNode->Index
    diff=abs(Indx-en_Index) 
    if (diff<Indx) and diff<(NumNodes-Indx) then 
      if Indx>en_Index then mode=3 else mode=4
    end if
  end if
  
  select case mode
    case 1'Suche vom Beginn vorwrts
      n=first_node
      do
        if n->Index = Indx  then found=n
        n=n->next_node
      loop until (n=0) or (found<>0)
  
    case 2'Suche vom Ende rckwrts
      n=last_node
      do
        if n->Index = Indx  then found=n
        n=n->prev_node
      loop until (n=0) or (found<>0)
      
    case 3'Suche von EntryNode vorwrts
      n=EntryNode
      do
        if n->Index = Indx  then found=n
        n=n->next_node
      loop until (n=0) or (found<>0)
  
    case 4'Suche von EntryNode rckwrts
      n=EntryNode
      do
        if n->Index = Indx  then found=n
        n=n->prev_node
      loop until (n=0) or (found<>0) 
  end select 
  function=found 
end function

/'
function sGUIList.GetIndex(e as any ptr) as integer
  function=cast(node ptr,e)->Index
end function
'/

function sGUIList.GetTimeStamp as double
  function=TimeStamp
end function


function sGUIList.CheckNode(n as node ptr) as integer
  function=0
  dim as node ptr nn
  dim as integer found=0
  nn=first_node
  if (nn>0) and (n>0) then
    do
      if nn=n then found=1
      nn=nn->next_node
    loop until (nn=0) or (found<>0)
    function=found
  end if
end function


sub sGUIList.MoveTo(srcIndx as integer, dstIndx as integer)
  dim as node ptr src,dst
  if (srcIndx>0) and (srcIndx<=NumNodes) then'valide Quelle
    if (dstIndx>0) and (dstIndx<=NumNodes) then'valides Ziel
      if srcIndx<>dstIndx then        'geeeenau, denn warum sollen wir hier berhaupt was tun :)
        src=GetAddr(srcIndx)                         
        if dstIndx=1 then             'src an den ListenAnfang          
          UnLink src
          LinkAsFirst(src)      
        elseif dstIndx=NumNodes then  'src ans ListenEnde
          UnLink src
          LinkAsLast(src)         
        else                          'src irgendwo anders hin
          dst=GetAddr(dstIndx,src)
          UnLink src
          if srcIndx<dstIndx then     'src Richtung ListenEnde verschieben
            LinkBehindDest(src, dst)
          else                        'src Richtung ListenAnfang verschieben
            LinkBeforeDest(src, dst)
          end if      
        end if
        MakeIndices
        TimeStamp=timer 
      end if
    end if
  end if
end sub


sub sGUIList.MoveToFirst(e as any ptr)
  dim as node ptr n=cast(node ptr,e)
  'if CheckNode(n) then
    UnLink n
    LinkAsFirst(n)
    MakeIndices
    TimeStamp=timer
  'end if
end sub


sub sGUIList.MoveToLast(e as any ptr)
  dim as node ptr n=cast(node ptr,e)
  'if CheckNode(n) then
    UnLink n
    LinkAsLast(n)
    MakeIndices
    TimeStamp=timer
  'end if
end sub


sub sGUIList.MoveBehind(e as any ptr, de as any ptr)
  dim as node ptr n=cast(node ptr,e)
  dim as node ptr dest=cast(node ptr,de)  
  'if (n<>dest) and (CheckNode(n)) and (CheckNode(dest)) then
  if (n<>dest) then
    UnLink n
    LinkBehindDest(n, dest)
    MakeIndices
    TimeStamp=timer
  end if
end sub


sub sGUIList.MoveBefore(e as any ptr, de as any ptr)
  dim as node ptr n=cast(node ptr,e)
  dim as node ptr dest=cast(node ptr,de)  
  'if (n<>dest) and (CheckNode(n)) and (CheckNode(dest)) then
  if (n<>dest) then
  UnLink n
    LinkBeforeDest(n, dest)
    MakeIndices
    TimeStamp=timer
  end if
end sub


sub sGUIList.PrintsGUIList
  dim as node ptr n
  n=first_node
  if (n>0) then
    do
      print "n: " & n; n->Index , "pn: " & n->prev_node , "nn: " & n->next_node
      n=n->next_node
    loop until (n=0)
    print
  end if
end sub


sub sGUIList.UnLink(n as node ptr)
  dim as integer UnLinkcase
  if n then
    if (n=first_node) and (n=last_node) then UnLinkcase=1  'es existiert nur ein node(ist damit sowohl erstes als auch letztes), das herausgelst wird
    if (n=first_node) and (n<>last_node) then UnLinkcase=2 'erste node der Liste wird herausgelst
    if (n<>first_node) and (n<>last_node) then UnLinkcase=3'weder erstes noch letztes node(also mittendrin) wird herausgelst
    if (n<>first_node) and (n=last_node) then UnLinkcase=4 'letztes node wird herausgelst
    select case UnLinkcase
      case 1
        first_node=0
        last_node=0
      case 2
        n->next_node->prev_node=0 'im Nachfolger den Link zum Vorgnger lschen, damit wird auch innerhalb der Liste der Anfang neu definiert (zb. fr Rckwrtssuche)
        first_node=n->next_node   'Nachfolger von n zum ersten node machen
      case 3
         '              +------------------+
         '              |                  |
         '      B       | C          D     |
         '   <-a c->   <-b d->    <-c n->  |
         '                  |              |
         '                  |              |  node C freistellen
         '      B           |        D     |
         '   <-a d->        |     <-b n->  |
         '        ^         |      ^       |
         '        |         |      |       |
         '        +---------+      +-------+

        n->next_node->prev_node = n->prev_node'im Nachfolger den Link zum "Vorvorgnger" setzen
        n->prev_node->next_node = n->next_node'im Vorgnger den Link zum "Nachnachfolger" setzen
      case 4
        n->prev_node->next_node=0             'im Vorgnger den Link zum Nachfolger lschen(=0), damit wird auch innerhalb der Liste das Ende neu definiert
        last_node=n->prev_node                'Vorgnger von n zum letzten node machen
    end select
    n->prev_node=0                            'alle Verlinkungen im freigestellten node n auf 0 setzen
    n->next_node=0
  end if
end sub


sub sGUIList.LinkAsFirst(n as node ptr)
  n->prev_node=0              'zur Sicherheit erst einmal alle Verlinkungen im bergebenen node auf 0 setzen
  n->next_node=0
  'Verlinken
  if first_node then          'sollte schon mindestens ein node existieren, dann...
    first_node->prev_node=n   'node n dort als Vorgnger definieren
    n->next_node=first_node   'im node n bisheriges erstes node als Nachfolger definieren
    first_node=n              'node n wird zum ersten der Liste
  else                        'sollte noch kein node existieren dann...
    first_node=n              'sowohl...
    last_node=n               ' ...als auch
  end if
end sub


sub sGUIList.LinkAsLast(n as node ptr)
  n->prev_node=0              'zur Sicherheit erst einmal alle Verlinkungen im bergebenen node auf 0 setzen
  n->next_node=0
  'Verlinken
  if last_node then           'sollte schon mindestens ein node existieren, dann...
    last_node->next_node=n    'node n dort als Nachfolger definieren
    n->prev_node=last_node    'im node n bisheriges letzes node als Vorgnger definieren
  else                        'sollte noch kein node existieren dann...
    first_node=n              'sowohl...    
  end if
  last_node=n               ' ...der letze wird er auf jeden Fall
end sub


sub sGUIList.LinkBehindDest(n as node ptr, dest as node ptr) 
  dim as node ptr nn
  if dest=last_node then
    LinkAsLast(n)  
  else
    nn=dest->next_node'Nachfolger von dest merken
  
    dest->next_node=n 'in dest node n als Nachfolger definieren
    nn->prev_node=n   'in Nachfolger von dest node n als Vorgnger definieren
  
    n->prev_node=dest 'in node n dest als Vorgnger definieren
    n->next_node=nn   'in node n Nachfolger von dest als Nachfolger definieren
  end if
end sub


sub sGUIList.LinkBeforeDest(n as node ptr, dest as node ptr) 
  dim as node ptr pn
  if dest=first_node then
    LinkAsFirst(n)
  else
    pn=dest->prev_node'Vorgnger von dest merken
    
    pn->next_node=n   'in dests Vorgnger node n als Nachfolger definieren
    dest->prev_node=n 'in dest node n als Vorgnger definieren
    
    n->next_node=dest 'in node n dest als Nachfolger definieren
    n->prev_node=pn   'in node n dests ehemaligen Vorgnger als Vorgnger definieren    
  end if
end sub


sub sGUIList.MakeIndices
  dim as node ptr n,nn
  n=first_node
  
  NumNodes=0
  if n then
    do
      NumNodes +=1        'Anzahl aller nodes
      nn=n->next_node     'Nachfolger von n holen
      n->Index=NumNodes   'Index in node schreiben
      n=nn                'Nachfolger zum akuellem node machen
    loop until n=0        'wenn keine node >>> raus!!!
  end if
end sub


sub sGUIList.DeleteNode(e as any ptr)
  dim as node ptr n=cast(node ptr,e)  
  'if CheckNode(n) then'gibt es den Eintrag/node in der Liste???
		UnLink n
		KillNode (e)
		MakeIndices
	'end if
  TimeStamp=timer 
end sub


sub sGUIList.DeleteAll
  dim as node ptr n,nn
  n=first_node
  if n then
    do
      nn=n->next_node 'Nachfolger merken
      'DeleteNode n   'hierber wird die Liste nach jedem Lschen korrigiert, sicherer aber eigentlich nicht notwendig
      KillNode (n)
      n=nn            'Nachfolger zum akuellem node machen
    loop until n=0    'wenn keine node >>> raus!!!
  end if
  'zum Schlu die Zeiger, die auf sGUIListenanfang und -ende verweisen, lschen
  first_node=0
  last_node=0
	NumNodes=0
  
  TimeStamp=timer 
end sub
