#include once "file.bi"'ohne sGUI bitte aktivieren
type _sGUIText as sGUIText

'UDT fr Beschreibung einer Zeile
type TextRow
  text          as string       'enthlt die Zeile
  index         as integer      'Zeilennummer
  previousrow   as TextRow ptr 'Zeiger auf vorhergehende Zeile, 0 wenn 1.Zeile
  nextrow       as TextRow ptr 'Zeiger auf nachfolgende Zeile, 0 wenn letzte Zeile
  Parent        as _sGUIText ptr'das Mutterschiff, damit jede Zeile Auskunft geben kann wo sie hingehrt
end type



'UDT fr Beschreibung einer eindeutigen Textposition, fr Cursor,Clipboardmarker
type TextMark
  txtrow     as TextRow ptr
  position  as integer
end type



'"Objekt" zur Verwaltung und Editieren eines mehrzeiligen Textes
type sGUIText extends node'extends node' auskommentieren
  private:
  cursor      as TextMark   'Hmmm ;)
  firstrow    as TextRow ptr'Zeiger auf erste Zeile
  lastrow     as TextRow ptr'Zeiger auf letzte Zeile
  longestrow  as integer    'eine Art Schleppzeiger fr die bisher lngste Zeile, die zur Laufzeit editiert/geladen wurde
                            'ob diese tatschlich noch existiert, ist nicht gegeben, der Wert ist mehr als Highscore zu verstehen ;)
                            'kann in einer GUI fr die Konfiguration eines horizontalen Scrollbalkens verwendet werden
  timestamp   as double
'kommt vielleicht spter mal: ein internes Clipboard
'    clipstart     as TextMark
'    clipend       as TextMark
'    clipfirstline as TextRow ptr
'    cliplastline  as TextRow ptr
  public:
  declare constructor
  declare destructor
  'Editierfunktionen
  declare sub KeyAddChar(c as string)
  declare sub KeyBackspace
  declare sub KeyDelete
  declare sub KeyReturn
  'Cursorsteuerung
  declare sub CursorUp
  declare sub CursorDown
  declare sub CursorLeft
  declare sub CursorRight
  declare sub CursorKeyPos1'added by MilkFreeze, modified by Muttonhead :)
  declare sub CursorKeyEnd'added by MilkFreeze, modified by Muttonhead :)
  declare sub SetCursor overload(row as integer,p as integer)
  declare sub SetCursor (row as TextRow ptr,p as integer)
  'Info
  declare function GetCursorRow as integer
  declare function GetCursorPosition as integer
  declare function GetNumRows as integer
  declare function GetRowAddress(i as integer) as TextRow ptr
  declare function GetRowIndex(row as TextRow ptr) as integer
  declare function GetLongestRow  as integer
  declare function GetTimeStamp as double
  'Input/Output
    'Laden aus Datei/String
  declare sub LoadText (filename as string,linebreak as string=chr(13,10))
  declare sub SetText (s as string,linebreak as string=chr(13,10))
    'Ausgabe/Speichern als Datei/String
  declare sub SaveText (filename as string, linebreak as string=chr(13,10))
  declare function GetText (linebreak as string=chr(13,10)) as string
    'Abfrage Zeileninhalt
  declare function GetRowContent overload(i as integer) as string
  declare function GetRowContent (row as TextRow ptr) as string
    '(Er)-Setzen des Zeileninhaltes einer bestimmten Zeile
  declare sub SetRowContent overload(i as integer,t as string)
  declare sub SetRowContent (row as TextRow ptr,t as string)
    'Zeile an vorhandenen Text anhngen
  declare sub AppendRow (t as string="")
    'Text komplett lschen
  declare sub ClearText

    'nur fr Testzwecke des TOs
  declare sub printout
  private:
  'Speicherverwaltung & Zeilenlogik
  declare function CreateBlankRow as TextRow ptr    'erzeugt eine nicht verlinkte Zeile (NEW "gewrappt")
  declare function AppendBlankRow as TextRow ptr    'Hngt ein Leerzeile am Ende des Textes an/ Erzeugt Startzeile
  declare function InsertBlankRow(prev as TextRow ptr) as TextRow ptr'Fgt eine Zeile zwischen 2 anderen
  declare sub DeleteAllRows (row as TextRow ptr)      'Lscht alle Zeilen ab/einschlielich bergebene(r) Zeile
  'interne Statistik
  declare sub MakeIndex'Versieht alle Zeilen mit einer Zeilennummer
end type



constructor sGUIText
  /'
  AppendBlankRow 'bei Erstellung eines TOs ist mindestens eine Zeile notwendig, wird hiermit erledigt
  longestrow=0
  cursor.txtrow=lastrow
  cursor.position=len(lastrow->text)+1
  '/
  cursor.txtrow=0
  cursor.position=0'1
  firstrow=0
  lastrow=0
  timestamp=timer
end constructor



destructor sGUIText
  DeleteAllRows firstrow
  'DeleteAllRows clipboard
end destructor


'Editierfunktionen*************************************************************
sub sGUIText.KeyAddChar(c as string)
  'sollte noch keine Zeile existieren, erste Erzeugen und Cursor setzen
  if firstrow=0 then
    AppendBlankRow
    longestrow=0
    cursor.txtrow=lastrow
    cursor.position=len(lastrow->text)+1
    makeindex
  end if

  dim as integer rowlength
  cursor.txtrow->text= left(cursor.txtrow->text,cursor.position-1) & c & right(cursor.txtrow->text,len(cursor.txtrow->text)-cursor.position+1)
  cursor.position +=1
  rowlength=len(cursor.txtrow->text)
  if rowlength>longestrow then longestrow=rowlength
  timestamp=timer
end sub



sub sGUIText.KeyBackspace
  if firstrow=0 then exit sub

  dim as TextRow ptr prev,nxt
  dim as string textbuffer
  if cursor.position=1 then        'bei Backspace von erster Position in der Zeile erfolgt (wenn mglich) ein Lschen der Zeile

    if cursor.txtrow<>firstrow then'Zeile 1 Position 1 kein BACKSPACE mglich
      prev=cursor.txtrow->previousrow  'vorherige Zeile holen
      nxt=cursor.txtrow->nextrow   'nachfolgende Zeile holen(kann bei letzter Zeile auch 0 sein)

      if cursor.txtrow=lastrow then'sollte es sich um die letzte Zeile handeln
        lastrow=prev              'dann ist das entsprechend im TO zu ndern
        prev->nextrow=0           'prev hat nun keinen Nachfolger mehr
      else                         'ansonsten Verknpfung zwischen Vorgnger und Nachfolger der zu Lschenden herstellen
        prev->nextrow = nxt
        nxt->previousrow = prev
      end if
      'damit ist die zu lschende Zeile (Cursorzeile) freigestellt

      textbuffer=cursor.txtrow->text'eventuell vorhandenen Text der zu lschenden Zeile merken
      cursor.txtrow->text=""        'Inhalt lschen(eigentlich nicht ntig)
      delete cursor.txtrow          'Zeile entgltig lschen

      'Cursor hinter den Text der Vorherigen setzen
      cursor.position=len(prev->text)+1
      cursor.txtrow=prev

      'eventuell vorhandenen Text aus gelschter Zeile anfgen
      prev->text = prev->text & textbuffer

      makeindex
    end if

  else 'ansonsten "normales" In-Line-BACKSPACE

    cursor.txtrow->text=left(cursor.txtrow->text,cursor.position-2)  & _
      right(cursor.txtrow->text,len(cursor.txtrow->text)-cursor.position+1)
    cursor.position -=1

  end if
  timestamp=timer
end sub



sub sGUIText.KeyDelete
  if firstrow=0 then exit sub

  dim as TextRow ptr nxt,nnxt
  dim as string textbuffer

  if cursor.position>len(cursor.txtrow->text) then 'wenn Cursor hinter einer Zeile erfolgt (wenn mglich) ein Lschen der folgenden Zeile
    if cursor.txtrow<>lastrow then                'hinter letzter Zeile kein DELETE mglich
      nxt=cursor.txtrow->nextrow                  'nchste Zeile holen(die gelscht wird)
      nnxt=nxt->nextrow                          'bernchste Zeile holen(kann auch 0 sein)

      if nxt=lastrow then      'sollte Nchste die letzte Zeile sein
        lastrow=cursor.txtrow   'dann ist das entsprechend im TO zu ndern
        cursor.txtrow->nextrow=0'aktuelle Cursorzeile hat nun keinen Nachfolger mehr
      else                      'ansonsten Verknpfung zwischen Cursorzeile und Nachfolger der zu Lschenden herstellen
        cursor.txtrow->nextrow = nnxt
        nnxt->previousrow = cursor.txtrow
      end if
      'damit ist die zu lschende Zeile (nxt) freigestellt

      textbuffer=nxt->text'eventuell vorhandenen Text der zu lschenden Zeile merken
      nxt->text=""        'Inhalt lschen(eigentlich nicht ntig)
      delete nxt          'Zeile entgltig lschen

      'eventuell vorhandenen Text aus gelschter Zeile anfgen
      cursor.txtrow->text = cursor.txtrow->text & textbuffer

      MakeIndex
    end if
  else'ansonsten "normales" In-Line-DELETE
    cursor.txtrow->text=left(cursor.txtrow->text,cursor.position-1) & _
      right(cursor.txtrow->text,len(cursor.txtrow->text)-cursor.position)
  end if
  timestamp=timer
end sub



sub sGUIText.KeyReturn
  'sollte noch keine Zeile existieren, erste erzeugen und Cursor setzen
  if firstrow=0 then
    AppendBlankRow
    longestrow=0
    cursor.txtrow=lastrow
    cursor.position=len(lastrow->text)+1
  end if

  'In der Regel wird durch Return eine neue Zeile geffnet.
  dim as TextRow ptr ntr
  dim as string textbuffer

  'String der Zeile in Abhngigkeit von der Cursorposition splitten
  '1.Fall
  'Cursor ist hinter dem String, also Len(Zeile)+1. Der String bleibt vollstndig in der alten Zeile und
  'es wird eine neue leere Zeile "darunter" erzeugt.Der Cursor ist in der neuen Zeile an Position 1
  if cursor.position>len(cursor.txtrow->text) then textbuffer=""
  '2.Fall
  'Cursor ist im Bereich Position >1 bis Len(Zeile). String bleibt bis zur Position Cursor-1 in der alten
  'Zeile, ab dem Cursor wandert der Rest des Strings in die neue Zeile. Der Cursor ist in der neuen
  'Zeile an Position 1
  if cursor.position>1 and cursor.position<=len(cursor.txtrow->text) then
    textbuffer=right(cursor.txtrow->text , (len(cursor.txtrow->text)-cursor.position+1) )'Zeilentext ab Cursor sichern
    cursor.txtrow->text=left(cursor.txtrow->text , cursor.position-1)                    'Zeilentext der Cursorzeile verkrzen
  end if
  '3.Fall
  'Cursor ist an Position 1. Der gesamte String geht in die neue Zeile und die alte Zeile wird leer.
  'Der Cursor ist in der neuen Zeile an Position 1
  if cursor.position=1 then
    textbuffer=cursor.txtrow->text 'Zeileninhalt merken
    cursor.txtrow->text=""         'Inhalt von CursorZeile lschen
  end if

  'neue Zeile erzeugen
    if cursor.txtrow=lastrow then    'wenn die Zeile ans Textende angefgt wird dann...
    AppendBlankRow                  'Zeile anhngen
    lastrow->text=textbuffer        'gegebenfalls Text hineinkopieren
    cursor.txtrow=lastrow            'Cursor in die letzte Zeile an Position 1 setzen
    cursor.position=1
  else                               'wenn die Zeile mittendrin eingefgt wird dann...
    ntr=InsertBlankRow(cursor.txtrow)
    ntr->text=textbuffer             'gegebenfalls Text hineinkopieren
    cursor.txtrow=ntr                 'Cursor in die neue Zeile an Position 1 setzen
    cursor.position=1
    MakeIndex
  end if
  timestamp=timer
end sub



'Cursorsteuerung***************************************************************
sub sGUIText.SetCursor (row as integer,p as integer)
  if firstrow=0 then exit sub

  cursor.txtrow=GetRowAddress(row)
  if p<0 then p=1
  if p>len(cursor.txtrow->text)+1 then p=len(cursor.txtrow->text)+1
  cursor.position=p
  timestamp=timer
end sub



sub sGUIText.SetCursor (row as TextRow ptr,p as integer)
  if firstrow=0 then exit sub

  cursor.txtrow=row
  if p<0 then p=1
  if p>len(cursor.txtrow->text)+1 then p=len(cursor.txtrow->text)+1
  cursor.position=p
  timestamp=timer
end sub



sub sGUIText.CursorUp
  if firstrow=0 then exit sub

  'nicht ber die erste Zeile hinaus
  if cursor.txtrow<>firstrow then
    cursor.txtrow=cursor.txtrow->previousrow'damit sind wir schon in der vorhergehenden Zeile!!!
    'Falls Zeile krzer ist als aktuelle Cursorposition mu entsprechend angepat werden
    'Cursor wird dann hinter der Zeile positioniert
    if len(cursor.txtrow->text)+1 < cursor.position then cursor.position=len(cursor.txtrow->text)+1
  end if
  timestamp=timer
end sub



sub sGUIText.CursorDown
  if firstrow=0 then exit sub

  'nicht ber die letzte Zeile hinaus
  if cursor.txtrow<>lastrow then
    cursor.txtrow=cursor.txtrow->nextrow'damit sind wir schon in der nachfolgenden Zeile!!!
    'Falls Zeile krzer ist als aktuelle Cursorposition mu entsprechend angepat werden
    'Cursor wird dann hinter der Zeile positioniert
    if len(cursor.txtrow->text)+1 < cursor.position then cursor.position=len(cursor.txtrow->text)+1
  end if
  timestamp=timer
end sub



sub sGUIText.CursorLeft
  if firstrow=0 then exit sub

  cursor.position -=1                          'Cursorposition um 1 verringern
  if cursor.position<1 then                    'ist diese dann 0, was nicht sein darf, dann...
    if cursor.txtrow<>firstrow then            'befinden wir uns nich nicht in der ersten Zeile
      cursor.txtrow=cursor.txtrow->previousrow      'dann vorhergehende Zeile zur CursorZeile machen
      cursor.position=len(cursor.txtrow->text)+1'Cursor ans Ende dieser Zeile setzen
    else                                       'sind wir doch schon in der ersten Zeile
      cursor.position=1                        'dann Position 1 setzen, weiter gehts ja nicht
    end if
  end if
  timestamp=timer
end sub



sub sGUIText.CursorRight
  if firstrow=0 then exit sub

  cursor.position +=1                              'Cursorposition um 1 erhhen
  if cursor.position>len(cursor.txtrow->text)+1 then'ist diese dann mehr als eine Position hinter dem Text, was nicht sein darf, dann...
    if cursor.txtrow<>lastrow then                 'wir befinden uns nich nicht in der letzten Zeile
      cursor.txtrow=cursor.txtrow->nextrow          'dann nchste Zeile zur CursorZeile machen
      cursor.position=1                            'Cursor an den Anfang dieser Zeile setzen
    else                                           'sind wir doch schon in der letzten Zeile
      cursor.position=len(cursor.txtrow->text)+1    'dann auf eine Position hinter Text setzen, weiter gehts ja nicht
    end if
  end if
  timestamp=timer
end sub


'added by MilkFreeze, modified by Muttonhead :)
Sub sGUIText.CursorKeyPos1
  if firstrow=0 then exit sub
	cursor.position=1
  timestamp=timer  
End Sub


'added by MilkFreeze, modified by Muttonhead :)
Sub sGUIText.CursorKeyEnd
  if firstrow=0 then exit sub
	cursor.position=len(cursor.txtrow->text)+1
  timestamp=timer
End Sub



'Info**************************************************************************
function sGUIText.GetCursorRow as integer
 'if firstrow=0 then function=0 else function=GetRowIndex(cursor.txtrow)
  if firstrow=0 then function=1 else function=GetRowIndex(cursor.txtrow)
end function



function sGUIText.GetCursorPosition as integer
  function=cursor.position
end function



'liefert die Zeilenzahl des Textes
function sGUIText.GetNumRows as integer
  if lastrow then function=lastrow->index else function=0
end function



'liefert die Adresse einer Zeile auf Basis des Index
function sGUIText.GetRowAddress(i as integer) as TextRow ptr
  if firstrow=0 then
    function=0
  else
    dim as TextRow ptr row,found
    row=firstrow
    found=0
    do
      if row->index=i then found=row
      row=row->nextrow
    loop until (found<>0) or (row=0)
    function=found
  end if
end function



'liefert die Zeilennummer(Index) einer Zeile auf Basis der Adresse
function sGUIText.GetRowIndex(row as TextRow ptr) as integer
  if firstrow=0 then
    function=0
  else
    function=row->index
  end if
end function

function sGUIText.GetLongestRow  as integer
  function=longestrow
end function

function sGUIText.GetTimeStamp as double
  function=timestamp
end function

'Input/Output******************************************************************
sub sGUIText.LoadText (filename as string,linebreak as string=chr(13,10))
  dim as integer ff
  dim as string fulltext=""

  'if fileexists(filename) then
    ff=freefile
    open filename for binary as ff
      if lof(ff) then fulltext=space(lof(ff))
      get #ff, ,fulltext
    close ff
   SetText (fulltext,linebreak)
    fulltext=""
  'end if
  'SetCursor(1,1)
  timestamp=timer
end sub



sub sGUIText.SetText (s as string,linebreak as string=chr(13,10))
  dim as integer searchstart,tabsize,numspaces,tabpos,newtabpos
	dim as integer llb,ls,rowlength,linestart,lineend

	'Tabulator Expander
	tabsize=2
	searchstart=1
	do
    tabpos = instr(searchstart,s,chr(9))
    if tabpos>0 then
    	newtabpos=int((tabpos+tabsize-1)/tabsize)*tabsize + 1
    	numspaces=newtabpos-tabpos
			s=left(s, tabpos-1) & space(numspaces) & mid(s, tabpos+1)
		end if
		searchstart=tabpos
  loop until tabpos=0

	'Line Split
  llb=len(linebreak)
  ls=len(s)
  linestart=1

  DeleteAllRows firstrow
  longestrow=0

  do
    lineend = instr(linestart,s,linebreak)
    if lineend=0 then lineend=ls+1
    AppendBlankRow
    lastrow->text=mid(s,linestart,lineend-linestart)
    rowlength=len(lastrow->text)
    if rowlength>longestrow then longestrow=rowlength
    linestart=lineend+llb
  loop until lineend>ls

  SetCursor(1,1)
  MakeIndex
  timestamp=timer
end sub



sub sGUIText.SaveText (filename as string, linebreak as string=chr(13,10))
  if firstrow=0 then exit sub

  dim as integer ff=freefile
  dim as TextRow ptr row
  open filename for output as ff
    row=firstrow
    do
      print #ff, row->text;
      if row<>lastrow then print #ff,linebreak;
      row=row->nextrow
    loop until row=0
  close ff
end sub



function sGUIText.GetText (linebreak as string=chr(13,10)) as string
  if firstrow=0 then
    function=""
  else
    dim as TextRow ptr row
    dim as string s
    s=""
    row=firstrow
    do
      s =s & row->text
      if row<>lastrow then s =s & linebreak
      row=row->nextrow
    loop until row=0
    function=s
  end if
end function



function sGUIText.GetRowContent (i as integer) as string
  if firstrow=0 then function="" else function=GetRowAddress(i)->text
end function



function sGUIText.GetRowContent (row as TextRow ptr) as string
  function=row->text
end function



sub sGUIText.SetRowContent (i as integer,t as string)
  dim as integer rowlength
  dim as TextRow ptr row
  row= GetRowAddress(i)
  row->text=t
  rowlength=len(row->text)
  if rowlength>longestrow then longestrow=rowlength
  timestamp=timer
end sub



sub sGUIText.SetRowContent (row as TextRow ptr,t as string)
  dim  as integer rowlength
  row->text=t
  rowlength=len(row->text)
  if rowlength>longestrow then longestrow=rowlength
  SetCursor (row,1)
  timestamp=timer
end sub



sub sGUIText.AppendRow (t as string="")
  dim as integer rowlength
  AppendBlankRow
  lastrow->text=t
  rowlength=len(lastrow->text)
  if rowlength>longestrow then longestrow=rowlength
  SetCursor (lastrow,1)
end sub



sub sGUIText.ClearText
  DeleteAllRows firstrow
  timestamp=timer
end sub



'dient nur zu Testzwecken!!!!
sub sGUIText.printout
  dim as TextRow ptr row
  dim as integer rc=0
  if firstrow then
    screenlock
    cls
    row=firstrow
    do
      draw string(0,rc*16),row->text
      row=row->nextrow
      rc +=1
    loop until row=0
    draw string((cursor.position-1)*8,(GetRowIndex(cursor.txtrow)-1)*16+1),"_"
    screenunlock
  end if
end sub



'Speicherverwaltung & Zeilenlogik**********************************************
function sGUIText.CreateBlankRow as TextRow ptr
  function=0
  dim newrow as TextRow ptr
  newrow=new TextRow
  if newrow then
    newrow->text=""     'neue Zeile ist leer
    newrow->index=0     'keine Indexnummer
    newrow->nextrow=0  'kein Vorgnger
    newrow->nextrow=0  'kein Nachfolger
    newrow->Parent=@this'Adresse des TO zu dem diese Zeile gehrt
    function=newrow
  end if
end function



function sGUIText.AppendBlankRow as TextRow ptr
  function=0
  dim newrow as TextRow ptr
  newrow=CreateBlankRow
  if newrow then
    'Verlinken

    if lastrow=0 then   'wenn die erste Zeile erzeugt wird
      newrow->previousrow=0  'keinen Vorgnger
      newrow->nextrow=0  'keinen Nachfolger
      newrow->index=1     'da erste bekommt sie auch den Index 1
      firstrow=newrow    'Zeile als erste im TO definieren
      lastrow=newrow     'Zeile als letzte im TO definieren... ist also beides!!!
    else                 'Anhngen an vorhandene Zeilen
      newrow->previousrow=lastrow'Vorgnger in neuer Zeile verlinken
      newrow->nextrow=0  'keinen Nachfolger
      newrow->index=lastrow->index + 1'Index um eins hher als Vorgnger
      lastrow->nextrow=newrow'neue Zeile im Vorgnger verlinken
      lastrow=newrow     'neue Zeile im TO als Letzte eintragen
    end if
    function=newrow
  end if
end function



function sGUIText.InsertBlankRow(prev as TextRow ptr) as TextRow ptr
  function=0
  dim as TextRow ptr nextrow,newrow
  nextrow=prev->nextrow             'Nachfolger merken
  newrow=CreateBlankRow
    if newrow then
    'Verlinken
    '(nach hinten)
    prev->nextrow=newrow            'neue Zeile in prev als Nachfolger eintragen
    newrow->previousrow=prev        'prev in neuer Zeile als Vorgnger eintragen

    '(nach vorn)
    newrow->nextrow=nextrow         'Nachfolger in neue Zeile als Nachfolger...
    nextrow->previousrow=newrow     'neue Zeile als (neuer) Vorgnger des alten Nachfolgers... *hust* 
    'hhmm jahhh... die letzten 2 Kommentare lesen sich sehr bld, ist aber so... XD !!!
    function=newrow
  end if
end function



sub sGUIText.DeleteAllRows (byval row as TextRow ptr)
  dim as TextRow ptr nextrow

  if row=firstrow then
    firstrow=0
    lastrow=0
    longestrow=0
    cursor.txtrow=0
    cursor.position=0'1
  end if

  if row then             'wenn Zeile vorhanden(row>0), dann...
    do
      nextrow=row->nextrow'Hole aus der Zeile den Zeiger der nchsten Zeile (ist 0 wenn keine nchste Zeile existiert)
      delete row          'Lsche aktuelle Zeile
      row=nextrow         'Erklre nchste Zeile zur aktuellen,kann dabei auch zu 0 werden
    loop until row=0      'wenn keine Zeile da dann raus aus Loop
  end if
end sub



'interne Statistik*************************************************************
sub sGUIText.MakeIndex
  dim as TextRow ptr row
  dim as integer counter=0
  row=firstrow        'Hole erste Zeile
  do
    counter +=1
    row->index=counter 'Schreibe Zeilennummer in Zeile
    row=row->nextrow   'Hole aus der Zeile den Zeiger der nchsten Zeile
  loop until row=0     'wenn keine Zeile da dann raus aus Loop
end sub