'Color Stuff
declare function ColorSelection (BodyColor as ulong, BodySelectColor as ulong, selected as integer ,hover as integer,hovermode as integer=0) as ulong
declare function EntryBGColorSelection (selected as integer, hover as integer) as ulong
declare function EntryTXTColorSelection (selected as integer, hover as integer) as ulong
declare sub CalcLight(ciBase as ColorInfo, Intensity as integer,byref ciDest as ColorInfo)
declare sub CalcDark(ciBase as ColorInfo, Intensity as integer,byref ciDest as ColorInfo)
declare sub CalcShiny(ciBase as ColorInfo, Intensity as integer,byref ciDest as ColorInfo)
'Fill Basics
declare sub ClearBox (img as FB.Image ptr,PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,col as ulong=Colors.Cleaning)
declare sub Raster (img as FB.Image ptr, PosX as integer, PosY as integer, BoxWidth as integer, BoxHeight as integer, col as ulong=Colors.GadSleepPattern, mode as integer=1)
declare sub GradientFXBox(img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer, _
                    ColorTopLeft as ulong,ColorTopRight as ulong,ColorBottomLeft as ulong,ColorBottomRight as ulong)
'Fills
declare sub StdFill (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
declare sub StdFillRounded (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0, cornercases as ubyte=15)

declare sub AltFillA (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
declare sub AltFillARounded (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)   

'Frames
declare sub GetFrameColor( b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0, byref ci as ColorInfo)
declare sub StdFrame (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0, switch as integer=-1)
declare sub StdFrameRounded (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0, switch as integer=-1, cornercases as ubyte=15)
declare sub GrdFrame (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer)
declare sub CornerShape (img as FB.Image ptr, PosX as integer, PosY as integer, BoxWidth as integer, BoxHeight as integer, selected as integer, top as ulong, bottom as ulong, topmerge as ulong=0, bottommerge as ulong=0, cornercases as ubyte=15)  
declare sub CornerTransMask (img as FB.Image ptr, PosX as integer,PosY as integer, BoxWidth as integer, BoxHeight as integer, cornercases as ubyte=15)

declare sub WinFrame (img as FB.Image ptr,PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,selected as integer=0)
declare sub WinShadow (img as FB.Image ptr,PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer)
declare sub RoundFrame (img as FB.Image ptr, PosX as integer,PosY as integer,Radius as integer,light as ulong, dark as ulong)

'Boxes
declare sub StdFilledBox (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
declare sub StdFilledBoxRounded (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0, cornercases as ubyte=15)
declare sub FilledBoxKnob (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
declare sub FilledBoxContainer (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
declare sub FilledBoxDrop (img as FB.Image ptr, b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0,mode as integer=0)
declare sub FilledBoxList (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
declare sub FilledBoxEntry (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,selected as integer=0,hover as integer=0)
declare sub FilledBoxRadio (img as FB.Image ptr, PosX as integer,PosY as integer,BoxSize as integer,Radius as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
declare sub FilledBoxCheckMark (img as FB.Image ptr, PosX as integer,PosY as integer,BoxSize as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
'Symbols
declare sub DrawMenuRBDot (img as FB.Image ptr, PosX as integer,PosY as integer, Radius as integer, col as ulong)
declare sub Symbol_Arrow (img as FB.Image ptr, PosX as integer,PosY as integer,size as integer,direction as integer,col as ulong,thickness as integer=2)

declare sub Symbol_CheckMark (img as FB.Image ptr, PosX as integer,PosY as integer,size as integer,col as ulong=Colors.Black)
declare sub Symbol_X (img as FB.Image ptr, PosX as integer,PosY as integer, col as ulong=Colors.Black)

declare sub DrawRBMask(img as FB.Image ptr, DrawSize as integer, Radius as integer)

declare sub CreateShadowGFX
declare sub DrawShadowMask (a as integer)

'******************************************************************************
'******************************************************************************
'******************************************************************************
'Color Stuff


function ColorSelection (BodyColor as ulong, BodySelectColor as ulong, selected as integer ,hover as integer,hovermode as integer=0) as ulong
  dim as ulong col
  if hover then   
    select case hovermode
      case 0
        col=iif(selected=1,Colors.HoverFXSelected,Colors.HoverFX)
      case 1
        col=Colors.HoverFX
    end select  
  else    
    col=iif(selected=1,BodySelectColor,BodyColor)   
  end if  
  function=col
end function


function EntryBGColorSelection (selected as integer, hover as integer) as ulong
  dim as ulong col
  if hover then
    col=Colors.LBX_BackGroundHoverFX
  else  
    col=iif(selected=1,Colors.LBX_BackGroundSelected,Colors.LBX_BackGround)  
  end if  
  function=col
end function


sub CalcLight(ciBase as ColorInfo, Intensity as integer,byref ciDest as ColorInfo)
  dim as single s,v
  s=ciBase.Saturation - ciBase.Saturation*(Intensity/101)
  v=ciBase.Value + (100-ciBase.Value)*(Intensity/101)
  SetHSV (ciDest, ciBase.Hue,s,v)
end sub


sub CalcDark(ciBase as ColorInfo, Intensity as integer,byref ciDest as ColorInfo)
  dim as single s,v
  if ciBase.Saturation>0 then s=ciBase.Saturation + (100-ciBase.Saturation)*(Intensity/101) else s=0'verhindert Rotstich
  v=ciBase.Value - ciBase.Value*Intensity/101
  SetHSV (ciDest, ciBase.Hue,s,v)
end sub


sub CalcShiny(ciBase as ColorInfo, Intensity as integer,byref ciDest as ColorInfo)
  dim as single s,v  
  if ciBase.Saturation>0 then s=ciBase.Saturation + (100-ciBase.Saturation)*(Intensity/101) else s=0'verhindert Rotstich 
  v=ciBase.Value + (100-ciBase.Value)*(Intensity/101)
  SetHSV (ciDest, ciBase.Hue,s,v)
end sub


'******************************************************************************
'******************************************************************************
'******************************************************************************
'Fill Basics


sub ClearBox (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,col as ulong=Colors.Cleaning)
  line img, (PosX,PosY)-(PosX+BoxWidth-1,PosY+BoxHeight-1),col,BF
end sub


sub Raster (img as FB.Image ptr, PosX as integer, PosY as integer, BoxWidth as integer, BoxHeight as integer, col as ulong=Colors.GadSleepPattern, mode as integer=1)
  select case mode
    case 1
      for k as integer=0 to BoxHeight-1 step 2
        for i as integer=0 to BoxWidth-1 step 4
          pset img,(PosX+i, PosY+k),col
          pset img,(PosX+i+1, PosY+k),col
          
          if ((k+1) <= (BoxHeight-1)) then
            if ((i+3) <= (BoxWidth-1)) then
              pset img,(PosX+i+2, PosY+k+1),col
              pset img,(PosX+i+3, PosY+k+1),col      
            end if
          end if
        next i
      next k

    case 2
      for k as integer=0 to BoxHeight-1 step 2
        for i as integer=0 to BoxWidth-1 step 2
          pset img,(PosX+i, PosY+k),col    
          if ( (i+1) <= (BoxWidth-1) ) and ( (k+1) <= (BoxHeight-1) ) then pset img,(PosX+i+1, PosY+k+1),col   
        next i
      next k

    case 3
      for k as integer=0 to BoxHeight-1 step 2
        line img,(PosX,PosY+k)-(PosX+Boxwidth-1,PosY+k),col    
      next k  
      
  end select
end sub


sub GradientFXFill(img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer, _
                    ColorTopLeft as ulong,ColorTopRight as ulong,ColorBottomLeft as ulong,ColorBottomRight as ulong)
  'Image/Screen Infos Pointer
  #if __FB_VERSION__ >= "1.08.0"
    #if defined (__fb_64bit__) 
      dim as ulong bpp,ptch,gcWidth,gcHeight                
    #else
      dim as integer bpp,ptch,gcWidth,gcHeight      
    #endif    
  #else
    dim as integer bpp,ptch
  #endif  
  dim as any ptr pdata
  dim as ulong ptr pxladdr    
  'Mathe und Farben
  dim as ulong cs,ce
  dim as integer bw,bh,gcPosX,gcPosY
  
  if img then
    imageinfo (img, gcWidth ,gcHeight , bpp, ptch, pdata)  
  else
    screeninfo ( gcWidth, gcHeight, , bpp, ptch) 
    pdata=screenptr
  end if
  'Berechnungen aus Schleife herausholen
  bw=BoxWidth-1
  bh=BoxHeight-1
  
  for y as integer=0 to bh
    cs=MixColor (ColorTopLeft, ColorBottomLeft, y/bh)
    ce=MixColor (ColorTopRight, ColorBottomRight, y/bh)   
    for x as integer=0 to bw
      'direkt in Screen/Image schreiben = bei mir etwa 45% schneller als die PSET Variante
      'erfordert eventuell screenlock/unlock
      gcPosX=PosX+x
      gcPosY=PosY+Y      
      if (gcPosX>=0) and (gcPosX<gcWidth) and (gcPosY>=0) and (gcPosY<gcHeight) then      
      pxladdr =pdata + gcPosY * ptch + gcPosX * bpp
      *pxladdr=MixColor (cs, ce, x/bw) 
      'ber PSET = langsamer
      'pset (PosX+x,PosY+y), MixColor (cs, ce, x/bw)
      end if
    next x
  next y
end sub


'******************************************************************************
'******************************************************************************
'******************************************************************************
'Fills


sub StdFill (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
  dim as ColorInfo fill,dark,shade,colorfx,lightfx
  dim as integer d1
  SetRGB(fill,  ColorSelection(b, s, selected,hover) )

  if GradientFX>0 then
    CalcDark(fill,GradientFX*.66,dark)
    CalcShiny(fill,GradientFX*.66,colorfx)    
    CalcDark(fill,GradientFX*.5,shade)
    CalcLight(fill,GradientFX*.25,lightfx)   
    if BoxWidth>=BoxHeight then       
      d1=BoxHeight*.33
      GradientFXFill img,PosX,PosY,BoxWidth,d1,lightfx.RGBValue,shade.RGBValue,shade.RGBValue,dark.RGBValue
      GradientFXFill img,PosX,PosY+d1,BoxWidth,BoxHeight-d1,shade.RGBValue,dark.RGBValue,dark.RGBValue,colorfx.RGBValue
    else     
      d1=BoxWidth*.5
      GradientFXFill img,PosX,PosY,d1,BoxHeight,lightfx.RGBValue,shade.RGBValue,shade.RGBValue,dark.RGBValue
      GradientFXFill img,PosX+d1,PosY,BoxWidth-d1,BoxHeight,shade.RGBValue,dark.RGBValue,dark.RGBValue,colorfx.RGBValue       
    end if
  else      
    ClearBox img,PosX,PosY,BoxWidth,BoxHeight,fill.RGBValue 
  end if
end sub


sub StdFillRounded (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0,cornercases as ubyte=15)   
  StdFill img,PosX,PosY,BoxWidth,BoxHeight,b,s,selected,hover    
  CornerTransMask img, PosX, PosY, BoxWidth, BoxHeight, cornercases
end sub


sub AltFillA (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
  dim as ColorInfo fill,dark,shade,colorfx,lightfx
  SetRGB(fill,  ColorSelection(b, s, selected,hover) )
  if GradientFX>0 then
    CalcDark(fill,GradientFX*.33,dark)
    CalcDark(fill,GradientFX*.25,shade)       
    CalcLight(fill,GradientFX*.33,lightfx)    
    if BoxWidth>=BoxHeight then   
      GradientFXFill img,PosX,PosY,BoxWidth,BoxHeight,dark.RGBValue,dark.RGBValue,shade.RGBValue,lightfx.RGBValue   
    else    
      GradientFXFill img,PosX,PosY,BoxWidth,BoxHeight,dark.RGBValue,shade.RGBValue,dark.RGBValue,lightfx.RGBValue     
    end if 
  else      
    ClearBox img,PosX,PosY,BoxWidth,BoxHeight,fill.RGBValue 
  end if
end sub


sub AltFillARounded (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)   
  AltFillA img,PosX,PosY,BoxWidth,BoxHeight,b,s,selected,hover
  CornerTransMask img, PosX, PosY, BoxWidth, BoxHeight
end sub
'******************************************************************************
'******************************************************************************
'******************************************************************************
'Frames


sub GetFrameColor( b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0, byref ci as ColorInfo)
  dim as ColorInfo c
  SetRGB(c, ColorSelection(b, s, selected,hover)) 
  
  if FrameContrastFX<0 then
    CalcDark(c,FrameContrastFX*-1,ci)'->Abdunkeln, letztlich Schwarz
  else
    CalcLight(c,FrameContrastFX,ci)'->Aufhellung, letztlich Weiss      
  end if
end sub


sub StdFrame (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0, switch as integer=-1)
  dim as ColorInfo frame,pale,dark
  GetFrameColor(b,s,selected,hover,frame)
  if switch>-1 then selected=switch
  
  CalcLight(frame, BevelFX, pale)
  CalcDark(frame, BevelFX, dark)
  
  if selected then     
    line img, (PosX,PosY+BoxHeight-1)-(PosX,PosY),dark.RGBValue'links
    line img, -(PosX+BoxWidth-1,PosY),dark.RGBValue'oben
    line img, -(PosX+BoxWidth-1,PosY+BoxHeight-1),pale.RGBValue'rechts     
    line img, -(PosX+1,PosY+BoxHeight-1),pale.RGBValue'unten
  else
    line img, (PosX,PosY+BoxHeight-1)-(PosX,PosY),pale.RGBValue'links
    line img, -(PosX+BoxWidth-1,PosY),pale.RGBValue'oben
    line img, -(PosX+BoxWidth-1,PosY+BoxHeight-1),dark.RGBValue'rechts     
    line img, -(PosX+1,PosY+BoxHeight-1),dark.RGBValue'unten  
  end if  
end sub


sub StdFrameRounded (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0, switch as integer=-1, cornercases as ubyte=15)
  dim as ColorInfo frame,light,dark,lightcolor,darkcolor
  StdFrame img,PosX,PosY,BoxWidth,BoxHeight,b,s,selected,hover  
  GetFrameColor(b,s,selected,hover,frame)
  if switch>-1 then selected=switch 
  CalcLight(frame, BevelFX, light)
  CalcDark(frame, BevelFX, dark)
  CalcLight(frame, BevelFX*.5, lightcolor)
  CalcDark(frame, BevelFX*.5, darkcolor)  
  CornerShape img, PosX, PosY, BoxWidth, BoxHeight, selected, light.RGBValue ,dark.RGBValue, lightcolor.RGBValue, darkcolor.RGBValue, cornercases 
end sub


sub GrdFrame (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer)
   line img, (PosX,PosY+BoxHeight-1)	-(PosX+BoxWidth-1,PosY+BoxHeight-1),Colors.DGR_Frame
   line img, (PosX+BoxWidth-1,PosY)	-(PosX+BoxWidth-1,PosY+BoxHeight-1),Colors.DGR_Frame      
end sub


sub WinFrame (img as FB.Image ptr,PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,selected as integer=0)
  dim as ColorInfo fill,dark,shade,colorfx,lightfx
  dim as ulong col
  SetRGB(fill, iif(selected=1,Colors.WinFrame,Colors.WinFrameUnselected)) 
  CalcDark(fill,GradientFX,dark)
  CalcDark(fill,GradientFX*.86,shade)
  CalcLight(fill,GradientFX*.86,lightfx)   
  CalcShiny(fill,GradientFX,colorfx)
  
  GradientFXFill img,0,0,BoxWidth,sGUIMainGap,lightfx.RGBValue,dark.RGBValue,lightfx.RGBValue,dark.RGBValue'oben horizontal
  GradientFXFill img,0,0,sGUIMainGap,BoxHeight,lightfx.RGBValue,lightfx.RGBValue,shade.RGBValue,shade.RGBValue'links vertikal
  GradientFXFill img,BoxWidth-sGUIMainGap,0,sGUIMainGap,BoxHeight,dark.RGBValue,dark.RGBValue,colorfx.RGBValue,colorfx.RGBValue'rechts vertikal    
  GradientFXFill img,0,BoxHeight-sGUIMainGap,BoxWidth,sGUIMainGap,shade.RGBValue,colorfx.RGBValue,shade.RGBValue,colorfx.RGBValue'unten horizontal
  
  if FrameFX then  
    StdFrame img,sGUIMainGap-1,sGUIMainGap-1,BoxWidth-2*sGUIMainGap+2,BoxHeight-2*sGUIMainGap+2,fill.RGBValue,fill.RGBValue,,,1'Innenrahmen  
    StdFrame img,0,0,BoxWidth,BoxHeight,fill.RGBValue,fill.RGBValue,,,0'Aussenrahmen
  end if
end sub


sub RoundFrame (img as FB.Image ptr, PosX as integer,PosY as integer,Radius as integer,light as ulong, dark as ulong)
  dim as integer x,y,res
  res=6
   
  for i as integer=0 to res   
    x=fix(cos(rad045 + rad180 * i/res) * Radius)
    y=fix(sin(rad045 + rad180 * i/res) * Radius)
    if i=0 then
      pset img,(PosX+x, PosY-y), dark
    else
      line img, - (PosX+x, PosY-y), dark
    end if
  next i
  
  for i as integer=0 to res
    x=fix(cos(rad225 + rad180 * i/res) * Radius)
    y=fix(sin(rad225 + rad180 * i/res) * Radius)
    if i=0 then
      pset img,(PosX+x, PosY-y), light
    else
      line img, - (PosX+x, PosY-y), light
    end if
  next    
end sub


sub CornerShape (img as FB.Image ptr, PosX as integer, PosY as integer, BoxWidth as integer, BoxHeight as integer, selected as integer, top as ulong, bottom as ulong, topmerge as ulong=0, bottommerge as ulong=0, cornercases as ubyte=15)  
  dim as integer X,Y
  if selected then 
    swap top,bottom
    swap topmerge, bottommerge
  end if
  
  'topleft
  X=PosX
  Y=PosY
  if (cornercases and 1) then
    line img, (X+2,Y+1)-(X+3,Y+1),top
    line img, (X+1,Y+2)-(X+1,Y+3),top
  end if
  
  'topright
  X=PosX+BoxWidth-1
  
  if (cornercases and 2) then
    line img, (X-2,Y+1)-(X-3,Y+1),topmerge
    line img, (X-1,Y+2)-(X-1,Y+3),bottommerge   
  end if
  
  'bottomright
  Y=PosY+BoxHeight-1
  
  if (cornercases and 4) then
    line img, (X-2,Y-1)-(X-3,Y-1),bottom
    line img, (X-1,Y-2)-(X-1,Y-3),bottom  
  end if
  
  'bottomleft
  X=PosX
  
  if (cornercases and 8) then
    line img, (X+2,Y-1)-(X+3,Y-1),bottommerge
    line img, (X+1,Y-2)-(X+1,Y-3),topmerge
  end if
  
end sub


sub CornerTransMask (img as FB.Image ptr, PosX as integer,PosY as integer, BoxWidth as integer, BoxHeight as integer, cornercases as ubyte=15)
  dim as integer X,Y

  'topleft
  X=PosX
  Y=PosY

  if (cornercases and 1) then   
    line img, (X,Y)-(X+3,Y),&H00FF00FF
    line img, (X,Y)-(X,Y+3),&H00FF00FF
    pset img, (X+1,Y+1),&H00FF00FF
  end if

  'topright
  X=PosX+BoxWidth-1

  if (cornercases and 2) then 
    line img, (X,Y)-(X-3,Y),&H00FF00FF
    line img, (X,Y)-(X,Y+3),&H00FF00FF
    pset img, (X-1,Y+1),&H00FF00FF  
  end if

  'bottomright
  Y=PosY+BoxHeight-1

  if (cornercases and 4) then     
    line img, (X,Y)-(X-3,Y),&H00FF00FF
    line img, (X,Y)-(X,Y-3),&H00FF00FF
    pset img, (X-1,Y-1),&H00FF00FF  
  end if
  
  'bottomleft
  X=PosX

  if (cornercases and 8) then 
    line img, (X,Y)-(X+3,Y),&H00FF00FF
    line img, (X,Y)-(X,Y-3),&H00FF00FF
    pset img, (X+1,Y-1),&H00FF00FF
  end if 
end sub


'******************************************************************************
'******************************************************************************
'******************************************************************************
'Boxes


sub StdFilledBox (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0) 
  if FrameFX then 
    StdFill img,PosX+1,PosY+1,BoxWidth-2,BoxHeight-2,b,s,selected,hover
    StdFrame img,PosX,PosY,BoxWidth,BoxHeight,b,s,selected,hover    
  else
    StdFill img,PosX,PosY,BoxWidth,BoxHeight,b,s,selected,hover  
  end if
end sub


sub StdFilledBoxRounded (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0, cornercases as ubyte=15) 
  if FrameFX then 
    StdFill img,PosX+1,PosY+1,BoxWidth-2,BoxHeight-2,b,s,selected,hover
    StdFrameRounded img,PosX,PosY,BoxWidth,BoxHeight,b,s,selected,hover,,cornercases'    
  else
    StdFillRounded img,PosX,PosY,BoxWidth,BoxHeight,b,s,selected,hover,cornercases  
  end if
  CornerTransMask img, PosX, PosY, BoxWidth, BoxHeight,cornercases 
end sub


'Knob Scrollbar
'bleibt immer "erhaben", lediglich "Farbspiel" bei Hover/Selection
sub FilledBoxKnob (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
  if FrameFX then
    StdFill img,PosX+1,PosY+1,BoxWidth-2,BoxHeight-2,b,s,selected,hover
    StdFrameRounded img,PosX,PosY,BoxWidth,BoxHeight,b,s,selected,hover
  else
    StdFillRounded img,PosX,PosY,BoxWidth,BoxHeight,b,s,selected,hover
  end if
  CornerTransMask img, PosX, PosY, BoxWidth, BoxHeight  
end sub


'Container Scrollbar
sub FilledBoxContainer (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
  if FrameFX then   
    AltFillA img,PosX+1,PosY+1,BoxWidth-2,BoxHeight-2,b,s,selected,hover
    StdFrameRounded img,PosX,PosY,BoxWidth,BoxHeight,b,s,selected,hover
  else
    AltFillARounded img,PosX,PosY,BoxWidth,BoxHeight,b,s,selected,hover
  end if
  CornerTransMask img, PosX, PosY, BoxWidth, BoxHeight 
end sub


sub FilledBoxDrop (img as FB.Image ptr, b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0,mode as integer=0)
  dim as ulong symbolcolor
  dim as integer BoxWidth,BoxHeight,asize,x,y
  BoxWidth=sGUIMainSize
  BoxHeight=GetFontHeight 
  asize=int(sGUIMainSize*.7)
  x=(BoxWidth-asize)/2
  y=(BoxHeight-int(asize/2) ) /2  
  
  'StdFill img,0,0,BoxWidth,BoxHeight,b,s,selected,hover  
  StdFillRounded img,0,0,BoxWidth,BoxHeight,b,s,selected,hover
  if hover then
    symbolcolor=iif(selected,Colors.HoverFXText,Colors.HoverFXText)
  else
    symbolcolor=Colors.GadText
  end if
  Symbol_Arrow (img,x,y,asize,3,symbolcolor)  
end sub


sub FilledBoxList (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
	dim as ColorInfo fill	
  SetRGB(fill, ColorSelection(b, s, selected,hover) )
  'StdFrame img,PosX,PosY,BoxWidth,BoxHeight,b,s,selected,hover
	'line img, (PosX+1,PosY+1)-(PosX+BoxWidth-2,PosY+BoxHeight-2),fill.RGBValue,BF
  if FrameFX then
    StdFrame img,PosX,PosY,BoxWidth,BoxHeight,b,s,selected,hover
    line img, (PosX+1,PosY+1)-(PosX+BoxWidth-2,PosY+BoxHeight-2),fill.RGBValue,BF  
  else
    line img, (PosX,PosY)-(PosX+BoxWidth,PosY+BoxHeight),fill.RGBValue,BF  
  end if  
end sub


sub FilledBoxEntry (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,selected as integer=0,hover as integer=0)
	dim as ColorInfo fill	
  SetRGB(fill, EntryBGColorSelection (selected,hover))
  line img, (PosX,PosY)-(PosX+BoxWidth-1,PosY+BoxHeight-1),fill.RGBValue,BF
end sub


sub FilledBoxRadio (img as FB.Image ptr, PosX as integer,PosY as integer,BoxSize as integer,Radius as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
  dim as ColorInfo frame,light,dark
  dim as ulong dotcolor

  StdFill img,PosX,PosY,BoxSize,BoxSize,b,s,selected,hover  
  put img,(PosX,PosY),cast(FB.Image ptr,RadioButtonMask->img),trans
  
  GetFrameColor(b,s,selected,hover,frame)
  
  if FrameFX then  
    if BevelFX then 	      
      CalcLight(frame, BevelFX, light)
      CalcDark(frame, BevelFX, dark)  
    else 
      SetRGB(light, frame.RGBValue) 
      SetRGB(dark, frame.RGBValue)    
    end if      
    RoundFrame (img, PosX+Radius, PosY+Radius, Radius, light.RGBValue, dark.RGBValue)
  end if
  
  if selected then 
    if hover then
      dotcolor=iif(selected,Colors.HoverFXText,Colors.HoverFXText)
    else
      dotcolor=Colors.GadText
    end if 
    DrawMenuRBDot img, PosX+Radius, PosY+Radius, Radius/2, dotcolor
  end if
end sub


sub FilledBoxCheckMark (img as FB.Image ptr, PosX as integer,PosY as integer,BoxSize as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
  dim as ulong cmcolor
  dim as integer ssize,a,o
  ssize=BoxSize*.6
  a=(sGUIMainSize-ssize)/2

  if FrameFX then
    'AltFillB img,PosX+1,PosY+1,BoxSize-2,BoxSize-2,b,s,selected,hover
    StdFill img,PosX+1,PosY+1,BoxSize-2,BoxSize-2,b,s,selected,hover
    StdFrame img,PosX,PosY,BoxSize,BoxSize,b,s,selected,hover,1	
  else
    'AltFillB img,PosX,PosY,BoxSize,BoxSize,b,s,selected,hover
    StdFill img,PosX,PosY,BoxSize,BoxSize,b,s,selected,hover
  end if

  if selected then 
    if hover then
      cmcolor=iif(selected,Colors.HoverFXText,Colors.HoverFXText)
    else
      cmcolor=Colors.GadText
    end if 
    Symbol_CheckMark (img, PosX+a,PosY+a,ssize,cmcolor)
  end if 	
end sub


'******************************************************************************
'******************************************************************************
'******************************************************************************
'Symbols

sub DrawMenuRBDot (img as FB.Image ptr, PosX as integer,PosY as integer, Radius as integer, col as ulong)
  RoundFrame (img, PosX, PosY, Radius, col, col) 
  paint img,(PosX,PosY),col,col 
end sub


sub Symbol_Arrow (img as FB.Image ptr, PosX as integer,PosY as integer,size as integer,direction as integer,col as ulong,thickness as integer=2)
  dim as integer n,w 
  if size<8 then thickness=1
  
  w=size-1  
  if (size mod 2) then
    n=int(size/2)
  else
    n=size/2-1
  end if
  select case direction
    case 0'l
'line img, (PosX,PosY)-(PosX+n,PosY+w),&HFFFFFF,B
      for i as integer=0 to thickness
        line img, (PosX+n,PosY+i)-(PosX+i,PosY+n),col
        line img, (PosX+i,PosY+w-n)-(PosX+n,PosY+w-i),col
      next i
        
    case 1'r
'line img, (PosX,PosY)-(PosX+n,PosY+w),&HFFFFFF,B
      for i as integer=0 to thickness
        line img, (PosX,PosY+i)-(PosX+n-i,PosY+n),col
        line img, (PosX+n-i,PosY+w-n)-(PosX,PosY+w-i),col
      next i

    case 2'up
'line img, (PosX,PosY)-(PosX+w,PosY+n),&HFFFFFF,B
      for i as integer=0 to thickness
        line img, (PosX+i,PosY+n)-(PosX+n,PosY+i),col
        line img, (PosX+w-n,PosY+i)-(PosX+w-i,PosY+n),col
      next i
      
    case 3'dwn
'line img, (PosX,PosY)-(PosX+w,PosY+n),&HFFFFFF,B
      for i as integer=0 to thickness
        line img, (PosX+i,PosY)-(PosX+n,PosY+n-i),col
        line img, (PosX+w-n,PosY+n-i)-(PosX+w-i,PosY),col
      next i
  end select 
end sub


sub Symbol_CheckMark (img as FB.Image ptr, PosX as integer,PosY as integer,size as integer,col as ulong=Colors.Black)
  dim as integer n,w,thickness
  if size<16 then thickness=1 else thickness=2 
  w=size-1  
  if (size mod 2) then
    n=int(size/2)
  else
    n=size/2-1
  end if

  for i as integer=0 to thickness
    line img, (PosX+i,PosY+w-n)-(PosX+n,PosY+w-i),col
    line img, (PosX+n,PosY+w-i)-(PosX+w-i,PosY),col
  next i

end sub


sub Symbol_X (img as FB.Image ptr, PosX as integer,PosY as integer, col as ulong=Colors.Black)
  line img, (PosX+1,PosY+1)-(PosX+6,PosY+6),col
  line img, (PosX+1,PosY+0)-(PosX+7,PosY+6),col
	line img, (PosX+0,PosY+1)-(PosX+6,PosY+7),col
  
  line img, (PosX+1,PosY+6)-(PosX+6,PosY+1),col
  line img, (PosX+0,PosY+6)-(PosX+6,PosY+0),col
	line img, (PosX+1,PosY+7)-(PosX+7,PosY+1),col  
end sub


sub DrawRBMask(img as FB.Image ptr, DrawSize as integer, Radius as integer)
  line img, (0,0)-(DrawSize-1,DrawSize-1),Colors.Background,BF  
  DrawMenuRBDot (img,Radius,Radius,Radius,&HFF00FF)   
end sub


'******************************************************************************
'******************************************************************************
'******************************************************************************
'FensterSchattenFX

sub CreateShadowGFX
  dim as integer numrays
  dim as ulong alphavalue,maxalpha
  dim as single x,y
  maxalpha=96
  numrays=(2*sGUIMainSize*rad180)/4'"Umfang in px"/4

  ShadowLeft=ImageList->AppendNew(sGUIImageType)
  ShadowRight=ImageList->AppendNew(sGUIImageType)
  ShadowTop=ImageList->AppendNew(sGUIImageType)
  ShadowBottom=ImageList->AppendNew(sGUIImageType)
  ShadowCTL=ImageList->AppendNew(sGUIImageType)
  ShadowCTR=ImageList->AppendNew(sGUIImageType)
  ShadowCBL=ImageList->AppendNew(sGUIImageType)
  ShadowCBR=ImageList->AppendNew(sGUIImageType)
  
  if ShadowLeft then ShadowLeft->img=imagecreate(sGUIMainSize,1)      
  if ShadowRight then ShadowRight->img=imagecreate(sGUIMainSize,1)
  if ShadowTop then ShadowTop->img=imagecreate(1,sGUIMainSize)      
  if ShadowBottom then ShadowBottom->img=imagecreate(1,sGUIMainSize)
  if ShadowCTL then ShadowCTL->img=imagecreate(sGUIMainSize,sGUIMainSize)      
  if ShadowCTR then ShadowCTR->img=imagecreate(sGUIMainSize,sGUIMainSize)
  if ShadowCBL then ShadowCBL->img=imagecreate(sGUIMainSize,sGUIMainSize)      
  if ShadowCBR then ShadowCBR->img=imagecreate(sGUIMainSize,sGUIMainSize)      
  
  'wichtig! zuerst EckImages mit Alphawert=0 also transparent "befllen", RGB Bestandteile sind da eigentl. egal
  line ShadowCTL->Img,(0,0)-(sGUIMainSize-1,sGUIMainSize-1),&H00FF00FF,BF
  line ShadowCTR->Img,(0,0)-(sGUIMainSize-1,sGUIMainSize-1),&H00FF00FF,BF
  line ShadowCBL->Img,(0,0)-(sGUIMainSize-1,sGUIMainSize-1),&H00FF00FF,BF
  line ShadowCBR->Img,(0,0)-(sGUIMainSize-1,sGUIMainSize-1),&H00FF00FF,BF  
  for i as integer=0 to sGUIMainSize-1
    alphavalue=int((1 - i/(sGUIMainSize-1))*maxalpha) shl 24    
    for k as integer=0 to numrays
      x=fix(cos(rad090 * k/numrays)*i)
      y=fix(sin(rad090 * k/numrays)*i)      
      
      pset ShadowCTL->img,(sGUIMainSize-1-x,sGUIMainSize-1-y), alphavalue or Colors.Black
      pset ShadowCTR->img,(x,sGUIMainSize-1-y), alphavalue or Colors.Black
      pset ShadowCBL->img,(sGUIMainSize-1-x,y), alphavalue or Colors.Black
      pset ShadowCBR->img,(x,y), alphavalue or Colors.Black     
    next k
  next i
  
  for i as integer=0 to sGUIMainSize-1
    alphavalue=int(i/(sGUIMainSize-1) * maxalpha) shl 24 
    pset ShadowLeft->img,(i,0), alphavalue or Colors.Black
    pset ShadowRight->img,(sGUIMainSize-1-i,0), alphavalue or Colors.Black
    pset ShadowTop->img,(0,i), alphavalue or Colors.Black
    pset ShadowBottom->img,(0,sGUIMainSize-1-i), alphavalue or Colors.Black    
  next i    
end sub


sub WinShadow (img as FB.Image ptr,PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer)
  dim as integer x0,x1,x2,x3,y0,y1,y2,y3,w,h
  x0=PosX-sGUIMainSize*.40
  x1=x0+sGUIMainSize
  x2=PosX+BoxWidth - sGUIMainSize + sGUIMainSize*.66
  
  y0=PosY-sGUIMainSize*.40
  y1=y0+sGUIMainSize
  y2=PosY+BoxHeight
  w=x2 - x1
  h=y2 - y1
  if img then
    
    for i as integer=0 to w-1 step 1
      put img,(x1 + i, y0),ShadowTop->img,alpha   
      put img,(x1 + i, y2),ShadowBottom->img,alpha   
    next i
    for i as integer=0 to h-1 step 1
      put img,(x0, y1 + i),ShadowLeft->img,alpha   
      put img,(x2, y1 + i),ShadowRight->img,alpha   
    next i  

    put img,(x0, y0),ShadowCTL->img,alpha
    put img,(x2, y0),ShadowCTR->img,alpha
    put img,(x0, y2),ShadowCBL->img,alpha
    put img,(x2, y2),ShadowCBR->img,alpha 
  
  else
  
    for i as integer=0 to w-1 step 1
      put (x1 + i, y0),ShadowTop->img,alpha   
      put (x1 + i, y2),ShadowBottom->img,alpha   
    next i
    for i as integer=0 to h-1 step 1
      put (x0, y1 + i),ShadowLeft->img,alpha   
      put (x2, y1 + i),ShadowRight->img,alpha   
    next i  

    put (x0, y0),ShadowCTL->img,alpha
    put (x2, y0),ShadowCTR->img,alpha
    put (x0, y2),ShadowCBL->img,alpha
    put (x2, y2),ShadowCBR->img,alpha
    
  end if
end sub


'******************************************************************************
'******************************************************************************
'******************************************************************************
