namespace sGUI

declare sub DeleteEntries overload(gad as Gadget ptr)
declare sub DeleteEntries(list as sGUIList ptr)

declare function AddEntry overload(gad as Gadget ptr,Text as string="", EType as integer=ETYPE_UNDEFINED, Qualifier as integer=0) as sGUIEntry ptr
declare function AddEntry (list as sGUIList ptr,Text as string="", EType as integer=ETYPE_UNDEFINED, Qualifier as integer=0) as sGUIEntry ptr

declare function GetEntryAddr overload(gad as Gadget ptr,Index as integer) as sGUIEntry ptr
declare function GetEntryAddr(list as sGUIList ptr,Index as integer) as sGUIEntry ptr

declare function GetEntryText overload(gad as Gadget ptr,Index as integer) as string
declare function GetEntryText(list as sGUIList ptr,Index as integer) as string

declare function GetEntryType overload(gad as Gadget ptr,Index as integer) as integer
declare function GetEntryType(list as sGUIList ptr,Index as integer) as integer

declare function GetEntryQualifier overload(gad as Gadget ptr,Index as integer) as integer
declare function GetEntryQualifier(list as sGUIList ptr,Index as integer) as integer

declare sub DirTosGUIList(list as sGUIList ptr,directory as string=exepath,mode as integer=3 )
declare sub DirToListBox(gad as Gadget ptr,directory as string=exepath,mode as integer=3 )

declare sub SetEntryActivation overload(gad as Gadget ptr, Index as integer, Activation as integer=1)
declare sub SetEntryActivation (list as sGUIList ptr, Index as integer, Activation as integer=1)
'******************************************************************************

declare function NewMenuBase as sGUIList ptr
declare function OpenMenuStrip (menulist as sGUIList ptr, txt as string,activation as integer=1) as integer
declare function CloseMenuStrip (menulist as sGUIList ptr) as integer
declare function Item (menulist as sGUIList ptr, txt as string, activation as integer=1) as integer
declare function CheckMark (menulist as sGUIList ptr, txt as string, activation as integer=1, selection as integer) as integer
'declare function RadioButton (menulist as sGUIList ptr, txt as string, activation as integer=1, selection as integer) as integer
declare function RadioButton (menulist as sGUIList ptr, txt as string, activation as integer=1, selection as integer,HeadID as integer) as integer
declare function Separator(menulist as sGUIList ptr) as integer

declare function MenuValidator(menulist as sGUIList ptr, mode as integer=0) as integer
declare sub MenuSetLevel(menulist as sGUIList ptr)
declare function MenuSetGroup(menulist as sGUIList ptr) as integer
declare sub GetMenuEntry(menulist as sGUIList ptr, Index as integer, byref Activation as integer=-1, byref Selection as integer=-1)
declare sub SetMenuEntry(menulist as sGUIList ptr, Index as integer, Activation as integer=-1, Selection as integer=-1)

declare sub ProofPrint (menulist as sGUIList ptr)


sub DeleteEntries(gad as Gadget ptr)
  if gad->xtd.EntryList then    
    gad->xtd.EntryList->DeleteAll    
  end if
end sub


sub DeleteEntries(list as sGUIList ptr)
  list->DeleteAll
end sub


function AddEntry(gad as Gadget ptr,Text as string="", EType as integer=ETYPE_UNDEFINED, Qualifier as integer=0) as sGUIEntry ptr
  function=0
  if gad->xtd.EntryList then    
    function=AddEntry(gad->xtd.EntryList, Text, EType, Qualifier)     
  end if
end function


function AddEntry(list as sGUIList ptr,Text as string="", EType as integer=ETYPE_UNDEFINED, Qualifier as integer=0) as sGUIEntry ptr
  function=0
  dim as sGUIEntry ptr entry=list->AppendNew(sGUIEntryType)
  if entry then
    entry->Text       =Text  
    entry->EntryType  =EType
    entry->Qualifier  =Qualifier
    entry->Activation  =1
		function=entry
  end if
end function


function GetEntryAddr(gad as Gadget ptr,Index as integer) as sGUIEntry ptr
  function=0
  if gad->xtd.EntryList then    
    function=GetEntryAddr(gad->xtd.EntryList,Index)
  end if
end function


function GetEntryAddr(list as sGUIList ptr,Index as integer) as sGUIEntry ptr
  dim as sGUIEntry ptr entry,detected
  detected=0
  entry=list->GetFirst
	if Index<>0 then
    if entry then
      do
        if (entry->Index = Index) then detected=entry
        entry=cast(sGUIEntry ptr,entry->next_node)
      loop until (entry=0) or (detected<>0)
    end if
  end if
  function=detected
end  function


function GetEntryText(gad as Gadget ptr,Index as integer) as string
  function=""
  if Index<>0 then
    if gad->xtd.EntryList then    
      function=GetEntryText(gad->xtd.EntryList,Index)
    end if
  end if
end function


function GetEntryText(list as sGUIList ptr,Index as integer) as string
  function=( GetEntryAddr(list,Index) )->Text
end function


function GetEntryType (gad as Gadget ptr,Index as integer) as integer
  function=ETYPE_UNDEFINED
  if gad->xtd.EntryList then    
    function=GetEntryType(gad->xtd.EntryList,Index)
  end if
end function


function GetEntryType(list as sGUIList ptr,Index as integer) as integer
  function=( GetEntryAddr(list,Index) )->EntryType
end function


function GetEntryQualifier (gad as Gadget ptr,Index as integer) as integer
  function=0
  if Index<>0 then
    if gad->xtd.EntryList then    
      function=GetEntryQualifier(gad->xtd.EntryList,Index)
    end if
  end if
end function


function GetEntryQualifier(list as sGUIList ptr,Index as integer) as integer
  function=( GetEntryAddr(list,Index) )->Qualifier
end function

'mode=1 nur Dateien
'mode=2 nur Verzeichnisse
'mode 3 Dateien & Verzeichnisse 
sub DirTosGUIList(list as sGUIList ptr,directory as string=exepath,mode as integer=3 )
  dim as string entryname
  DeleteEntries (list)
  chdir directory
  
  if (mode and 2)=2 then
    'entryname=dir("*",fbDirectory or fbHidden or fbReadOnly or fbSystem)
    entryname=dir("*",fbDirectory or fbHidden or fbReadOnly or fbSystem)
    do
      if (len(entryname)>0) and (entryname<>".") and (entryname<>"..") then
        AddEntry(list,entryname,ETYPE_DIR)
      end if
      entryname=dir
    loop while len(entryname)      
  end if
  
  if (mode and 1)=1 then
    entryname=dir("*",fbNormal)
    do
      if (len(entryname)>0) and (entryname<>".") and (entryname<>"..") then
        AddEntry(list,entryname,ETYPE_FILE)
      end if
      entryname=dir
    loop while len(entryname)     
  end if
end sub


sub DirToListBox(gad as Gadget ptr,directory as string=exepath,mode as integer=3 ) 
  if gad->xtd.EntryList then
    DirTosGUIList(gad->xtd.EntryList,directory,mode)
  end if
end sub


sub SetEntryActivation overload(gad as Gadget ptr, Index as integer, Activation as integer=1)
  dim as sGUIEntry ptr entry
  entry=GetEntryAddr(gad->xtd.EntryList, Index)
  entry->Activation=Activation
end sub


sub SetEntryActivation (list as sGUIList ptr, Index as integer, Activation as integer=1)
  dim as sGUIEntry ptr entry
  entry=GetEntryAddr(list, Index)
  entry->Activation=Activation
end sub

'******************************************************************************
'******************************************************************************
'******************************************************************************


function NewMenuBase as sGUIList ptr
  function=cast( sGUIList ptr, EntryLists->AppendNew(sGUIListType) )
end function


function OpenMenuStrip(menulist as sGUIList ptr, txt as string,activation as integer=1) as integer
  function=0
  dim as sGUIEntry ptr entry
  dim as integer level  
  entry=menulist->AppendNew(sGUIEntryType)
  
  if entry then
    entry->Text         =txt 
    entry->EntryType    =ETYPE_OPENMENUSTRIP
    entry->Activation   =activation    
    entry->EntryWidth   =0'wird spter definiert
    entry->EntryHeight  =GetFontHeight(2) + 2*sGUIMainGap
    entry->SymbolSize   =GetFontHeight(2)*.66
    function=entry->index
  end if
end function


function CloseMenuStrip(menulist as sGUIList ptr) as integer
  function=0
  dim as sGUIEntry ptr entry
  dim as integer level  
  entry=menulist->AppendNew(sGUIEntryType)
  
  if entry then
    entry->EntryType      =ETYPE_CLOSEMENUSTRIP
    entry->EntryWidth     =0
    entry->EntryHeight    =0
		function=entry->index
  end if
end function


function Item(menulist as sGUIList ptr, txt as string, activation as integer=1) as integer
  function=0
  dim as sGUIEntry ptr entry
  dim as integer level  
  entry=menulist->AppendNew(sGUIEntryType)
  
  if entry then
    entry->Text         =txt 
    entry->EntryType    =ETYPE_ITEM
    entry->Activation   =activation
    entry->EntryWidth   =0'wird spter definiert
    entry->EntryHeight  =GetFontHeight(2) + 2*sGUIMainGap   
    function=entry->index
  end if 
end function


function CheckMark(menulist as sGUIList ptr, txt as string, activation as integer=1, selection as integer) as integer
  function=0
  dim as sGUIEntry ptr entry
  dim as integer level  
  entry=menulist->AppendNew(sGUIEntryType)
  
  if entry then
    entry->Text           =txt 
    entry->EntryType      =ETYPE_CHECKMARK
    entry->Activation     =activation
    entry->Selection      =selection
    entry->EntryWidth     =0'wird spter definiert
    entry->EntryHeight    =GetFontHeight(2) + 2*sGUIMainGap
    entry->SymbolSize     =GetFontHeight(2)*.66    
    function=entry->index 
  end if  
end function


function RadioButton  (menulist as sGUIList ptr, txt as string, activation as integer=1, selection as integer, HeadID as integer) as integer
  function=0
  dim as sGUIEntry ptr entry
  dim as integer level  
  entry=menulist->AppendNew(sGUIEntryType)
  
  if entry then
    entry->Text           =txt 
    entry->EntryType      =ETYPE_RADIOBUTTON
    entry->Activation     =activation
    entry->Selection      =selection
    entry->EntryWidth     =0'wird spter definiert
    entry->EntryHeight    =GetFontHeight(2) + 2*sGUIMainGap
    entry->SymbolSize     =GetFontHeight(2)*.66    
    entry->QualifierB     =HeadID':(
    function=entry->index 
  end if  
end function


function Separator(menulist as sGUIList ptr) as integer
  function=0
  dim as sGUIEntry ptr entry,prev
  dim as integer level  
  entry=menulist->AppendNew(sGUIEntryType)
  
  if entry then
    entry->EntryType      =ETYPE_SEPARATOR
    entry->Activation     =0
    entry->EntryWidth     =0'wird spter definiert
    entry->EntryHeight    =2 + 2*sGUIMainGap    
    function=entry->index
  end if
end function


sub GetMenuEntry(menulist as sGUIList ptr, Index as integer, byref Activation as integer=-1, byref Selection as integer=-1)
  dim as sGUIEntry ptr entry
  entry=GetEntryAddr(menulist,Index)
  Activation=entry->Activation
  Selection=entry->Selection
end sub


sub SetMenuEntry(menulist as sGUIList ptr, Index as integer, Activation as integer=-1, Selection as integer=-1)
  dim as sGUIEntry ptr entry
  entry=GetEntryAddr(menulist,Index)
  if Activation<>-1 then entry->Activation=Activation
  if Selection<>-1 then entry->Selection=Selection
  entry->TimeStamp=timer
end sub


function MenuValidator(menulist as sGUIList ptr, mode as integer=0) as integer
  dim as integer stack,fail,lasttype
  dim as sGUIEntry ptr entry
  stack=0    
  fail=0
  lasttype=-1
  entry=menulist->GetFirst
    
    if entry then
      do
        
        'nur auf unterster Ebene(stack=0) knnte berhaupt der Fall eintreten:
        'mode 0: (WindowMen) Items/CheckMarks/Separatoren mssen immer von einem Open-Close-Konstrukt umschlossen sein           
        'mode 1: (PopUpMen) auch ausserhalb von Open-Close-Konstrukten sind Items/CheckMarks/Separatoren zulssig        
        'da das dazugehrige Close ist immer einen StackLevel hher
        if stack=0 then
          if (mode=0) and (entry->EntryType <> ETYPE_OPENMENUSTRIP) then fail=1
        end if        
        
        'auf Stack legen
        if entry->EntryType=ETYPE_OPENMENUSTRIP then stack +=1
        
        'vom Stack runternehmen
        'dabei darf der stack zur Laufzeit des Checks nicht unter 0 fallen
        '- mehr Close als Open -> Fehler!!
        '- Close vor Open ->Fehler!!
        if entry->EntryType=ETYPE_CLOSEMENUSTRIP then stack -=1        
        if stack<0 then fail=1        
        
        'auf ein Open darf nicht direkt ein Close folgen -> dies wre ein leerer Menstrip -> unzulssig  
        if (entry->EntryType=ETYPE_CLOSEMENUSTRIP) and (lasttype=ETYPE_OPENMENUSTRIP) then fail=1
        lasttype=entry->EntryType
        
        entry=cast(sGUIEntry ptr,entry->next_node)'nchsten Eintrag holen       
      loop until (entry=0) or (fail=1)
      
      'stack mu zum Schlu 0 sein, d.h. gleiche Anzahl Open und Close
      'Werte < 0 fhren schon im Loop oben zu einem fail
      if stack>0 then fail=1  
   
    else
      'falls Liste leer dann Fehler
      fail=1
    end if
    
  if fail=0 then function=1 else function=0
end function


sub MenuSetLevel(menulist as sGUIList ptr)
  dim as sGUIEntry ptr entry=menulist->GetFirst
  dim as integer lvl=0
  
  if entry then
    do
      'die Reihenfolge von Erhhen/Verringern/Zuordnen bestimmt,
      'ob ein CloseMenuStrip auf OpenMenuStrip-Level erscheint oder im Strip-Level als
      'eine Art "EndMarker".
      
      'dies hier ist Variante CloseMenuStrip als Strip-End-Marker, einen Level hher als der dazugehrige OpenMenuStrip:     
      entry->Level=lvl                                      'Level Zuordnen
      if entry->EntryType=ETYPE_CLOSEMENUSTRIP then lvl -=1 'Level Verringern   
      if entry->EntryType=ETYPE_OPENMENUSTRIP then lvl +=1  'Level Erhhen   
      
      entry=cast(sGUIEntry ptr,entry->next_node)'nchsten Eintrag holen       
    loop until entry=0
  end if
end sub


function MenuSetGroup(menulist as sGUIList ptr) as integer
  dim as sGUIEntry ptr entry,e
  dim as integer lvl,group,foundhigher
  entry=menulist->GetFirst  
  lvl=0
  group=0
  if entry then
    do
      foundhigher=0
      e=entry
      do
        if e->Level>lvl then foundhigher=1
        
        if e->Level=lvl then
          e->MemberOfGroup=Group
          if e->EntryType=ETYPE_CLOSEMENUSTRIP then group +=1'aktuelle Gruppe schliessen und eine neue Gruppe "ffnen"
        end if
               
        e=cast(sGUIEntry ptr,e->next_node)'nchsten Eintrag holen       
      loop until e=0
      
      'da oben (in MenuSetLevel()) der CloseMenuStrip als Strip-End-Marker definiert ist, also immer einen Level hher,
      'gibt es auf Level 0 bis zum Listenende kein CloseMenuStrip, der die aktuelle Gruppe schliessen und eine neu Gruppe "ffnen" wrde,
      'darum muss das fr Level 0 von Hand geschehen:
      if lvl=0 then group +=1
            
      if foundhigher=1 then lvl +=1  
    loop until foundhigher=0
  end if
  function=group
end function


sub ProofPrint (menulist as sGUIList ptr)
  dim as sGUIEntry ptr entry
  dim as string et,sp

  print tab(15);"L / G"
  entry=menulist->GetFirst
  if entry then
    do
      sp=space(entry->Level*2)
      et=""
      select case entry->EntryType
        case ETYPE_OPENMENUSTRIP
          et="OPEN"
        case ETYPE_CLOSEMENUSTRIP
          et="CLOS"
        case ETYPE_ITEM
          et="ITEM"
        case ETYPE_CHECKMARK
          et="CMRK"
        case ETYPE_SEPARATOR
          et="SEPR"
      end select
      if et<>"" then

        print tab(1 + entry->Level*2); et; tab(15); entry->Level & " / " & entry->MemberOfGroup, entry->EntryWidth & "/" & entry->EntryHeight ,_
                entry->StripWindow,entry->ChildStripWindow  
      end if
      entry=cast(sGUIEntry ptr,entry->next_node)'nchsten Eintrag holen       
    loop until entry=0
  end if    
end sub

end namespace
