declare function GetSysFontHeight as integer
declare function GetTextWidth(txt as string, mode as integer=0) as integer
declare function GetFontHeight(mode as integer=0) as integer
declare sub DrawString(img as FB.Image ptr=0,xpos as integer,ypos as integer,txt as string,PenColor as ulong=&H000000,mode as integer=0)
declare sub LoadProportionalFont(filename as string)
declare sub LoadFixedFont(filename as string)
declare sub SetFixedWidth(w as integer)
declare function GetFixedWidth as integer
declare sub SetsGUIMainSize

'nach einer Idee von Volta
'ermittelt die benutzte Fonthhe und gibt sie zurck
'siehe http://forum.qbasic.at/viewtopic.php?t=6065&highlight=fonth%F6he
function GetSysFontHeight as integer
  #if __FB_VERSION__ >= "1.08.0"
    dim as ulong h,fheight
  #else
    dim as integer h,fheight
  #endif  
  
  screeninfo ,h
  select case  h\hiword(width)
    case is < 8
      fheight=0
    case 8 to 13
      fheight=8
    case 14, 15
      fheight=14
    case is > 15
      fheight=16
  end select
  function=cast(integer,fheight)
end function


function GetFontHeight(mode as integer=0) as integer
   dim as integer fallback
   fallback=1
   
   select case mode  
    case 0
      if Font_Prop->img then
        function=Font_Prop->imgheight   
        fallback=0
      end if    
    
    case 1
      if Font_Mono->img then
        function=Font_Mono->imgheight 
        fallback=0
      end if    
    
    case 2
      if Font_Menu->img then
        function=Font_Menu->imgheight        
        fallback=0
      end if
    
    end select
  
  if fallback then function=GetSysFontHeight
end function


function GetTextWidth(txt as string, mode as integer=0) as integer
   dim as integer fallback
   fallback=1
   
   select case mode  
    case 0
      if Font_Prop->img then
        function=Font_Prop->GetTextWidth(txt)
        fallback=0
      end if
      
    case 1
      if Font_Mono->img then 
        function=Font_Mono->GetTextWidth(txt,1)   
        fallback=0
      end if
      
    case 2
      if Font_Menu->img then 
        function=Font_Menu->GetTextWidth(txt)  
        fallback=0
      end if  
  end select

  if fallback then function=8*len(txt)
end function


sub DrawString(img as FB.Image ptr=0,xpos as integer,ypos as integer,txt as string,PenColor as ulong=&H000000,mode as integer=0)
   dim as integer fallback
   fallback=1
   select case mode  
    case 0
      if Font_Prop->img then
        Font_Prop->PenColor=PenColor
        Font_Prop->Print (img,xpos,ypos,txt)
        fallback=0
      end if
      
    case 1
      if Font_Mono->img then
        Font_Mono->PenColor=PenColor
        Font_Mono->Print (img,xpos,ypos,txt)
        fallback=0
      end if
      
    case 2
      if Font_Menu->img then
        Font_Menu->PenColor=PenColor
        Font_Menu->Print (img,xpos,ypos,txt)
        fallback=0
      end if
      
  end select 
  
  if fallback then 
    if img then 
      draw string img,(xpos,ypos),txt,Pencolor
    else
      draw string (xpos,ypos),txt,Pencolor
    end if
  end if
end sub


sub LoadProportionalFont(filename as string)
  Font_Prop->LoadFont(filename)
  SetsGUIMainSize
  
end sub


sub LoadFixedFont(filename as string)
  Font_Mono->LoadFont(filename)
  Font_Mono->monospaced= Font_Mono->CharSet(32).AdvanceX'Space als feste Breite verwenden
  SetsGUIMainSize 
end sub


sub LoadMenuFont(filename as string)
  Font_Menu->LoadFont(filename)
  SetsGUIMainSize
end sub


sub SetFixedWidth(w as integer)
  Font_Mono->monospaced= w
end sub


function GetFixedWidth as integer
  if Font_Mono->img then
    function=Font_Mono->monospaced
  else
    function=8
  end if
end function


sub SetsGUIMainSize
  'der Einfachheit wegen der arithmetischer Mittelwert von Hhe u. Breite
  'sGUIMainSize=int( ( GetFontHeight(0) + GetFontHeight(1) + GetFontHeight(2) + _ 
  '        GetTextWidth("M",0) +  GetTextWidth("M",1) + GetTextWidth("M",2) ) /6 )

  'Menu-Font hier nicht bercksichtigt
  'sGUIMainSize=int( ( GetFontHeight(0) + GetFontHeight(1) + _ 
  '        GetTextWidth("M",0) +  GetTextWidth("M",1) ) /4 ) + 2'Pixel fr Bevel' + 2 * sGUIMainGap
  
  'sGUIMainSize=int( ( GetFontHeight(0) + GetFontHeight(1) + GetFontHeight(2)) / 3)
  sGUIMainSize=GetFontHeight(0)
  if sGUIMainSize<14 then sGUIMainSize=14
end sub
