declare sub KillWindow (win as _sGUIWindow ptr)
declare sub KillGadget (gad as _Gadget ptr)
declare function GetUserImage (win as _sGUIWindow ptr=0) as FB.Image ptr

declare function DrawRequest (gad as _Gadget ptr) as integer
declare sub UpdateGadget(gad as _Gadget ptr)

declare sub ModifyActivation (thing as any ptr, activation as integer)
declare sub GadgetOn    (thing as any ptr)
declare sub GadgetSleep (thing as any ptr)
declare sub GadgetOff   (thing as any ptr)
declare sub RestoreActivation (thing as any ptr)

declare sub SetFocus (thing as any ptr)
declare function GetSelect (thing as any ptr) as integer
declare sub SetSelect (thing as any ptr,Selection as integer=1)

declare sub ShowWindow    (win as _sGUIWindow ptr)
declare sub HideWindow    (win as _sGUIWindow ptr)
declare sub DeleteWindow  (win as _sGUIWindow ptr)

declare sub GetGlobalPosition(thing as any ptr, byref posx as integer, byref posy as integer)

declare sub FakeGad (gad as _Gadget ptr)
declare sub FakeWin (win as _sGUIWindow ptr)

'******************************************************************************
'******************************************************************************
'******************************************************************************
type WinGadHeader extends node
  parent          as any ptr        'Zeiger auf ein Parent, dies kann beides sein: Window oder Gadget
  KindOfType      as integer        'Flag 0=Window,1=Gadget. Nur zur Sicherheit, mal sehen ob es gebraucht wird 
  PosX            as integer
  PosY            as integer
  Text            as string         'Text / Bezeichnung     
  xtd					    as _ExtendedData  'ersetzt jetzt das Ctrl()Array durch ne fette UNION 
  DrawBuffer      as _sGUIImage ptr 'sGUIImage, dorthinein wird das Gadget/Window gezeichnet
  Selection       as integer
  Activation      as integer
  Activation_Old  as integer
end type


'******************************************************************************
'******************************************************************************
'******************************************************************************
type Gadget extends WinGadHeader
  GadWidth    		as integer'Gadgetbreite
  GadHeight   		as integer'Gadgethhe    
  DoDraw      		as sub      (gad as Gadget ptr) 
  DoAction    		as function (refgad as Gadget ptr, action as integer=0) as integer 
  DoUpdate    		as sub      (gad as Gadget ptr)                                          
  GadgetWindow 		as _sGUIWindow ptr'ein Gadget darf ein Fenster enthalten   
  MouseHover      as integer
  KeyboardStream  as integer
  DeviceFlags     as uinteger  
  ReDraw          as integer
  oldFlags        as integer    
  declare constructor
  declare destructor    
end type


constructor Gadget
  KindOfType=1'its a Gadget
  DrawBuffer =ImageList->AppendNew(sGUIImageType)'leer, noch ohne Image!
  DoUpdate  =@FakeGad
  DoDraw    =@FakeGad
  ReDraw    =1
  DeviceFlags=DFLAG_LMB
end constructor


destructor Gadget 
end destructor


'******************************************************************************
'******************************************************************************
'******************************************************************************
type sGUIWindow extends WinGadHeader
  WinFlags        as uinteger
  WinWidth        as integer
  WinHeight       as integer
  ContentOffsetX  as integer
  ContentOffsetY  as integer
  ContentWidth    as integer
  ContentHeight   as integer
  Created         as double
  ActiveSince     as double  
  private:
  refgad         as _Gadget ptr 'Referenz Gadget, auf dem der Rest des Clickvorganges basiert
  actgad         as _Gadget ptr
  wheelgad       as _Gadget ptr 
  public:     
  UserGFXBuffer as _sGUIImage ptr'zweites Image, falls User in das Window zeichnen darf, derzeit nur bei Windows mglich 
  WinGadgetList as sGUIList ptr 'separate GadgetListe fr Fensterbedienelemente 
  GadgetList    as sGUIList ptr 'ChildGadgets als Content
  WindowList    as sGUIList ptr 'ChildWindows als Content   
  DoClearWindow as sub      (win as sGUIWindow ptr)  
  DoDrawWindow  as sub      (win as sGUIWindow ptr)
  DoUpdate      as sub      (win as sGUIWindow ptr)
  'NEU!! Replacement fr zusammengesetztes Gadget
  'ein GADGETMODE-Window
  DoAction      as sub  (win as sGUIWindow ptr)
  declare constructor ()
  declare destructor ()
  declare sub LMBGadgetCheck
  declare sub MMBGadgetCheck 
  declare sub RMBGadgetCheck
  declare sub WheelGadgetCheck
  declare sub KeyboardGadgetCheck
  
  declare sub HoveringOverGadgetCheck   
  declare function GetGadgetPointer as _Gadget ptr 
end type


constructor sGUIWindow
  KindOfType  = 0'its a Window
  WinGadgetList  = GadgetLists->AppendNew(sGUIListType)
  GadgetList  = GadgetLists->AppendNew(sGUIListType)
  WindowList  = WindowLists->AppendNew(sGUIListType)   
  DrawBuffer  = ImageList->AppendNew(sGUIImageType)'leer, noch ohne Image!
  UserGFXBuffer = ImageList->AppendNew(sGUIImageType)'leer, noch ohne Image!
  DoClearWindow=@FakeWin
  DoDrawWindow=@FakeWin
  DoUpdate=@FakeWin
  DoAction=@FakeWin
end constructor


destructor sGUIWindow
end destructor

'Methoden
sub sGUIWindow.LMBGadgetCheck
  dim as integer result,action
  action=0
    
  if LMB=HIT then
    refgad=0           
    actgad=0
    result=0
    refgad=GetGadgetPointer
    if (refgad<>0) andalso (refgad->DeviceFlags and DFLAG_LMB) then 
      action=GADGET_LMBHIT
      SetFocus(refgad)
    else
      SetFocus(0)
      refgad=0
    end if
  end if
  
  if refgad then
    if LMB=HOLD then
      actgad=GetGadgetPointer
      if actgad=refgad then action=GADGET_LMBHOLD else action=GADGET_LMBHOLDOFF    
    end if
    
    if LMB=RELEASE then
      actgad=GetGadgetPointer
      if actgad=refgad then 
        'SetFocus(refgad)
        action=GADGET_LMBRELEASE
      else 
        'SetFocus(0)
        action=GADGET_LMBRELEASEOFF      
      end if
    end if
    
    if LMB=RELEASED then refgad=0
 
  end if
  
  if action then result=refgad->DoAction(refgad,action)
  if (result>0) then GADGETMESSAGE=refgad
end sub


sub sGUIWindow.WheelGadgetCheck
  dim as integer result
  wheelgad=GetGadgetPointer
  if (wheelgad<>0) andalso (wheelgad->DeviceFlags and DFLAG_WHEEL) then
    result=wheelgad->DoAction(wheelgad,GADGET_WHEELMOVE)
    if (result>0) then 
      SetFocus(wheelgad)
      GADGETMESSAGE=wheelgad
    end if
  end if  
end sub


sub sGUIWindow.KeyboardGadgetCheck
  dim as Gadget ptr childgad
  childgad=GadgetList->GetFirst  
  if childgad then
    do
      if (childgad->DeviceFlags and DFLAG_KEYBOARD) then childgad->DoAction(childgad,GADGET_KEYBOARD) 
      childgad=cast(Gadget ptr,childgad->next_node)
    loop until childgad=0    
  end if 
end sub


sub sGUIWindow.HoveringOverGadgetCheck 
  dim as Gadget ptr childgad, hovergad

  hovergad=GetGadgetPointer  
 'Loop durch die WinGadgetList....  
  childgad=WinGadgetList->GetFirst  
  if childgad then
    do
      if hovergad then
        if hovergad=childgad then 
          childgad->DoAction(childgad,GADGET_MOUSEHOVER) 
        else 
          childgad->DoAction(childgad,GADGET_MOUSENEXT)
        end if
      else
        childgad->DoAction(childgad,GADGET_MOUSENEXT)
      end if
      'nchstes Gadget
      childgad=cast(Gadget ptr,childgad->next_node)
    loop until childgad=0
  end if
  '... und GadgetList dieses Fensters
  childgad=GadgetList->GetFirst  
  if childgad then
    do
      if hovergad then
        if hovergad=childgad then
          childgad->DoAction(childgad,GADGET_MOUSEHOVER)
        else
          childgad->DoAction(childgad,GADGET_MOUSENEXT)
        end if  
      else
        childgad->DoAction(childgad,GADGET_MOUSENEXT)
      end if
      'nchstes Gadget
      childgad=cast(Gadget ptr,childgad->next_node)
    loop until childgad=0    
  end if   
end sub


function sGUIWindow.GetGadgetPointer as _Gadget ptr
  dim as _Gadget ptr gad,hover
  dim as integer guix,guiy,gadx,gady
  dim as sGUIList ptr sGUIList
  function=0  

  GetGlobalPosition(@this,guix,guiy)
  
  sGUIList=WinGadgetList
  if sGUIList->GetFirst=0 then sGUIList=GadgetList
  gad=sGUIList->GetFirst
  if gad then
    do
      gadx=guix + gad->posx
      gady=guiy + gad->posy
      
      hover=0
      MOUSEOVERGADGET=0
      if gad->Activation=1 then'nur bei Activation=1 gibt es eine Antwort
        if  (MOUSEX>=gadx) and (MOUSEX<gadx + gad->GadWidth) and (MOUSEY>=gady) and (MOUSEY<gady + gad->GadHeight) then
          'MaskenHandling erst einmal herausgenommen!!!!
          'wenn eine Maske existiert, dann ausschliessen ob die Maus-Position
          'nicht ber einem Pixel mit der Farbe RGB(255,0,255) ist!
          'if (gad->Mask>0) then
          '  col=point(MOUSEX-gadx,MOUSEY-gady,gad->Mask->img)
          '  if col<>&HFFFF00FF then hover=gad
          'else'ohne Maske
            hover=gad
          'end if
        end if
      end if
      if hover then 
        function=gad
        MOUSEOVERGADGET=hover
      end if
      'nchstes gad   
      gad=cast(Gadget ptr,gad->next_node)
      
      'und sGUIListenwechselhandling
      select case sGUIList
        case WinGadgetList
          if gad=0 then 
            sGUIList=GadgetList'<--!!!
            gad=sGUIList->GetFirst
          end if
        'case..... bei mehr als 2 sGUIListen
      end select      
      
    loop until (gad=0) or (hover>0)
  end if
  
end function


'******************************************************************************
'******************************************************************************
'******************************************************************************

sub KillWindow (win as _sGUIWindow ptr)
  dim as Gadget ptr childgad
  dim as sGUIWindow ptr  childwin
  dim as sGUIList ptr owner
  
  'falls dieses Window selbst Childwindows hat
  'KillWindow fr jedes der Fenster in der WindowList rekursiv aufrufen
  childwin=win->WindowList->GetFirst
  if childwin then
    do
      KillWindow(childwin)
      childwin=cast(sGUIWindow ptr,win->WindowList->GetFirst)'bei jedem Durchgang wird immer der erste Eintrag der WindowList wird entfernt
    loop until childwin=0
  end if
  'Die nun zwar leere WindowList selbst muss aber auch aus einer bergeordneten sGUIListe entfernt werden
  'hier wre der owner eigentlich bekannt, eine WindowList eines Fensters wird immer in der globalen sGUIListe "WindowLists" erzeugt(sGUI.bas)
  'WindowLists->DeleteNode(win->WindowList)' wre also der einfachste Weg
  'wir gehen aber ber den owner im geerbten node
  owner=win->WindowList->owner
  owner->DeleteNode(win->WindowList)
  
  'Grafikpuffer des Windows aus entsprechender sGUIListe entfernen
  if win->DrawBuffer then
    owner=win->DrawBuffer->owner
    owner->DeleteNode(win->DrawBuffer)
  end if  
  
  'UserGFXpuffer des Windows aus entsprechender sGUIListe entfernen
  if win->UserGFXBuffer then
    owner=win->UserGFXBuffer->owner
    owner->DeleteNode(win->UserGFXBuffer)
  end if  
 
  'zum Schlu Fenster selbst aus entsprechender sGUIListe entfernen
  owner=win->owner
  owner->DeleteNode(win)
end sub


sub KillGadget (gad as _Gadget ptr)
  dim as sGUIList ptr owner
  'zuerst alle Objekte lschen die zwar von diesem Gadget benutzt, jedoch in einer entsprechenden sGUIListe verwaltet werden
  
  'hat dieses Gadget ein Fenster?
  if gad->GadgetWindow then KillWindow(gad->GadgetWindow)' eigene Lschroutine, siehe hier drber :)
 
  'Grafikpuffer des Gadgets aus entsprechender sGUIListe entfernen
  if gad->DrawBuffer then
    owner=gad->DrawBuffer->owner
    owner->DeleteNode(gad->DrawBuffer)
  end if
    
  'weitere/andere Elemente???? hier einfgen
  '.....
  
  'zum Schlu Gadget selbst aus entsprechender sGUIListe entfernen
  owner=gad->owner
  owner->DeleteNode(gad)
end sub


function GetUserImage (win as _sGUIWindow ptr=0) as FB.Image ptr
  function=0 
  if (win<>0) and (win<>RootWindow) then
    if (win->WinFlags and WFLAG_IMAGE) then
      function=win->DrawBuffer->img
    else
      if win->UserGFXBuffer->img=0 then win->UserGFXBuffer->img=imagecreate(win->ContentWidth,win->ContentHeight,Colors.Cleaning)  
      function=win->UserGFXBuffer->img
    end if
  end if
end function


'******************************************************************************
'******************************************************************************
'******************************************************************************
function DrawRequest (gad as _Gadget ptr) as integer
  function=gad->ReDraw
  gad->ReDraw=0
end function


sub UpdateGadget(gad as _Gadget ptr)
  dim as integer flgs  
  'rechte niedrige Bits ....0000HSAA
  flgs=(gad->MouseHover shl 3) or (gad->Selection shl 2) or (gad->Activation)
  '
  if flgs<>gad->oldFlags then
    gad->ReDraw=1
    gad->oldFlags=flgs
  end if
  gad->DoUpdate(gad)'falls vorhanden, zustzliche gadgetspezifische Updates 
end sub


'********
sub ModifyActivation (thing as any ptr, activation as integer)
  dim as WinGadHeader ptr wingad  
  dim as Gadget ptr gad
  dim as sGUIWindow ptr win,childwin
  dim as sGUIList ptr lst  
  dim as ulong filter
  
  select case cast(WinGadHeader ptr,thing)->KindOfType 
     case 1'Gadget
      gad   =cast(Gadget ptr,thing) 
      gad->Activation_Old=gad->Activation'alten Zustand merken
      gad->Activation=activation   
    
    case 0'Window
      win   =cast(sGUIWindow ptr,thing)
      filter=WFLAG_GADGETMODE or WFLAG_GADGETMODE_LITE
      
      if (win->WinFlags and filter) then'... und wenn im Fenster eines der GADGETMODE Flags gesetzt ist       
        'beide GadgetListen dieses Fensters abarbeiten
        lst=win->GadgetList
        do
          gad=lst->GetFirst
          if gad then
            do
              gad->Activation=activation
              gad->ReDraw=1'neuzeichnen
              gad=cast(Gadget ptr,gad->next_node)'nchstes Gadget holen
            loop until gad=0     
          end if       
          lst=iif(lst=win->GadgetList,win->WinGadgetList,0)'Wechsel zur WinGadgetList des Fensters, bzw mit 0 Abbruchbedingung fr ussere DO...LOOP
        loop until lst=0
        
        'rekursiver Aufruf um alle Fenster dieses "Zweiges" zu durchlaufen
        childwin=win->WindowList->GetFirst
        if childwin then
          do               
            ModifyActivation (childwin, activation)'rekursiver Aufruf
            childwin=cast(sGUIWindow ptr,childwin->next_node)
          loop until childwin=0     
        end if        

      end if   
  end select
end sub


sub GadgetOn (thing as any ptr)
  ModifyActivation(thing,ACTIVATION_ON)
end sub


sub GadgetSleep (thing as any ptr)
  ModifyActivation(thing,ACTIVATION_SLEEP)
end sub


sub GadgetOff (thing as any ptr)
  ModifyActivation(thing,ACTIVATION_OFF)
end sub


sub RestoreActivation (thing as any ptr)
  dim as Gadget ptr gad=cast(Gadget ptr,thing)    
  if gad->KindOfType=1 then
    select case gad->Activation_Old
      case ACTIVATION_OFF
        GadgetOff (gad)
      case ACTIVATION_OFF
        GadgetOn (gad)
      case ACTIVATION_SLEEP
        GadgetSleep (gad)
    end select
  end if
end sub


sub SetFocus (thing as any ptr)
  'alten Focus "entlassen", aber nur, wenn es ein Gadget ist
  if (FOCUSGADGET>0) andalso (FOCUSGADGET<>thing) then 
    FOCUSWINDOW=0
    if cast(WinGadHeader ptr,FOCUSGADGET)->KindOfType=1 then FOCUSGADGET->DoAction(FOCUSGADGET,GADGET_FOCUSOFF)
  end if
  
  if thing then
    if  cast(WinGadHeader ptr,thing)->KindOfType=1 then'wenn thing ein Gadget
      FOCUSGADGET=thing
      FOCUSWINDOW=FOCUSGADGET->parent
    else'falls thing ein Window, das ist zwar mglich, wird aber nicht weiter behandelt
      FOCUSGADGET=thing
      FOCUSWINDOW=thing
    end if
  else
    FOCUSGADGET=0
    FOCUSWINDOW=0   
  end if
end sub


'********
function GetSelect (thing as any ptr) as integer  
  if cast(WinGadHeader ptr,thing)->KindOfType=1 then'wenns ein Gadget ist
      function=cast(Gadget ptr,thing)->Selection
  else
    function=-1
  end if
end function


sub SetSelect (thing as any ptr,Selection as integer=1)
  if cast(WinGadHeader ptr,thing)->KindOfType=1 then'wenns ein Gadget ist
    cast(Gadget ptr,thing)->Selection=Selection  
  end if
end sub


'******************************************************************************
'*****************************************************************************
'*****************************************************************************
sub ShowWindow (win as _sGUIWindow ptr)
  dim as WinGadHeader ptr parent
  dim as integer result
  win->ActiveSince=timer
  win->Activation=1
end sub


sub HideWindow    (win as _sGUIWindow ptr)
  win->Activation=0
end sub


sub DeleteWindow  (win as _sGUIWindow ptr)
  win->Activation=0
  KillWindow (win)
end sub


sub GetGlobalPosition(thing as any ptr, byref PosX as integer, byref PosY as integer)
  dim as _WinGadHeader ptr wgheader
  dim as any ptr parent
  wgheader=cast(_WinGadHeader ptr, thing)
  PosX +=wgheader->PosX
  PosY +=wgheader->PosY  
  if wgheader->KindOfType=0 then'bei einem Fenster, ContentOffsets hinzufgen
    PosX +=cast(sGUIWindow ptr, wgheader)->ContentOffsetX
    PosY +=cast(sGUIWindow ptr, wgheader)->ContentOffsetY
  end if
  parent=wgheader->parent  
  if parent then GetGlobalPosition(parent,PosX,PosY)
end sub


'******************************************************************************
'*****************************************************************************
'*****************************************************************************
sub FakeGad (gad as _Gadget ptr)
end sub


sub FakeWin (win as _sGUIWindow ptr)
end sub
