#include once "Gadget_CloseButton.bas"
#include once "Gadget_DragBar.bas"
#include once "Gadget_Label.bas"
namespace sGUI

declare function AddWindow (parent as any ptr,PosX as integer,PosY as integer,WinWidth as integer,WinHeight as integer,Text as string="", WinFlags as integer=0, WinMenu as sGUIList ptr=0) as sGUIWindow ptr
declare function AddRootWindow as sGUIWindow ptr
declare function AddSimpleWarnWindow (PosX as integer,PosY as integer,Text as string) as sGUIWindow ptr

declare sub ClearWin (win as sGUIWindow ptr)
declare sub DrawWin (win as sGUIWindow ptr)

declare sub ValidateFlags(win as sGUIWindow ptr)
declare function GetNumFlags(value as ulong=0) as ulong

declare sub MoveWindowOnTop (win as _sGUIWindow ptr)


function AddWindow (parent as any ptr,PosX as integer,PosY as integer,WinWidth as integer,WinHeight as integer,Text as string="", WinFlags as integer=0, WinMenu as sGUIList ptr=0) as sGUIWindow ptr
  function=0
  dim as integer DragBarWidth,offsetx,radius
  
  if parent=0 then parent=RootWindow
  dim as sGUIWindow ptr win
  dim as Gadget ptr gad

  win=cast(sGUIWindow ptr,parent)->WindowList->AppendNew(sGUIWindowType)

  if win then
    win->Created=timer
    win->parent=parent
    win->Selection=0
    win->Activation=0
    win->PosX=PosX
    win->PosY=PosY
    win->Text=Text
    
    win->WinFlags=WinFlags
    
    BarHeight=GetFontHeight + 2*sGUIMainGap
    MenuBarHeight=GetFontHeight(2) + 2*sGUIMainGap    
   
    'Contentbereich ist immer so gro wie bergebene Parameter
    'und befindet sich links oben, kein Versatz
    win->ContentWidth=WinWidth
    win->ContentHeight=WinHeight    
    win->ContentOffsetX=0
    win->ContentOffsetY=0
    'Fenstergre entspricht auch erstmal den bergebenen Parametern
    win->WinWidth=WinWidth
    win->WinHeight=WinHeight
    
    
    ValidateFlags(win)'bevor Flags zur Konfiguration herangezogen werden, validieren
'WFLAG_FRAMED    
    if (win->WinFlags and WFLAG_FRAMED) then
      'Fenster um zwei Randdicken vergrern
      win->WinWidth +=2*sGUIMainGap 
      win->WinHeight +=2*sGUIMainGap       
      'Content um eine Randbreite nach unten und rechts verschieben
      win->ContentOffsetX +=sGUIMainGap
      win->ContentOffsetY +=sGUIMainGap     
    end if

'WFLAG_TITLEBAR    
    if (win->WinFlags and WFLAG_TITLEBAR) then
      if win->WinHeight > win->ContentHeight then'falls ringsherum Rand schon hinzugefgt,dann
        win->WinHeight -=sGUIMainGap'oberen Rand wieder entfernen 
        win->ContentOffsetY -=sGUIMainGap'Content wieder nach oben schieben 
      end if
      win->WinHeight +=BarHeight'Hhe um Titelbalkendicke erhhen
      win->ContentOffsetY +=BarHeight'Content um eine Titelbalkendicke nach unten verschieben
    end if

'WFLAG_MENUBAR    
    if (win->WinFlags and WFLAG_MENUBAR) then
      win->WinHeight += MenuBarHeight'Fensterhhe vergrert sich um eine Bar-Hhe  
      win->ContentOffsetY += MenuBarHeight'Content um Bar-Hhe nach unten verschieben     
    end if  
    
'WFLAG_IMAGE    
    if (win->WinFlags and WFLAG_IMAGE) then
    
    end if

'bis hierher mssen alle Grenvernderungen erledigt sein!
'***********************************************************

'WFLAG_CLOSEABLE / WFLAG_DRAGABLE
    if (win->WinFlags and WFLAG_TITLEBAR) then
      'Koordinaten der SystemGadgets sind immer relativ zur Position des ContentOffsets(!)
      'Darum sieht die Verortung der SystemGadgets etwas verwirrend aus
      'Urschlich ist die Funktion GetGlobalPosition.
      
      if ((win->WinFlags and WFLAG_CLOSEABLE)<>0) or ((win->WinFlags and WFLAG_DRAGABLE)<>0) then
        DragBarWidth=win->WinWidth'zuerst nehmen wir immer mal an, das Dragbar "fllt" die gesamte Fensterbreite aus     
        
        if win->WinWidth > win->ContentWidth then offsetx=-sGUIMainGap else offsetx=0
      
        if (win->WinFlags and WFLAG_CLOSEABLE) then
          'win->xtd.wnd.CloseButton=AddCloseButton(win,offsetx,-win->ContentOffsetY)
          'GadgetOn(win->xtd.wnd.CloseButton)
          gad=AddCloseButton(win,offsetx,-win->ContentOffsetY)
          GadgetOn(gad)          
          offsetx       +=BarHeight   
          DragBarWidth  -=BarHeight        
        end if      
      
        if (win->WinFlags and WFLAG_DRAGABLE) then        
          'win->xtd.wnd.DragBar=AddDragBar(win,offsetx,-win->ContentOffsetY,DragBarWidth)
          'GadgetOn(win->xtd.wnd.DragBar)
          gad=AddDragBar(win,offsetx,-win->ContentOffsetY,DragBarWidth)
          GadgetOn(gad)          
        end if      
      end if
    end if
     
    'im Falle eines Backdrop Fensters verschieben wir dieses an den Anfang
    if (win->WinFlags and WFLAG_BACKDROP) then cast(sGUIWindow ptr,parent)->WindowList->MoveToFirst(win)
    
    win->DrawBuffer->img=imagecreate(win->WinWidth,win->WinHeight)
    
    win->DoClearWindow =@ClearWin
    win->DoDrawWindow =@DrawWin
    
    'das erste erzeugte Window erzeugt auch gleichzeitig die gfx fr den Schatten
    'einfach nachschauen ob schon ein Schattenimage existiert, fertig
    if ShadowLeft=0 then CreateShadowGFX
     
    function=win
  end if 
end function


function AddRootWindow as sGUIWindow ptr
  function=0
	dim as sGUIWindow ptr win

  'alternative Erzeugung um das Rootwindow zum Bestandteil der WindowLists zu machen
  '!!! im MainDestructor das separate Lschen des RootWindows auskommentieren
  'das sollte nun ber das Lschen der WindowsLists passieren
  dim as sGUIList ptr winlist
  winlist  = WindowLists->AppendNew(sGUIListType)'eine Fensterliste an
  if winlist then
    win=winlist->AppendNew(sGUIWindowType)
    if win then
      win->Created=timer
      win->PosX=0
      win->PosY=0
      win->WinWidth=ScrnWidth
      win->WinHeight=ScrnHeight
      win->ContentOffsetX=0
      win->ContentOffsetY=0
      win->ContentWidth=ScrnWidth
      win->ContentHeight=ScrnHeight
      win->Activation=1      
      function=win    
    end if
  end if
end function


function AddSimpleWarnWindow (PosX as integer,PosY as integer,Text as string) as sGUIWindow ptr
  function=0  
  dim as integer winWidth,winHeight
  dim as sGUIWindow ptr win
  dim as Gadget ptr lbl

  winWidth=GetTextWidth(Text) + 3*GetFontHeight
  winHeight=3*GetFontHeight
  win=AddWindow(0,PosX,PosY,winWidth,winHeight,,WFLAG_FRAMED or WFLAG_HIDECLICKEDINSIDE or WFLAG_HIDECLICKEDOUTSIDE or WFLAG_WARN)
  if win then
    lbl=AddLabel(win,GetFontHeight,GetFontHeight,Text)
    GadgetOn(lbl)
    function=win
  end if
end function


sub ClearWin (win as sGUIWindow ptr)
  if win=RootWindow then
    ClearBox win->DrawBuffer->img,0,0,win->WinWidth,win->WinHeight    
  else
    if not (win->WinFlags and WFLAG_IMAGE) then
      'wenn das Elternteil ein Gadget ist, was das Fenster zu einem GadgetWindow macht,
      'dann Hintergrund mit Transparenz auffllen
      if cast(sGUIWindow ptr,win->parent)->KindOfType=1 then
        ClearBox win->DrawBuffer->img,0,0,win->WinWidth,win->WinHeight,&HFF00FF
      else
        ClearBox win->DrawBuffer->img,0,0,win->WinWidth,win->WinHeight,Colors.BackGround
      end if
      if win->UserGFXBuffer->img then put win->DrawBuffer->img,(win->ContentOffsetX,win->ContentOffsetY),win->UserGFXBuffer->img,pset   
    end if
  end if
end sub


sub DrawWin (win as sGUIWindow ptr)
  dim as integer TextPosX =int((win->WinWidth-GetTextWidth(win->Text))/2) 
  dim as integer TextPosY =sGUIMainGap 
  dim as integer displayedSelection=win->Selection  
  
  displayedSelection=win->Selection 
  if (win->WinFlags and WFLAG_APPEARSSELECTED) then displayedSelection=1
  if (win->WinFlags and WFLAG_APPEARSUNSELECTED) then displayedSelection=0   
  
  if win->Activation then

    if (win->WinFlags and WFLAG_FRAMED) then
      if ((win->WinFlags and (WFLAG_APPEARSUNSELECTED or WFLAG_APPEARSSELECTED))=0) then
        WinFrame win->DrawBuffer->img,0,0,win->WinWidth,win->WinHeight,win->Selection             
      elseif (win->WinFlags and WFLAG_APPEARSSELECTED) then
        WinFrame win->DrawBuffer->img,0,0,win->WinWidth,win->WinHeight,1		
      elseif (win->WinFlags and WFLAG_APPEARSUNSELECTED) then
        WinFrame win->DrawBuffer->img,0,0,win->WinWidth,win->WinHeight,0       
      end if   
    end if
    
    if (win->WinFlags and WFLAG_TITLEBAR) then
  
      if displayedSelection then
        'StdFilledBox win->DrawBuffer->img,0,0,win->WinWidth,BarHeight,Colors.WinFrame
        StdFilledBoxRounded win->DrawBuffer->img,0,0,win->WinWidth,BarHeight,Colors.WinFrame,,,,3
        drawstring (win->DrawBuffer->img, TextPosX, TextPosY, win->Text,Colors.WinText)		          
      else
        'StdFilledBox win->DrawBuffer->img,0,0,win->WinWidth,BarHeight,Colors.WinFrameUnselected
        StdFilledBoxRounded win->DrawBuffer->img,0,0,win->WinWidth,BarHeight,Colors.WinFrameUnselected,,,,3
        drawstring (win->DrawBuffer->img, TextPosX, TextPosY, win->Text,Colors.WinTextUnselected)		        
      end if      

    end if

    if (win->WinFlags and WFLAG_MENUBAR) then
      ClearBox win->DrawBuffer->img,win->ContentOffsetX,win->ContentOffsetY-MenuBarHeight,win->ContentWidth,MenuBarHeight,Colors.MNG_BackGround
    end if
    
    if (win->WinFlags and WFLAG_IMAGE) then
    
    end if
    
  end if
end sub


'******************************************************************************
'******************************************************************************
'******************************************************************************
sub ValidateFlags(win as sGUIWindow ptr)
  
  dim as uinteger filter,wintype,ButtonMenuFlags,GFXComponents,GFXComponents2,ImageFlag,StackFlags
  dim as uinteger SelectionFlags,AppearanceFlags,NoShadowFlag,ragpicker
  
  filter= WFLAG_WINDOWMENU or WFLAG_DRAGABLE or WFLAG_CLOSEABLE or WFLAG_MINIMISABLE
  ButtonMenuFlags=(win->WinFlags and filter)  
  
  if win->Text<>""                        then GFXComponents = GFXComponents or WFLAG_TITLEBAR
  if (win->WinFlags and WFLAG_WINDOWMENU) then GFXComponents = GFXComponents or WFLAG_MENUBAR
  if (win->WinFlags and WFLAG_DRAGABLE)   then GFXComponents = GFXComponents or WFLAG_TITLEBAR
  if (win->WinFlags and WFLAG_CLOSEABLE)  then GFXComponents = GFXComponents or WFLAG_TITLEBAR
  'if (win->WinFlags and WFLAG_MINIMISABLE)   then GFXComponents = GFXComponents or WFLAG_TITLEBAR
  
  'Durch Text,Buttons und Men sind bestimmte GFXElemente "zwangseingeschaltet" worden
  'Falls jedoch noch nicht angeschaltete GFXElemente "gewnscht" waren, jetzt verknpfen:
  'Schatten ist immer "switchable" ;)
  filter=WFLAG_FRAMED or WFLAG_TITLEBAR or WFLAG_MENUBAR
  GFXComponents = GFXComponents or (win->WinFlags and filter) 
 
  'overruler, das WFLAG_IMAGE schliesst alle GFXElemente und Buttons und Men von oben aus
  if (win->WinFlags and WFLAG_IMAGE) then 
    wintype=WFLAG_IMAGE
    GFXComponents=0
    ButtonMenuFlags=0  
  end if
  
  'Stack Handle
  filter= WFLAG_STACKABLE or WFLAG_BACKDROP or WFLAG_ALWAYSONTOP or WFLAG_WARN or WFLAG_WARNIGNORE
  StackFlags=(win->WinFlags and filter)
  'falls mehrere ODER kein StackFlag gesetzt wurde gilt WFLAG_STACKABLE als Vorgabe. Achtung! kann aber im Falle von GADGETWINDOW durchaus 0 sein, siehe unten
  if GetNumFlags(StackFlags)<>1 then StackFlags=WFLAG_STACKABLE
  'falls es ein WARN/WARNIGNORE ist, muss das Fenster auf RootWindowEbene erzeugt worden sein. wenn nicht, gilt auch dort zumindest WFLAG_STACKABLE
  if (StackFlags=WFLAG_WARN) and (win->Parent<>RootWindow) then StackFlags=WFLAG_STACKABLE
  if (StackFlags=WFLAG_WARNIGNORE) and (win->Parent<>RootWindow) then StackFlags=WFLAG_STACKABLE
  
  'Selection
  filter= WFLAG_PARENTSELECT or WFLAG_NOSELECT      
  SelectionFlags=(win->WinFlags and filter)
  'falls mehrere win->WinFlags gesetzt wurden gilt 0 (kein gesetztes Flag) als Vorgabe      
  if GetNumFlags(SelectionFlags)>1 then SelectionFlags=0     

  'Appearance
  filter= WFLAG_APPEARSSELECTED or WFLAG_APPEARSUNSELECTED
  AppearanceFlags=(win->WinFlags and filter)
  'falls mehrere win->WinFlags gesetzt wurden gilt 0 (kein gesetztes Flag) als Vorgabe      
  if GetNumFlags(AppearanceFlags)>1 then AppearanceFlags=0
  
  'Schatten
  filter=WFLAG_NOSHADOW
  NoShadowFlag=(win->WinFlags and filter)
  
  'GadgetMode OverRuler, ausgenommen die _LITE Variante
  if (win->WinFlags and WFLAG_GADGETMODE) then
    wintype=0
    GFXComponents=0
    StackFlags=0
    SelectionFlags=0 
    AppearanceFlags=WFLAG_APPEARSUNSELECTED
    NoShadowFlag=WFLAG_NOSHADOW
  end if 
  
  'FlagSammler
  'bernahme der restlichen Flags aus dem "Original" 
  'derzeitig gibt es 23 Flags  
  filter=WFLAG_HIDECLICKEDOUTSIDE or WFLAG_HIDECLICKEDINSIDE or WFLAG_DELETEONCLOSE  or WFLAG_GADGETMODE or WFLAG_GADGETMODE_LITE
  ragpicker=(win->WinFlags and filter)
  
  'zum Schluss wieder alles zusammenschrauben und das Original "berschreiben":
  win->WinFlags=wintype or ButtonMenuFlags or GFXComponents or StackFlags or AppearanceFlags or SelectionFlags or NoShadowFlag or ragpicker
end sub


function GetNumFlags(value as ulong=0) as ulong
  dim as ulong numsetbits,processedBit'kann auch integer sein
  numsetbits=0
  processedBit=32
  do
    processedBit -=1
    'if bit(value,processedBit) then numsetbits +=1'macht was es soll    
    'if (value and (1 shl processedBit)) then numsetbits +=1'macht auch was es soll    
    numsetbits +=iif( (value and (1 shl processedBit))<>0, 1, 0)
  loop until processedBit=0
  function=numsetbits
end function


'******************************************************************************
'******************************************************************************
'******************************************************************************
sub MoveWindowOnTop (win as _sGUIWindow ptr)
  dim as _sGUIWindow ptr parentwin
  parentwin=cast(sGUIWindow ptr, win->parent)
  'Memberroutine der sGUIList aufrufen:
  '->MoveToLast(ans Ende der Liste) bedeutet (als Fensterstapel interpretiert) ganz nach oben
  cast(sGUIList ptr,parentwin->WindowList)->MoveToLast(win)
end sub

end namespace


